var rtcClient = (function () {
	'use strict';

	const sdkVersion="4.1";function isFirefox(){return null!==window.navigator.userAgent.match("Firefox")}function isChrome(){return null!==window.navigator.userAgent.match("Chrome")}function isSafari(){return /^((?!chrome|android).)*safari/i.test(window.navigator.userAgent)}function isEdge(){return null!==window.navigator.userAgent.match(/Edge\/(\d+).(\d+)$/)}function createUuid(){return "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx".replace(/[xy]/g,function(e){var t=16*Math.random()|0;return ("x"===e?t:3&t|8).toString(16)})}function sysInfo(){var e=Object.create({});e.sdk={version:sdkVersion,type:"JavaScript"};var t=navigator.userAgent,i=/Chrome\/([0-9\.]+)/.exec(t);i?e.runtime={name:"Chrome",version:i[1]}:(i=/Firefox\/([0-9\.]+)/.exec(t))?e.runtime={name:"Firefox",version:i[1]}:(i=/Edge\/([0-9\.]+)/.exec(t))?e.runtime={name:"Edge",version:i[1]}:isSafari()?(i=/Version\/([0-9\.]+) Safari/.exec(t),e.runtime={name:"Safari"},e.runtime.version=i?i[1]:"Unknown"):e.runtime={name:"Unknown",version:"Unknown"};return (i=/Windows NT ([0-9\.]+)/.exec(t))?e.os={name:"Windows NT",version:i[1]}:(i=/Intel Mac OS X ([0-9_\.]+)/.exec(t))?e.os={name:"Mac OS X",version:i[1].replace(/_/g,".")}:(i=/iPhone OS ([0-9_\.]+)/.exec(t))?e.os={name:"iPhone OS",version:i[1].replace(/_/g,".")}:(i=/X11; Linux/.exec(t))?e.os={name:"Linux",version:"Unknown"}:(i=/Android( ([0-9\.]+))?/.exec(t))?e.os={name:"Android",version:i[1]||"Unknown"}:(i=/CrOS/.exec(t))?e.os={name:"Chrome OS",version:"Unknown"}:e.os={name:"Unknown",version:"Unknown"},e.capabilities={continualIceGathering:!1,unifiedPlan:!1,streamRemovable:"Firefox"!==e.runtime.name},e}var Logger=function(){function t(){}var i={DEBUG:0,TRACE:1,INFO:2,WARNING:3,ERROR:4,NONE:5};i.log=window.console.log.bind(window.console);function r(e){return ("function"==typeof window.console[e]?window.console[e]:window.console.log).bind(window.console)}function e(e){i.debug=e<=0?r("log"):t,i.trace=e<=1?r("trace"):t,i.info=e<=2?r("info"):t,i.warning=e<=3?r("warn"):t,i.error=e<=4?r("error"):t;}return e(0),i.setLogLevel=e,i}();const AudioSourceInfo={MIC:"mic",SCREENCAST:"screen-cast",FILE:"file",MIXED:"mixed"},VideoSourceInfo={CAMERA:"camera",SCREENCAST:"screen-cast",FILE:"file",MIXED:"mixed"},TrackKind={AUDIO:"audio",VIDEO:"video",AUDIO_AND_VIDEO:"av"};class Resolution{constructor(e,t){this.width=e,this.height=t;}}class AudioTrackConstraints{constructor(t){if(!Object.values(AudioSourceInfo).some(e=>e===t))throw new TypeError("Invalid source.");this.source=t,this.deviceId=void 0;}}class VideoTrackConstraints{constructor(t){if(!Object.values(VideoSourceInfo).some(e=>e===t))throw new TypeError("Invalid source.");this.source=t,this.deviceId=void 0,this.resolution=void 0,this.frameRate=void 0;}}class StreamConstraints{constructor(e=!1,t=!1){this.audio=e,this.video=t;}}function isVideoConstrainsForScreenCast(e){return "object"==typeof e.video&&e.video.source===VideoSourceInfo.SCREENCAST}class MediaStreamFactory{static createMediaStream(e){if("object"!=typeof e||!e.audio&&!e.video)return Promise.reject(new TypeError("Invalid constrains"));if(!isVideoConstrainsForScreenCast(e)&&"object"==typeof e.audio&&e.audio.source===AudioSourceInfo.SCREENCAST)return Promise.reject(new TypeError("Cannot share screen without video."));if(isVideoConstrainsForScreenCast(e)&&"object"==typeof e.audio&&e.audio.source!==AudioSourceInfo.SCREENCAST)return Promise.reject(new TypeError("Cannot capture video from screen cast while capture audio from other source."));if(!e.audio&&!e.video)return Promise.reject(new TypeError("At least one of audio and video must be requested."));const t=Object.create({});return "object"==typeof e.audio&&e.audio.source===AudioSourceInfo.MIC?(t.audio=Object.create({}),isEdge()?t.audio.deviceId=e.audio.deviceId:t.audio.deviceId={exact:e.audio.deviceId}):e.audio.source===AudioSourceInfo.SCREENCAST?t.audio=!0:t.audio=e.audio,"object"==typeof e.video?(t.video=Object.create({}),"number"==typeof e.video.frameRate&&(t.video.frameRate=e.video.frameRate),e.video.resolution&&e.video.resolution.width&&e.video.resolution.height&&(e.video.source===VideoSourceInfo.SCREENCAST?(t.video.width=e.video.resolution.width,t.video.height=e.video.resolution.height):(t.video.width=Object.create({}),t.video.width.exact=e.video.resolution.width,t.video.height=Object.create({}),t.video.height.exact=e.video.resolution.height)),"string"==typeof e.video.deviceId&&(t.video.deviceId={exact:e.video.deviceId}),isFirefox()&&e.video.source===VideoSourceInfo.SCREENCAST&&(t.video.mediaSource="screen")):t.video=e.video,isVideoConstrainsForScreenCast(e)?navigator.mediaDevices&&navigator.mediaDevices.getDisplayMedia?navigator.mediaDevices.getDisplayMedia(t).then(e=>e).catch(e=>Promise.reject({code:1,info:e})):Promise.reject({code:1,info:"Browser does not support"}):navigator.mediaDevices.getUserMedia(t)}}const EventDispatcher=function(){const i={dispatcher:{}};i.dispatcher.eventListeners={},this.addEventListener=function(e,t){void 0===i.dispatcher.eventListeners[e]&&(i.dispatcher.eventListeners[e]=[]),i.dispatcher.eventListeners[e].push(t);},this.removeEventListener=function(e,t){!i.dispatcher.eventListeners[e]||-1!==(t=i.dispatcher.eventListeners[e].indexOf(t))&&i.dispatcher.eventListeners[e].splice(t,1);},this.clearEventListener=function(e){i.dispatcher.eventListeners[e]=[];},this.dispatchEvent=function(t){i.dispatcher.eventListeners[t.type]&&i.dispatcher.eventListeners[t.type].map(function(e){e(t);});};};class OmsEvent{constructor(e){this.type=e;}}class MessageEvent extends OmsEvent{constructor(e,t){super(e),this.origin=t.origin,this.message=t.message,this.to=t.to;}}class ErrorEvent extends OmsEvent{constructor(e,t){super(e),this.error=t.error;}}class MuteEvent extends OmsEvent{constructor(e,t){super(e),this.kind=t.kind;}}class roomStatusEvent extends OmsEvent{constructor(e,t){super(e),this.roomStatus=t.data;}}class exitRoomEvent extends OmsEvent{constructor(e,t){super(e),this.origin=t.origin,this.participant=t.participant;}}class recordMsgEvent extends OmsEvent{constructor(e,t){super(e),this.recordMsg=t;}}class iceStatusEvent extends OmsEvent{constructor(e,t){super(e),this.iceStatus=t;}}class reloginEvent extends OmsEvent{constructor(e,t){super(e),this.room=t;}}function isAllowedValue(t,e){return e.some(e=>e===t)}class StreamStatusInfo{constructor(e,t){if(e&&!isAllowedValue(e,["active","inactive"]))throw new TypeError("Incorrect value for audioActive");if(t&&!isAllowedValue(t,["active","inactive"]))throw new TypeError("Incorrect value for videoActive");this.audio=e,this.video=t;}}class StreamSourceInfo{constructor(e,t){if(!isAllowedValue(e,[void 0,"mic","screen-cast","file","mixed"]))throw new TypeError("Incorrect value for audioSourceInfo");if(!isAllowedValue(t,[void 0,"camera","screen-cast","file","encoded-file","raw-file","mixed"]))throw new TypeError("Incorrect value for videoSourceInfo");this.audio=e,this.video=t;}}class Stream extends EventDispatcher{constructor(e,t,i,r,n,s){if(super(),e&&!(e instanceof MediaStream)||"object"!=typeof t)throw new TypeError("Invalid stream or sourceInfo.");if(e&&(0<e.getAudioTracks().length&&!t.audio||0<e.getVideoTracks().length&&!t.video))throw new TypeError("Missing audio source info or video source info.");Object.defineProperty(this,"mediaStream",{configurable:!1,writable:!0,value:e}),Object.defineProperty(this,"source",{configurable:!1,writable:!1,value:t}),Object.defineProperty(this,"attributes",{configurable:!0,writable:!1,value:i}),Object.defineProperty(this,"mediaStatus",{configurable:!1,writable:!1,value:r}),Object.defineProperty(this,"userInfo",{configurable:!1,writable:!1,value:n}),Object.defineProperty(this,"type",{configurable:!1,writable:!1,value:s});}}class LocalStream extends Stream{constructor(e,t,i){if(!(e instanceof MediaStream))throw new TypeError("Invalid stream.");super(e,t,i),Object.defineProperty(this,"id",{configurable:!1,writable:!1,value:createUuid()});}}class RemoteStream extends Stream{constructor(e,t,i,r,n,s,o,a){super(i,r,n,s,o,a),Object.defineProperty(this,"id",{configurable:!0,writable:!0,value:e||createUuid()}),Object.defineProperty(this,"origin",{configurable:!1,writable:!1,value:t}),this.settings=void 0,this.capabilities=void 0;}}class StreamEvent extends OmsEvent{constructor(e,t){super(e),this.stream=t.stream;}}class StreamAudioEvent extends OmsEvent{constructor(e,t){super(e),this.info=t.info;}}var base=Object.freeze({__proto__:null,AudioTrackConstraints:AudioTrackConstraints,VideoTrackConstraints:VideoTrackConstraints,StreamConstraints:StreamConstraints,MediaStreamFactory:MediaStreamFactory,StreamStatusInfo:StreamStatusInfo,StreamSourceInfo:StreamSourceInfo,Stream:Stream,LocalStream:LocalStream,RemoteStream:RemoteStream,StreamEvent:StreamEvent,StreamAudioEvent:StreamAudioEvent,AudioSourceInfo:AudioSourceInfo,VideoSourceInfo:VideoSourceInfo,TrackKind:TrackKind,Resolution:Resolution});class AudioPublicationSettings{constructor(e){this.codec=e;}}class VideoPublicationSettings{constructor(e,t,i,r,n){this.codec=e,this.resolution=t,this.frameRate=i,this.bitrate=r,this.keyFrameInterval=n;}}class PublicationSettings{constructor(e,t){this.audio=e,this.video=t;}}class Publication extends EventDispatcher{constructor(e,t,i,r,n,s,o,a){super(),Object.defineProperty(this,"id",{configurable:!1,writable:!1,value:e||createUuid()}),this.stop=t,this.getStats=i,this.getConnectionState=r,this.mute=n,this.unmute=s,this.getSenders=o,this.addTrack=a;}}function maybeSetOpusOptions(e,t){return "true"===t.opusStereo?e=setCodecParam(e,"opus/48000","stereo","1"):"false"===t.opusStereo&&(e=removeCodecParam(e,"opus/48000","stereo")),"true"===t.opusFec?e=setCodecParam(e,"opus/48000","useinbandfec","1"):"false"===t.opusFec&&(e=removeCodecParam(e,"opus/48000","useinbandfec")),"true"===t.opusDtx?e=setCodecParam(e,"opus/48000","usedtx","1"):"false"===t.opusDtx&&(e=removeCodecParam(e,"opus/48000","usedtx")),t.opusMaxPbr&&(e=setCodecParam(e,"opus/48000","maxplaybackrate",t.opusMaxPbr)),t.opusMaxAb&&(e=setCodecParam(e,"opus/48000","maxaveragebitrate",t.opusMaxAb)),t.opusMaxb&&(e=setCodecParam(e,"opus/48000","x-google-max-bitrate",t.opusMaxb)),t.opusMinb&&(e=setCodecParam(e,"opus/48000","x-google-min-bitrate",t.opusMinb)),t.opusStartb&&(e=setCodecParam(e,"opus/48000","x-google-start-bitrate",t.opusStartb)),e=t.opusMaxPlaybackrate?setCodecParam(e,"opus/48000","maxplaybackrate",t.opusMaxPlaybackrate):e}function maybeSetVideoSendInitialBitRate(e,t){var i=parseInt(t.videoSendInitialBitrate);if(!i)return e;var r=parseInt(i),n=parseInt(t.videoSendBitrate);n&&(n<i&&(Logger.debug("Clamping initial bitrate to max bitrate of "+n+" kbps."),t.videoSendInitialBitrate=i=n),r=n);var s=e.split("\r\n"),i=findLine(s,"m=","video");if(null===i)return Logger.debug("Failed to find video m-line"),e;n=s[i],i=new RegExp("m=video\\s\\d+\\s[A-Z/]+\\s"),i=n.split(i)[1].split(" ")[0],i=s[findLine(s,"a=rtpmap",i)].split("a=rtpmap:"+i)[1].split("/")[0],i=t.videoSendCodec||i;return console.log(i),e=setCodecParam(e,i,"x-google-min-bitrate",t.videoSendInitialBitrate),e=setCodecParam(e,i,"x-google-max-bitrate",r),e=setCodecParam(e,i,"x-google-start-bitrate","2048")}function setCodecParam(e,t,i,r){var n=e.split("\r\n"),s=findFmtpLine(n=n.length<=1?e.split("\n"):n,t),o={};if(null===s){var a=findLine(n,"a=rtpmap",t);if(null===a)return e;t=getCodecPayloadTypeFromLine(n[a]);o.pt=t.toString(),o.params={},o.params[i]=r,n.splice(a+1,0,writeFmtpLine(o));}else (o=parseFmtpLine(n[s])).params[i]=r,n[s]=writeFmtpLine(o);return e=n.join("\r\n")}function setAudioNack(e){var t=e.split("\r\n"),i=findFmtpLine(t=t.length<=1?e.split("\n"):t,"opus/48000");if(i){var r=findLine(t,"a=rtpmap","opus/48000");if(null===r)return e;r=getCodecPayloadTypeFromLine(t[r]);t.splice(i,0,"a=rtcp-fb:"+r.toString()+" nack");}return t.join("\r\n")}function removeCodecParam(e,t,i){var r=e.split("\r\n"),n=findFmtpLine(r,t);if(null===n)return e;t=parseFmtpLine(r[n]);delete t.params[i];t=writeFmtpLine(t);return null===t?r.splice(n,1):r[n]=t,e=r.join("\r\n")}function parseFmtpLine(e){var t={},i=e.indexOf(" "),r=e.substring(i+1).split(";"),i=new RegExp("a=fmtp:(\\d+)"),i=e.match(i);if(!i||2!==i.length)return null;t.pt=i[1];for(var n={},s=0;s<r.length;++s){var o=r[s].split("=");2===o.length&&(n[o[0]]=o[1]);}return t.params=n,t}function writeFmtpLine(e){if(!e.hasOwnProperty("pt")||!e.hasOwnProperty("params"))return null;var t,i=e.pt,r=e.params,n=[],s=0;for(t in r)n[s]=t+"="+r[t],++s;return 0===s?null:"a=fmtp:"+i.toString()+" "+n.join(";")}function findFmtpLine(e,t){t=getCodecPayloadType(e,t);return t?findLine(e,"a=fmtp:"+t.toString()):null}function findLine(e,t,i){return findLineInRange(e,0,-1,t,i)}function findLineInRange(e,t,i,r,n){for(var s=-1!==i?i:e.length,o=t;o<s;++o)if(0===e[o].indexOf(r)&&(!n||-1!==e[o].toLowerCase().indexOf(n.toLowerCase())))return o;return null}function getCodecPayloadType(e,t){t=findLine(e,"a=rtpmap",t);return t?getCodecPayloadTypeFromLine(e[t]):null}function getCodecPayloadTypeFromLine(e){var t=new RegExp("a=rtpmap:(\\d+) [a-zA-Z0-9-]+\\/\\d+"),t=e.match(t);return t&&2===t.length?t[1]:null}const audioCodecWhiteList=["CN","telephone-event"],videoCodecWhiteList=["red","ulpfec"];function setCodecOrder(e,t){return e.split(" ").slice(0,3).concat(t).join(" ")}function appendRtxPayloads(e,t){for(const r of t){var i=findLine(e,"a=fmtp","apt="+r);null!==i&&(i=parseFmtpLine(e[i]),t.push(i.pt));}return t}function removeCodecFramALine(t,e){var i=new RegExp("a=(rtpmap|rtcp-fb|fmtp):"+e+"\\s");for(let e=t.length-1;0<e;e--)t[e].match(i)&&t.splice(e,1);return t}function reorderCodecs(e,t,i){if(!i||0===i.length)return e;i="audio"===t?i.concat(audioCodecWhiteList):i.concat(videoCodecWhiteList);var r=e.split("\r\n"),t=findLine(r,"m=",t);if(null===t)return e;let n=r[t].split(" ");n.splice(0,3);var s=[];for(const u of i)for(var o=0;o<r.length;o++){var a,c=findLineInRange(r,o,-1,"a=rtpmap",u);null===c||(a=getCodecPayloadTypeFromLine(r[c]))&&(s.push(a),o=c);}s=appendRtxPayloads(r,s),r[t]=setCodecOrder(r[t],s);for(const d of n)-1===s.indexOf(d)&&(r=removeCodecFramALine(r,d));return e=r.join("\r\n")}function setMaxBitrate(e,t){console.log(t);for(const i of t)i.maxBitrate&&(e=setCodecParam(e,i.codec.name,"x-google-max-bitrate",i.maxBitrate.toString()));return e}function getRomoteAddr(e){e.split("\r\n").forEach(e=>{var t,i;!~e.indexOf("a=candidate")||"172"!=(i=e.split(" "))[4].substring(0,3)&&"192.168"!=i[4].substring(0,7)&&"IP4"!=i[4].substring(0,3)&&(t=document.getElementById("userDispatchIp"),e=document.getElementById("remoteIp"),t&&!e&&((e=document.createElement("p")).setAttribute("id","remoteIp"),i=document.createTextNode("webrtc ip:"+i[4]),e.appendChild(i),t.appendChild(e)));});}sysInfo();sysInfo();!!isSafari();!isSafari();class ConferenceError extends Error{constructor(e){super(e);}}const version="3.7.2",VERSION=version,_hasatob="function"==typeof atob,_hasbtoa="function"==typeof btoa,_hasBuffer="function"==typeof Buffer,_TD="function"==typeof TextDecoder?new TextDecoder:void 0,_TE="function"==typeof TextEncoder?new TextEncoder:void 0,b64ch="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",b64chs=Array.prototype.slice.call(b64ch),b64tab=(e=>{let i={};return e.forEach((e,t)=>i[e]=t),i})(b64chs),b64re=/^(?:[A-Za-z\d+\/]{4})*?(?:[A-Za-z\d+\/]{2}(?:==)?|[A-Za-z\d+\/]{3}=?)?$/,_fromCC=String.fromCharCode.bind(String),_U8Afrom="function"==typeof Uint8Array.from?Uint8Array.from.bind(Uint8Array):(e,t=e=>e)=>new Uint8Array(Array.prototype.slice.call(e,0).map(t)),_mkUriSafe=e=>e.replace(/=/g,"").replace(/[+\/]/g,e=>"+"==e?"-":"_"),_tidyB64=e=>e.replace(/[^A-Za-z0-9\+\/]/g,""),btoaPolyfill=t=>{let i,r,n,s,o="";var e=t.length%3;for(let e=0;e<t.length;){if(255<(r=t.charCodeAt(e++))||255<(n=t.charCodeAt(e++))||255<(s=t.charCodeAt(e++)))throw new TypeError("invalid character found");i=r<<16|n<<8|s,o+=b64chs[i>>18&63]+b64chs[i>>12&63]+b64chs[i>>6&63]+b64chs[63&i];}return e?o.slice(0,e-3)+"===".substring(e):o},_btoa=_hasbtoa?e=>btoa(e):_hasBuffer?e=>Buffer.from(e,"binary").toString("base64"):btoaPolyfill,_fromUint8Array=_hasBuffer?e=>Buffer.from(e).toString("base64"):i=>{let r=[];for(let e=0,t=i.length;e<t;e+=4096)r.push(_fromCC.apply(null,i.subarray(e,e+4096)));return _btoa(r.join(""))},fromUint8Array=(e,t=!1)=>t?_mkUriSafe(_fromUint8Array(e)):_fromUint8Array(e),cb_utob=e=>{if(e.length<2)return (t=e.charCodeAt(0))<128?e:t<2048?_fromCC(192|t>>>6)+_fromCC(128|63&t):_fromCC(224|t>>>12&15)+_fromCC(128|t>>>6&63)+_fromCC(128|63&t);var t=65536+1024*(e.charCodeAt(0)-55296)+(e.charCodeAt(1)-56320);return _fromCC(240|t>>>18&7)+_fromCC(128|t>>>12&63)+_fromCC(128|t>>>6&63)+_fromCC(128|63&t)},re_utob=/[\uD800-\uDBFF][\uDC00-\uDFFFF]|[^\x00-\x7F]/g,utob=e=>e.replace(re_utob,cb_utob),_encode=_hasBuffer?e=>Buffer.from(e,"utf8").toString("base64"):_TE?e=>_fromUint8Array(_TE.encode(e)):e=>_btoa(utob(e)),encode=(e,t=!1)=>t?_mkUriSafe(_encode(e)):_encode(e),encodeURI=e=>encode(e,!0),re_btou=/[\xC0-\xDF][\x80-\xBF]|[\xE0-\xEF][\x80-\xBF]{2}|[\xF0-\xF7][\x80-\xBF]{3}/g,cb_btou=e=>{switch(e.length){case 4:var t=((7&e.charCodeAt(0))<<18|(63&e.charCodeAt(1))<<12|(63&e.charCodeAt(2))<<6|63&e.charCodeAt(3))-65536;return _fromCC(55296+(t>>>10))+_fromCC(56320+(1023&t));case 3:return _fromCC((15&e.charCodeAt(0))<<12|(63&e.charCodeAt(1))<<6|63&e.charCodeAt(2));default:return _fromCC((31&e.charCodeAt(0))<<6|63&e.charCodeAt(1))}},btou=e=>e.replace(re_btou,cb_btou),atobPolyfill=t=>{if(t=t.replace(/\s+/g,""),!b64re.test(t))throw new TypeError("malformed base64.");t+="==".slice(2-(3&t.length));let i,r="",n,s;for(let e=0;e<t.length;)i=b64tab[t.charAt(e++)]<<18|b64tab[t.charAt(e++)]<<12|(n=b64tab[t.charAt(e++)])<<6|(s=b64tab[t.charAt(e++)]),r+=64===n?_fromCC(i>>16&255):64===s?_fromCC(i>>16&255,i>>8&255):_fromCC(i>>16&255,i>>8&255,255&i);return r},_atob=_hasatob?e=>atob(_tidyB64(e)):_hasBuffer?e=>Buffer.from(e,"base64").toString("binary"):atobPolyfill,_toUint8Array=_hasBuffer?e=>_U8Afrom(Buffer.from(e,"base64")):e=>_U8Afrom(_atob(e),e=>e.charCodeAt(0)),toUint8Array=e=>_toUint8Array(_unURI(e)),_decode=_hasBuffer?e=>Buffer.from(e,"base64").toString("utf8"):_TD?e=>_TD.decode(_toUint8Array(e)):e=>btou(_atob(e)),_unURI=e=>_tidyB64(e.replace(/[-_]/g,e=>"-"==e?"+":"/")),decode=e=>_decode(_unURI(e)),isValid=e=>{if("string"!=typeof e)return !1;e=e.replace(/\s+/g,"").replace(/={0,2}$/,"");return !/[^\s0-9a-zA-Z\+/]/.test(e)||!/[^\s0-9a-zA-Z\-_]/.test(e)},_noEnum=e=>({value:e,enumerable:!1,writable:!0,configurable:!0}),extendString=function(){var e=(e,t)=>Object.defineProperty(String.prototype,e,_noEnum(t));e("fromBase64",function(){return decode(this)}),e("toBase64",function(e){return encode(this,e)}),e("toBase64URI",function(){return encode(this,!0)}),e("toBase64URL",function(){return encode(this,!0)}),e("toUint8Array",function(){return toUint8Array(this)});},extendUint8Array=function(){var e=(e,t)=>Object.defineProperty(Uint8Array.prototype,e,_noEnum(t));e("toBase64",function(e){return fromUint8Array(this,e)}),e("toBase64URI",function(){return fromUint8Array(this,!0)}),e("toBase64URL",function(){return fromUint8Array(this,!0)});},extendBuiltins=()=>{extendString(),extendUint8Array();},gBase64={version:version,VERSION:VERSION,atob:_atob,atobPolyfill:atobPolyfill,btoa:_btoa,btoaPolyfill:btoaPolyfill,fromBase64:decode,toBase64:encode,encode:encode,encodeURI:encodeURI,encodeURL:encodeURI,utob:utob,btou:btou,decode:decode,isValid:isValid,fromUint8Array:fromUint8Array,toUint8Array:toUint8Array,extendString:extendString,extendUint8Array:extendUint8Array,extendBuiltins:extendBuiltins};function handleResponse(e,t,i,r){"ok"===e||"success"===e?i(t):"error"===e?(console.log(t),r(t)):Logger.error("MCU returns unknown ack.");}const MAX_TRIALS=10;class SioSignaling extends EventDispatcher{constructor(){super(),this._socket=null,this._loggedIn=!1,this._reconnectTimes=0,this._reconnectionTicket=null,this._refreshReconnectionTicket=null;}connect(t,e,n){return new Promise((i,r)=>{var e={reconnection:!0,reconnectionAttempts:MAX_TRIALS,"force new connection":!0,transports:["websocket","polling"]};this._socket=io(t,e),this._socket.on("connect",()=>{console.log("连接成功");}),["participant","text","stream","progress","room","drop","recording"].forEach(t=>{this._socket.on(t,e=>{this.dispatchEvent(new MessageEvent("data",{message:{notification:t,data:e}}));});}),this._socket.on("reconnecting",()=>{console.log(this._reconnectTimes),this._reconnectTimes++;}),this._socket.on("reconnect_failed",e=>{this._reconnectTimes>=MAX_TRIALS&&(this.dispatchEvent(new OmsEvent("reconnect_failed")),this.dispatchEvent(new OmsEvent("disconnect")));}),this._socket.on("drop",()=>{this._reconnectTimes=MAX_TRIALS;}),this._socket.on("disconnect",e=>{console.debug(e),this._clearReconnectionTask(),this._reconnectTimes>=MAX_TRIALS&&(this._loggedIn=!1,this.dispatchEvent(new OmsEvent("disconnect")));}),this._socket.on("error",function(e){console.debug(e+" - error");}),this._socket.on("connect_error",e=>{console.debug(e),console.debug("连接超时");}),this._socket.on("connect_timeout",e=>{console.debug(e),console.debug("连接超时");}),this._socket.emit("login",n,(e,t)=>{"ok"===e&&(this._loggedIn=!0,this._onReconnectionTicket(t.reconnectionTicket),this._socket.on("connect",()=>{this._socket.emit("relogin",this._reconnectionTicket,async(e,t)=>{"ok"===e?(this._reconnectTimes=0,this._onReconnectionTicket(t),console.log(JSON.parse(gBase64.decode(t)).room),t=new reloginEvent("relogin",JSON.parse(gBase64.decode(t)).room),this.dispatchEvent(t)):await this.dispatchEvent(new OmsEvent("disconnect"));});})),handleResponse(e,t,i,r);});})}disconnect(){return this._reconnectTimes=MAX_TRIALS,!this._socket||this._socket.disconnected?(this._socket&&this._socket.disconnected&&this._socket.close(),console.log(this._reconnectTimes),Promise.resolve(new ConferenceError("Portal is not connected."))):new Promise((i,r)=>{this._socket.emit("logout",(e,t)=>{this._reconnectTimes=MAX_TRIALS,this._socket.disconnect(),handleResponse(e,t,i,r);});})}send(e,t){return new Promise((i,r)=>{this._socket.emit(e,t,(e,t)=>{handleResponse(e,t,i,r);});})}_onReconnectionTicket(t){this._reconnectionTicket=t,console.log(gBase64);var i=JSON.parse(gBase64.decode(t));console.log(i);t=Date.now();if(i.notAfter<=t-1e4)Logger.warning("Reconnection ticket expires too soon.");else {let e=i.notAfter-t-6e4;e<0&&(e=i.notAfter-t-1e4),this._clearReconnectionTask(),this._refreshReconnectionTicket=setTimeout(()=>{this._socket.emit("refreshReconnectionTicket",(e,t)=>{"ok"===e?this._onReconnectionTicket(t):Logger.warning("Failed to refresh reconnection ticket.");});},e);}}_clearReconnectionTask(){clearTimeout(this._refreshReconnectionTicket),this._refreshReconnectionTicket=null;}}const Base64=function(){for(var t,i,n,s,o,a,c=["A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z","a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","0","1","2","3","4","5","6","7","8","9","+","/"],r=[],e=0;e<c.length;e+=1)r[c[e]]=e;return n=function(e){t=e,i=0;},s=function(){var e;return !t||i>=t.length?-1:(e=255&t.charCodeAt(i),i+=1,e)},o=function(){if(!t)return -1;for(;;){if(i>=t.length)return -1;var e=t.charAt(i);if(i+=1,r[e])return r[e];if("A"===e)return 0}},a=function(e){return e="%"+(e=1===(e=e.toString(16)).length?"0"+e:e),unescape(e)},{encodeBase64:function(e){var t,i,r;for(n(e),t="",i=new Array(3),r=!1;!r&&-1!==(i[0]=s());)i[1]=s(),i[2]=s(),t+=c[i[0]>>2],-1!==i[1]?(t+=c[i[0]<<4&48|i[1]>>4],-1!==i[2]?(t+=c[i[1]<<2&60|i[2]>>6],t+=c[63&i[2]]):(t+=c[i[1]<<2&60],t+="=",r=!0)):(t+=c[i[0]<<4&48],t+="=",t+="=",r=!0);return t},decodeBase64:function(e){var t,i,r;for(n(e),t="",i=new Array(4),r=!1;!r&&-1!==(i[0]=o())&&-1!==(i[1]=o());)i[2]=o(),i[3]=o(),t+=a(i[0]<<2&255|i[1]>>4),-1!==i[2]?(t+=a(i[1]<<4&255|i[2]>>2),-1!==i[3]?t+=a(i[2]<<6&255|i[3]):r=!0):r=!0;return t}}}();class Participant extends EventDispatcher{constructor(e,t,i,r,n){super(),Object.defineProperty(this,"id",{configurable:!1,writable:!1,value:e}),Object.defineProperty(this,"role",{configurable:!1,writable:!1,value:t}),Object.defineProperty(this,"userId",{configurable:!1,writable:!1,value:i}),Object.defineProperty(this,"platform",{configurable:!1,writable:!1,value:r}),Object.defineProperty(this,"ptid",{configurable:!1,writable:!1,value:n});}}class ConferenceInfo{constructor(e,t,i,r){this.id=e,this.participants=t,this.remoteStreams=i,this.self=r;}}class AudioCodecParameters{constructor(e,t,i){this.name=e,this.channelCount=t,this.clockRate=i;}}class VideoCodecParameters{constructor(e,t){this.name=e,this.profile=t;}}class AudioSubscriptionCapabilities{constructor(e){this.codecs=e;}}class VideoSubscriptionCapabilities{constructor(e,t,i,r,n){this.codecs=e,this.resolutions=t,this.frameRates=i,this.bitrateMultipliers=r,this.keyFrameIntervals=n;}}class SubscriptionCapabilities{constructor(e,t){this.audio=e,this.video=t;}}class Subscription extends EventDispatcher{constructor(e,t,i,r,n,s,o,a,c,u){if(super(),!e)throw new TypeError("ID cannot be null or undefined.");Object.defineProperty(this,"id",{configurable:!0,writable:!1,value:e}),this.stop=t,this.getStats=i,this.getConnectionState=r,this.mute=n,this.unmute=s,this.applyOptions=o,this.getReceivers=a,this.getContributingSources=c,this.getSynchronizationSources=u;}}class ConferencePeerConnectionChannel extends EventDispatcher{constructor(e,t){super(),this._config=e,this._options=null,this._signaling=t,this._pc=null,this._internalId=null,this._pendingCandidates=[],this._subscribePromise=null,this._publishPromise=null,this._subscribedStream=null,this._publishedStream=null,this.publishTracks=[],this._publication=null,this._subscription=null,this._disconnectTimer=null,this._ended=!1;}onMessage(e,t){switch(e){case"progress":"soac"===t.status?this._sdpHandler(t.data):"ready"===t.status?this._readyHandler():"error"===t.status&&this._errorHandler(t.data);break;case"stream":this._onStreamEvent(t);break;default:Logger.warning("Unknown notification from MCU.");}}publish(n,s){if("object"!=typeof(s=void 0===s?{audio:!!n.mediaStream.getAudioTracks(),video:!!n.mediaStream.getVideoTracks()}:s))return Promise.reject(new TypeError("Options should be an object."));if(void 0===s.audio&&(s.audio=!!n.mediaStream.getAudioTracks()),void 0===s.video&&(s.video=!!n.mediaStream.getVideoTracks()),"object"==typeof s.audio){if(!Array.isArray(s.audio))return Promise.reject(new TypeError("options.audio should be a boolean or an array."));for(const t of s.audio)if(!t.codec||"string"!=typeof t.codec.name||void 0!==t.maxBitrate&&"number"!=typeof t.maxBitrate)return Promise.reject(new TypeError("options.audio has incorrect parameters."))}if("object"==typeof s.video){if(!Array.isArray(s.video))return Promise.reject(new TypeError("options.video should be a boolean or an array."));for(const i of s.video)if(!i.codec||"string"!=typeof i.codec.name||void 0!==i.maxBitrate&&"number"!=typeof i.maxBitrate||void 0!==i.codec.profile&&"string"!=typeof i.codec.profile)return Promise.reject(new TypeError("options.video has incorrect parameters."))}this._options=s;const o={};if(this._createPeerConnection(),0<n.mediaStream.getAudioTracks().length&&!1!==s.audio&&null!==s.audio){if(1<n.mediaStream.getAudioTracks().length&&Logger.warning("Publishing a stream with multiple audio tracks is not fully supported."),"boolean"!=typeof s.audio&&"object"!=typeof s.audio)return Promise.reject(new ConferenceError("Type of audio options should be boolean or an object."));o.audio={},o.audio.source=n.source.audio;for(const r of n.mediaStream.getAudioTracks())this._pc.addTrack(r,n.mediaStream);}else o.audio=!1;if(0<n.mediaStream.getVideoTracks().length&&!1!==s.video&&null!==s.video){1<n.mediaStream.getVideoTracks().length&&Logger.warning("Publishing a stream with multiple video tracks is not fully supported."),o.video={},o.video.source=n.source.video;var e=n.mediaStream.getVideoTracks()[0].getSettings?n.mediaStream.getVideoTracks()[0].getSettings():{width:1280,height:720,frameRate:30};o.video.parameters={resolution:{width:e.width,height:e.height},framerate:e.frameRate};for(const a of n.mediaStream.getVideoTracks())this._pc.addTrack(a,n.mediaStream);}else o.video=!1;return this._publishedStream=n,this._signaling.sendSignalingMessage("publish",{media:o,attributes:n.attributes}).then(e=>{var t=new MessageEvent("id",{message:e.id,origin:this._remoteId});this.dispatchEvent(t),this._internalId=e.id;const i={offerToReceiveAudio:!1,offerToReceiveVideo:!1};"function"==typeof this._pc.addTransceiver&&(o.audio&&0<n.mediaStream.getAudioTracks()&&this._pc.addTransceiver("audio",{direction:"sendonly"}),o.video&&0<n.mediaStream.getVideoTracks()&&this._pc.addTransceiver("video",{direction:"sendonly"}));let r;i.iceRestart=!0,this._pc.createOffer(i).then(e=>(s&&(e.sdp=this._setRtpReceiverOptions(e.sdp,s)),e)).then(e=>(r=e,this._pc.setLocalDescription(e))).then(()=>{this._signaling.sendSignalingMessage("soac",{id:this._internalId,signaling:r});}).catch(e=>{Logger.error("Failed to create offer or set SDP. Message: "+e.message),this._unpublish(),this._rejectPromise(e),this._fireEndedEventOnPublicationOrSubscription();});}).catch(e=>{this._unpublish(),this._rejectPromise(e),this._fireEndedEventOnPublicationOrSubscription();}),new Promise((e,t)=>{this._publishPromise={resolve:e,reject:t};})}subscribe(e,r){if("object"!=typeof(r=void 0===r?{audio:!!e.capabilities.audio,video:!!e.capabilities.video}:r))return Promise.reject(new TypeError("Options should be an object."));if(void 0===r.audio&&(r.audio=!!e.capabilities.audio),void 0===r.video&&(r.video=!!e.capabilities.video),void 0!==r.audio&&"object"!=typeof r.audio&&"boolean"!=typeof r.audio&&null!==r.audio||void 0!==r.video&&"object"!=typeof r.video&&"boolean"!=typeof r.video&&null!==r.video)return Promise.reject(new TypeError("Invalid options type."));if(r.audio&&!e.capabilities.audio||r.video&&!e.capabilities.video)return Promise.reject(new ConferenceError("options.audio/video cannot be true or an object if there is no audio/video track in remote stream."));if(!1===r.audio&&!1===r.video)return Promise.reject(new ConferenceError("Cannot subscribe a stream without audio and video."));this._options=r;const n={};if(r.audio){if("object"==typeof r.audio&&Array.isArray(r.audio.codecs)&&0===r.audio.codecs.length)return Promise.reject(new TypeError("Audio codec cannot be an empty array."));n.audio={},n.audio.from=e.id;}else n.audio=!1;if(r.video){if("object"==typeof r.video&&Array.isArray(r.video.codecs)&&0===r.video.codecs.length)return Promise.reject(new TypeError("Video codec cannot be an empty array."));n.video={},n.video.from=e.id,(r.video.resolution||r.video.frameRate||r.video.bitrateMultiplier&&1!==r.video.bitrateMultiplier||r.video.keyFrameInterval)&&(n.video.parameters={resolution:r.video.resolution,framerate:r.video.frameRate,bitrate:r.video.bitrateMultiplier?"x"+r.video.bitrateMultiplier.toString():void 0,keyFrameInterval:r.video.keyFrameInterval});}else n.video=!1;return this._subscribedStream=e,this._signaling.sendSignalingMessage("subscribe",{media:n}).then(e=>{var t=new MessageEvent("id",{message:e.id,origin:this._remoteId});this.dispatchEvent(t),this._internalId=e.id,this._createPeerConnection();e={offerToReceiveAudio:!!r.audio,offerToReceiveVideo:!!r.video};if("function"==typeof this._pc.addTransceiver&&(n.audio&&this._pc.addTransceiver("audio",{direction:"recvonly"}),n.video)){const i=this._pc.addTransceiver("video",{direction:"recvonly"});console.log(i),i.receiver.track.onended=function(e){console.log(e);},i.receiver.track.onunmuted=function(e){console.log(e);},i.receiver.track.onmute=function(e){console.log(e);};}this._pc.createOffer(e).then(t=>{r&&(t.sdp=this._setRtpReceiverOptions(t.sdp,r)),this._pc.setLocalDescription(t).then(()=>{this._signaling.sendSignalingMessage("soac",{id:this._internalId,signaling:t});},function(e){this._signaling.sendSignalingMessage("soac",{id:this._internalId,signaling:t}),Logger.error("Set local description failed. Message: "+JSON.stringify(e));});},function(e){Logger.error("Create offer failed. Error info: "+JSON.stringify(e));}).catch(e=>{Logger.error("Failed to create offer or set SDP. Message: "+e.message),this._unsubscribe(),this._rejectPromise(e),this._fireEndedEventOnPublicationOrSubscription();});}).catch(e=>{this._unsubscribe(),this._rejectPromise(e),this._fireEndedEventOnPublicationOrSubscription();}),new Promise((e,t)=>{this._subscribePromise={resolve:e,reject:t};})}_unpublish(){this._signaling.sendSignalingMessage("unpublish",{id:this._internalId}).catch(e=>{Logger.warning("MCU returns negative ack for unpublishing, "+e);}),this._pc&&"closed"!==this._pc.signalingState&&this._pc.close();}_unsubscribe(){this._signaling.sendSignalingMessage("unsubscribe",{id:this._internalId}).catch(e=>{Logger.warning("MCU returns negative ack for unsubscribing, "+e);}),this._pc&&"closed"!==this._pc.signalingState&&this._pc.close();}_muteOrUnmute(t,i,r){return this._signaling.sendSignalingMessage(i?"stream-control":"subscription-control",{id:this._internalId,operation:t?"pause":"play",data:r}).then(()=>{var e;i||(e=t?"mute":"unmute",this._subscription.dispatchEvent(new MuteEvent(e,{kind:r})));})}_applyOptions(e){if("object"!=typeof e||"object"!=typeof e.video)return Promise.reject(new ConferenceError("Options should be an object."));const t={};return t.resolution=e.video.resolution,t.framerate=e.video.frameRate,t.bitrate=e.video.bitrateMultiplier?"x"+e.video.bitrateMultiplier.toString():void 0,t.keyFrameInterval=e.video.keyFrameInterval,this._signaling.sendSignalingMessage("subscription-control",{id:this._internalId,operation:"update",data:{video:{parameters:t}}}).then()}_onRemoteStreamAdded(e){Logger.debug("Remote stream added."),this._subscribedStream?this._subscribedStream.mediaStream=e.streams[0]:Logger.warning("Received remote stream without subscription.");}_onLocalIceCandidate(e){e.candidate?"stable"!==this._pc.signalingState?this._pendingCandidates.push(e.candidate):this._sendCandidate(e.candidate):setTimeout(()=>{this._sendSDP();},1500);}_iceChangeStatus(e){var t=new iceStatusEvent("iceStatusChange",{data:e});this._subscription&&(console.log(e),this._subscription.dispatchEvent(t));}_fireEndedEventOnPublicationOrSubscription(){var e;this._ended||(this._ended=!0,e=new OmsEvent("ended"),this._publication?(this._publication.dispatchEvent(e),this._publication.stop()):this._subscription&&(this._subscription.dispatchEvent(e),this._subscription.stop()));}_rejectPromise(e){if(!e){new ConferenceError("Connection failed or closed.");}this._publishPromise?(this._publishPromise.reject(e),this._publishPromise=void 0):this._subscribePromise&&(this._subscribePromise.reject(e),this._subscribePromise=void 0);}_onIceConnectionStateChange(e){console.log(e.currentTarget.connectionState),e&&e.currentTarget&&(Logger.debug("ICE connection state changed to "+e.currentTarget.iceConnectionState),this._iceChangeStatus(e.currentTarget.connectionState),"closed"!==e.currentTarget.connectionState&&"failed"!==e.currentTarget.connectionState||this._fireEndedEventOnPublicationOrSubscription());}_sendSDP(){this._signaling.sendSignalingMessage("soac",{id:this._internalId,signaling:this._pc.currentLocalDescription});}_sendCandidate(e){this._signaling.sendSignalingMessage("soac",{id:this._internalId,signaling:{type:"candidate",candidate:{candidate:"a="+e.candidate,sdpMid:e.sdpMid,sdpMLineIndex:e.sdpMLineIndex}}}).catch(e=>{console.log(e);});}_createPeerConnection(){const e=this._config.rtcConfiguration||{};isChrome()&&(e.sdpSemantics="unified-plan"),this._pc=new RTCPeerConnection(e,{optional:[{RtpDataChannels:!0}]}),this._pc.onicecandidate=e=>{this._onLocalIceCandidate.apply(this,[e]);},this._pc.ontrack=e=>{this._onRemoteStreamAdded.apply(this,[e]);},this._pc.onconnectionstatechange=e=>{this._onIceConnectionStateChange.apply(this,[e]);},this._pc.onnegotiationneeded=e=>{console.log(e);},this._pc.addEventListener("icecandidateerror",e=>{console.log(e),701===e.errorCode&&reportConnectFail(e.url,e.errorText);});}_getStats(){return this._pc?this._pc.getStats():Promise.reject(new ConferenceError)}_getConnectionState(){return this._pc?this._pc.iceConnectionState:Promise.reject(new ConferenceError("PeerConnection is not available."))}_getSenders(){return this._pc?this._pc.getSenders():Promise.reject(new ConferenceError("PeerConnection is not available."))}_getReceivers(){return this._pc?this._pc.getReceivers():Promise.reject(new ConferenceError("PeerConnection is not available."))}_getContributingSources(){return this._pc?this._pc.getContributingSources():Promise.reject(new ConferenceError("PeerConnection is not available."))}_getSynchronizationSources(){return this._pc?this._pc.getContributingSources():Promise.reject(new ConferenceError("PeerConnection is not available."))}_addTrack(e){return this._pc?this._pc.addTrack(e):Promise.reject(new ConferenceError("PeerConnection is not available."))}_readyHandler(){this._subscribePromise?(this._subscription=new Subscription(this._internalId,()=>{this._unsubscribe();},()=>this._getStats(),()=>this._getConnectionState(),e=>this._muteOrUnmute(!0,!1,e),e=>this._muteOrUnmute(!1,!1,e),e=>this._applyOptions(e),()=>this._getReceivers(),()=>this._getContributingSources(),()=>this._getSynchronizationSources()),this._subscribedStream.addEventListener("ended",()=>{this._subscription.dispatchEvent("ended",new OmsEvent("ended"));}),this._subscribePromise.resolve(this._subscription)):this._publishPromise&&(this._publication=new Publication(this._internalId,()=>(this._unpublish(),Promise.resolve()),()=>this._getStats(),()=>this._getConnectionState(),e=>this._muteOrUnmute(!0,!0,e),e=>this._muteOrUnmute(!1,!0,e),()=>this._getSenders(),e=>this._addTrack(e)),this._publishPromise.resolve(this._publication)),this._publishPromise=null,this._subscribePromise=null;}_sdpHandler(t){"answer"===t.type&&((this._publication||this._publishPromise)&&this._options&&(this._publishedStream&&"screen-cast"==this._publishedStream.source.video?t.sdp=maybeSetVideoSendInitialBitRate(t.sdp,{videoSendInitialBitrate:3900,videoSendBitrate:3972}):t.sdp=this._setRtpSenderOptions(t.sdp,this._options)),this._pc.setRemoteDescription(t).then(()=>{if(getRomoteAddr(t.sdp),0<this._pendingCandidates.length)for(const e of this._pendingCandidates)this._sendCandidate(e);},e=>{console.log(e);},e=>{Logger.error("Set remote description failed: "+e),this._rejectPromise(e),this._fireEndedEventOnPublicationOrSubscription();}).catch(e=>{console.log(e);}));}_errorHandler(e){const t=this._publishPromise||this._subscribePromise;if(t)t.reject(new ConferenceError(e));else {const i=this._publication||this._subscription;i?(e=new ConferenceError(e),e=new ErrorEvent("error",{error:e}),i.dispatchEvent(e)):Logger.warning("Neither publication nor subscription is available.");}}_setCodecOrder(e,t){var i;return this._publication||this._publishPromise?(t.audio&&(i=Array.from(t.audio,e=>e.codec.name),console.log(i),e=reorderCodecs(e,"audio",i)),t.video&&(e=reorderCodecs(e,"video",Array.from(t.video,e=>e.codec.name)),e=this._publishedStream&&"screen-cast"==this._publishedStream.source.video?maybeSetVideoSendInitialBitRate(e,{videoSendInitialBitrate:3900,videoSendBitrate:3972}):this._setRtpSenderOptions(e,t))):(t.audio&&t.audio.codecs&&(e=reorderCodecs(e,"audio",Array.from(t.audio.codecs,e=>e.name))),e=setAudioNack(e=t.video&&t.video.codecs?reorderCodecs(e,"video",Array.from(t.video.codecs,e=>e.name)):e)),e}_setMaxBitrate(e,t){return "object"==typeof t.audio&&(e=setMaxBitrate(e,t.audio)),e="object"==typeof t.video?setAudioNack(e=maybeSetOpusOptions(e=maybeSetVideoSendInitialBitRate(e=setMaxBitrate(e,t.video),{videoSendInitialBitrate:2500,videoSendBitrate:2048}),{opusMaxAb:2e4,opusMaxPlaybackrate:16e3})):e}_setRtpSenderOptions(e,t){return e=this._setMaxBitrate(e,t)}_setRtpReceiverOptions(e,t){return e=this._setCodecOrder(e,t)}_onStreamEvent(t){let i;if(this._publication&&t.id===this._publication.id?i=this._publication:this._subscribedStream&&t.id===this._subscribedStream.id&&(i=this._subscription),i){let e;"audio.status"===t.data.field?e=TrackKind.AUDIO:"video.status"===t.data.field?e=TrackKind.VIDEO:Logger.warning("Invalid data field for stream update info."),"active"===t.data.value?i.dispatchEvent(new MuteEvent("unmute",{kind:e})):"inactive"===t.data.value?i.dispatchEvent(new MuteEvent("mute",{kind:e})):Logger.warning("Invalid data value for stream update info.");}}}function extractBitrateMultiplier(e){return "string"==typeof e&&e.startsWith("x")?Number.parseFloat(e.replace(/^x/,"")):(L.Logger.warning("Invalid bitrate multiplier input."),0)}function sortNumbers(e,t){return e-t}function sortResolutions(e,t){return e.width!==t.width?e.width-t.width:e.height-t.height}function convertToPublicationSettings(e){let t,i,r,n,s,o,a,c;return e.audio&&(e.audio.format&&(i=new AudioCodecParameters(e.audio.format.codec,e.audio.format.channelNum,e.audio.format.sampleRate)),t=new AudioPublicationSettings(i)),e.video&&(e.video.format&&(n=new VideoCodecParameters(e.video.format.codec,e.video.format.profile)),e.video.parameters&&(e.video.parameters.resolution&&(s=new Resolution(e.video.parameters.resolution.width,e.video.parameters.resolution.height)),o=e.video.parameters.framerate,a=1e3*e.video.parameters.bitrate,c=e.video.parameters.keyFrameInterval),r=new VideoPublicationSettings(n,s,o,a,c)),new PublicationSettings(t,r)}function convertToSubscriptionCapabilities(e){let t,i;if(e.audio){const s=[];if(e.audio&&e.audio.format&&s.push(new AudioCodecParameters(e.audio.format.codec,e.audio.format.channelNum,e.audio.format.sampleRate)),e.audio&&e.audio.optional&&e.audio.optional.format)for(const o of e.audio.optional.format){var r=new AudioCodecParameters(o.codec,o.channelNum,o.sampleRate);s.push(r);}s.sort(),t=new AudioSubscriptionCapabilities(s);}if(e.video){const a=[];if(e.video&&e.video.format&&a.push(new VideoCodecParameters(e.video.format.codec,e.video.format.profile)),e.video&&e.video.optional&&e.video.optional.format)for(const h of e.video.optional.format){var n=new VideoCodecParameters(h.codec,h.profile);a.push(n);}a.sort();const c=Array.from(e.video.optional.parameters.resolution,e=>new Resolution(e.width,e.height));e.video&&e.video.parameters&&e.video.parameters.resolution&&c.push(new Resolution(e.video.parameters.resolution.width,e.video.parameters.resolution.height)),c.sort(sortResolutions);const u=Array.from(e.video.optional.parameters.bitrate,e=>extractBitrateMultiplier(e));u.push(1),u.sort(sortNumbers);const d=JSON.parse(JSON.stringify(e.video.optional.parameters.framerate));e.video&&e.video.parameters&&e.video.parameters.framerate&&d.push(e.video.parameters.framerate),d.sort(sortNumbers);const l=JSON.parse(JSON.stringify(e.video.optional.parameters.keyFrameInterval));e.video&&e.video.parameters&&e.video.parameters.keyFrameInterval&&l.push(e.video.parameters.keyFrameInterval),l.sort(sortNumbers),i=new VideoSubscriptionCapabilities(a,c,d,u,l);}return new SubscriptionCapabilities(t,i)}class RemoteMixedStream extends RemoteStream{constructor(e){if("mixed"!==e.type)throw new TypeError("Not a mixed stream");super(e.id,void 0,void 0,new StreamSourceInfo("mixed","mixed")),this.settings=convertToPublicationSettings(e.media),this.capabilities=new convertToSubscriptionCapabilities(e.media);}}class ActiveAudioInputChangeEvent extends OmsEvent{constructor(e,t){super(e),this.activeAudioInputStreamId=t.activeAudioInputStreamId;}}class LayoutChangeEvent extends OmsEvent{constructor(e,t){super(e),this.layout=t.layout;}}const SignalingState={READY:1,CONNECTING:2,CONNECTED:3},protocolVersion="1.0",ParticipantEvent=function(e,t){const i=new OmsEvent(e,t);return i.participant=t.participant,i},ConferenceClient=function(i,e){Object.setPrototypeOf(this,new EventDispatcher),i=i||{};const r=this;let u=SignalingState.READY;const d=e||new SioSignaling;let l,h,p=new Map;const f=new Map,n=new Map,s=new Map;function t(e,t){var i;"soac"===e||"progress"===e?s.has(t.id)?s.get(t.id).onMessage(e,t):Logger.warning("Cannot find a channel for incoming data."):"stream"===e?"add"===t.status?function(e){e=m(e);p.set(e.id,e);e=new StreamEvent("streamadded",{stream:e});r.dispatchEvent(e);}(t.data):"remove"===t.status?function(e){if(p.has(e.id)){const t=p.get(e.id);e=new OmsEvent("ended");p.delete(t.id),t.dispatchEvent(e);}else Logger.warning("Cannot find specific remote stream.");}(t):"update"===t.status&&("audio.status"===t.data.field||"video.status"===t.data.field?(i=t,p.has(i.id)?(p.get(i.id),i=new StreamAudioEvent("audiostatuschange",{info:i}),r.dispatchEvent(i)):Logger.warning("Cannot find specific remote stream.")):"activeInput"===t.data.field?function(e){if(p.has(e.id)){const t=p.get(e.id);e=new ActiveAudioInputChangeEvent("activeaudioinputchange",{activeAudioInputStreamId:e.data.value});t.dispatchEvent(e);}else Logger.warning("Cannot find specific remote stream.");}(t):"video.layout"===t.data.field?function(e){if(p.has(e.id)){const t=p.get(e.id);e=new LayoutChangeEvent("layoutchange",{layout:e.data.value});t.dispatchEvent(e);}else Logger.warning("Cannot find specific remote stream.");}(t):"."===t.data.field?function(e){if(p.has(e.id)){const t=p.get(e.id);t.settings=convertToPublicationSettings(e.media),t.capabilities=convertToSubscriptionCapabilities(e.media);e=new OmsEvent("updated");t.dispatchEvent(e);}else Logger.warning("Cannot find specific remote stream.");}(t.data.value):Logger.warning("Unknown stream event from MCU.")):"text"===e?function(e){e=new MessageEvent("messagereceived",{message:e.message,origin:e.from,to:e.to});r.dispatchEvent(e);}(t):"participant"===e?function(e){if("join"===e.action){e=e.data;var t=new Participant(e.id,e.role,e.user,e.platform,e.ptid);f.set(e.id,t);t=new ParticipantEvent("participantjoined",{participant:t});r.dispatchEvent(t);}else if("leave"===e.action){e=e.data;if(f.has(e)){const i=f.get(e);f.delete(e),i.dispatchEvent(new OmsEvent("left"));}else Logger.warning("Received leave message from MCU for an unknown participant.");}}(t):"room"==e?function(e){e=new roomStatusEvent("roomstatuschange",{data:e});r.dispatchEvent(e);}(t):"drop"==e?function(e){e=new exitRoomEvent("exitRoom",e);r.dispatchEvent(e);}(t):"recording"==e&&(console.log(t),function(e){e=new recordMsgEvent("recording",e);r.dispatchEvent(e);}(t));}function m(n){if("mixed"===n.type)return new RemoteMixedStream(n);{let e,t,i,r;n.media.audio&&(e=n.media.audio.source,i=n.media.audio.status),n.media.video&&(t=n.media.video.source,r=n.media.video.status);const s=new RemoteStream(n.id,n.info.owner,void 0,new StreamSourceInfo(e,t),n.info.attributes,new StreamStatusInfo(i,r),n.info.user,n.info.type);return n.shareInfo&&(s.shareInfo=n.shareInfo),s.settings=convertToPublicationSettings(n.media),s.capabilities=convertToSubscriptionCapabilities(n.media),s}}function o(e,t){return d.send(e,t)}function a(){const e=Object.create(EventDispatcher);e.sendSignalingMessage=o;const t=new ConferencePeerConnectionChannel(i,e);return t.addEventListener("id",e=>{s.set(e.message,t);}),t}function c(){f.clear(),p.clear();}d.addEventListener("data",e=>{t(e.message.notification,e.message.data);}),d.addEventListener("disconnect",()=>{c(),u=SignalingState.READY,r.dispatchEvent(new OmsEvent("serverdisconnected"));}),d.addEventListener("reconnect_failed",()=>{r.dispatchEvent(new OmsEvent("recollectfailed"));}),d.addEventListener("relogin",e=>{if(c(),h=e.room,void 0!==h.streams)for(const t of h.streams)"mixed"===t.type&&(t.viewport=t.info.label),t.media&&(console.log(t),p.set(t.id,m(t)));if(e.room&&void 0!==e.room.participants)for(const i of e.room.participants)f.set(i.id,new Participant(i.id,i.role,i.user,i.platform,i.ptid)),i.id===e.id&&(l=f.get(i.id));console.log(),r.dispatchEvent(new reloginEvent("relogin",new ConferenceInfo(e.room.id,Array.from(f.values()),Array.from(p.values()),l)));}),Object.defineProperty(this,"info",{configurable:!1,get:()=>h?new ConferenceInfo(h.id,Array.from(f,e=>e[1]),Array.from(p,e=>e[1]),l):null}),this.join=function(a,c){return new Promise((r,t)=>{var e,i=JSON.parse(Base64.decodeBase64(a)),n=!0===i.secure;let s=i.host;if("string"==typeof s)if(-1===s.indexOf("http")&&(s=n?"https://"+s:"http://"+s,(e=document.getElementById("userDispatchIp"))&&(o=document.createElement("p"),i=document.createTextNode("protal ip:"+s),o.appendChild(i),e.appendChild(o))),u===SignalingState.READY){u=SignalingState.CONNECTING;let e=sysInfo();c&&(e.sdk.type=c);var o={token:a,userAgent:e,protocol:protocolVersion};d.connect(s,n,o).then(e=>{if(u=SignalingState.CONNECTED,h=e.room,void 0!==h.streams)for(const t of h.streams)"mixed"===t.type&&(t.viewport=t.info.label),p.set(t.id,m(t));if(e.room&&void 0!==e.room.participants)for(const i of e.room.participants)f.set(i.id,new Participant(i.id,i.role,i.user,i.platform,i.ptid)),i.id===e.id&&(l=f.get(i.id));r(new ConferenceInfo(e.room.id,Array.from(f.values()),Array.from(p.values()),l));},e=>{u=SignalingState.READY,t(new ConferenceError(e));});}else t(new ConferenceError("connection state invalid"));else t(new ConferenceError("Invalid host."));})},this.publish=function(e,t){if(!(e instanceof LocalStream))return Promise.reject(new ConferenceError("Invalid stream."));if(n.has(e.mediaStream.id))return Promise.reject(new ConferenceError("Cannot publish a published stream."));const i=a();return i.publish(e,t)},this.subscribe=function(e,t){if(!(e instanceof RemoteStream))return Promise.reject(new ConferenceError("Invalid stream."));const i=a();return i.subscribe(e,t)},this.replaceTrack=function(e,t){const i=a();return i.replaceTrack(e,t)},this.send=function(e,t){return o("text",{to:t=void 0===t?"all":t,message:e,type:"binary"})},this.leave=function(){return d.disconnect().then(()=>{c(),u=SignalingState.READY;})},this.getSignalingState=function(){var e=null;return e=d._socket&&d._socket.io?d._socket.io.readyState:e};};var conference=Object.freeze({__proto__:null,ConferenceClient:ConferenceClient,SioSignaling:SioSignaling});const Base=base,Conference=conference,sdkVersion$1="4.1";function isSafari$1(){return /^((?!chrome|android).)*safari/i.test(window.navigator.userAgent)}function sysInfo$3(){var e=Object.create({});e.sdk={version:sdkVersion$1,type:"JavaScript"};var t=navigator.userAgent,i=/Chrome\/([0-9\.]+)/.exec(t);i?e.runtime={name:"Chrome",version:i[1].split(".")[0]}:(i=/Firefox\/([0-9\.]+)/.exec(t))?e.runtime={name:"Firefox",version:i[1]}:(i=/Edge\/([0-9\.]+)/.exec(t))?e.runtime={name:"Edge",version:i[1]}:isSafari$1()?(i=/Version\/([0-9\.]+) Safari/.exec(t),e.runtime={name:"Safari"},e.runtime.version=i?i[1]:"Unknown"):e.runtime={name:"Unknown",version:"Unknown"};return (i=/Windows NT ([0-9\.]+)/.exec(t))?e.os={name:"windows",version:i[1]}:(i=/Intel Mac OS X ([0-9_\.]+)/.exec(t))?e.os={name:"mac",version:i[1].replace(/_/g,".")}:(i=/iPhone OS ([0-9_\.]+)/.exec(t))?e.os={name:"iPhone OS",version:i[1].replace(/_/g,".")}:(i=/X11; Linux/.exec(t))?e.os={name:"Linux",version:"Unknown"}:(i=/Android( ([0-9\.]+))?/.exec(t))?e.os={name:"Android",version:i[1]||"Unknown"}:(i=/CrOS/.exec(t))?e.os={name:"Chrome OS",version:"Unknown"}:e.os={name:"Unknown",version:"Unknown"},e.capabilities={continualIceGathering:!1,unifiedPlan:!1,streamRemovable:"Firefox"!==e.runtime.name},e}function checkDeviceSupport(t){var n=[],s="https:"===location.protocol,e=!1;("undefined"!=typeof MediaStreamTrack&&"getSources"in MediaStreamTrack||navigator.mediaDevices&&navigator.mediaDevices.enumerateDevices)&&(e=!0);var o=!1,a=!1,c=!1,u=!1;e&&(!navigator.enumerateDevices&&window.MediaStreamTrack&&window.MediaStreamTrack.getSources&&(navigator.enumerateDevices=window.MediaStreamTrack.getSources.bind(window.MediaStreamTrack)),!navigator.enumerateDevices&&navigator.enumerateDevices&&(navigator.enumerateDevices=navigator.enumerateDevices.bind(navigator)),navigator.enumerateDevices?(n=[],navigator.enumerateDevices(function(e){e.forEach(function(e){var t,i,r={};for(t in e)r[t]=e[t];"audio"===r.kind&&(r.kind="audioinput"),"video"===r.kind&&(r.kind="videoinput"),n.forEach(function(e){e.id===r.id&&e.kind===r.kind&&(i=!0);}),i||(r.deviceId||(r.deviceId=r.id),r.id||(r.id=r.deviceId),r.label?("videoinput"!==r.kind||u||(u=!0),"audioinput"!==r.kind||c||(c=!0)):(r.label="Please invoke getUserMedia once.",s||(r.label="HTTPs is required to get label of this "+r.kind+" device.")),"audioinput"===r.kind&&(o=!0),"videoinput"===r.kind&&(a=!0),n.push(r));}),t&&t(a,o,c,u);})):t&&t());}navigator.mediaDevices&&navigator.mediaDevices.enumerateDevices&&(navigator.enumerateDevices=function(e){navigator.mediaDevices.enumerateDevices().then(e);});const SetUp=function(){this.AudioInputList=[],this.AudioOutPutList=[],this.VideoInputList=[],this.audio=null,this.Stream={audioStream:null,videoStream:null,isUpdateVideo:!1,isUpdateAudio:!1,isCancelSetStream:!1},this.updateDeviceList=async()=>{if(!this.Stream.isCancelSetStream){let e=await navigator.mediaDevices.enumerateDevices();this.AudioInputList=[],this.AudioOutPutList=[],this.VideoInputList=[],e.forEach((e,t)=>{"audioinput"==e.kind&&e.label?this.AudioInputList.push({deviceId:e.id||e.deviceId,label:e.label,kind:"audioinput",disabled:!1}):"audiooutput"==e.kind&&e.label?this.AudioOutPutList.push({deviceId:e.id||e.deviceId,label:e.label,kind:"audiooutput",disabled:!1}):"videoinput"==e.kind&&e.label&&this.VideoInputList.push({deviceId:e.id||e.deviceId,label:e.label||e.id||e.deviceId,kind:"videoinput",disabled:!1});});}},this.updateDeviceStatus=async()=>{if(!this.Stream.isCancelSetStream){for(let e=0;e<this.VideoInputList.length;e++)(await this.getVideoMediaStream({deviceId:this.VideoInputList[e].deviceId})).code||(this.VideoInputList[e].disabled=!1);for(let e=0;e<this.AudioInputList.length;e++)(await this.getAudioMediaStream({deviceId:this.AudioInputList[e].deviceId})).code||(this.AudioInputList[e].disabled=!1);}},this.firstUsableDevice=()=>{var t=!1,i=!1,r=!1,n={videoInputInfo:"",audioInputInfo:"",audioOutputInfo:""};return this.VideoInputList.forEach(e=>{e.disabled||t||(t=!0,n.videoInputInfo=e);}),this.AudioInputList.forEach(e=>{e.disabled||i||(i=!0,n.audioInputInfo=e);}),this.AudioOutPutList.forEach(e=>{e.disabled||r||(r=!0,n.audioOutputInfo=e);}),console.log(n),n},this.isVideoUsableDevice=t=>{if(!this.Stream.isCancelSetStream){var e=this.VideoInputList.filter(e=>{if(e.deviceId==t)return e});return 0!=e.length&&!e.disabled}},this.isAudioUsableDevice=t=>{if(!this.Stream.isCancelSetStream){var e=this.AudioInputList.filter(e=>{if(e.deviceId==t)return e});return 0!=e.length&&!e.disabled}},this.getAudioMediaStream=async e=>{if(this.Stream.audioStream&&(this.trackStop(1),this.Stream.audioStream=null),this.Stream.isCancelSetStream)return {code:1,msg:"改设置已被取消"};let t={audio:{deviceId:e&&e.deviceId?e.deviceId:this.AudioInputList[0]&&this.AudioInputList[0].deviceId?this.AudioInputList[0].deviceId:""}};return new Promise((i,e)=>{navigator.mediaDevices.getUserMedia(t).then(e=>this.Stream.isCancelSetStream?(this.trackStop(1),void i({code:1,msg:"改设置已被取消"})):(this.Stream.audioStream=e,void i(e))).catch(e=>{let t={code:1,msg:e};"NotReadableError"!=e.name&&"NotAllowedError"!=e.name&&"NotFoundError"!=e.name||(t.msg=e),i(t);});})},this.changeAudioDestination=(i,r)=>(this.audio||(this.audio=new Audio),new Promise(async(e,t)=>{this.audio.src=r,this.audio.loop=!0,i&&this.audio.setSinkId(i),this.audio.play();})),this.stopAudioDestination=()=>{this.audio&&(this.audio.pause(),this.audio=null);},this.trackStop=async e=>{if(this.Stream.videoStream&&(0==e||2==e)){for(var t=0;t<this.Stream.videoStream.getVideoTracks().length;t++)this.Stream.videoStream.getVideoTracks()[t].stop(),this.Stream.videoStream.removeTrack(this.Stream.videoStream.getVideoTracks()[t]),console.log(11111);this.Stream.videoStream=null;}if(this.Stream.audioStream&&(1==e||2==e)){for(t=0;t<this.Stream.audioStream.getAudioTracks().length;t++)this.Stream.audioStream.getAudioTracks()[t].stop(),this.Stream.audioStream.removeTrack(this.Stream.audioStream.getAudioTracks()[t]);this.Stream.audioStream=null;}};};var layout=[{id:"1",primary:"default",region:[{id:"1",shape:"rectangle",area:{left:"0",top:"0",width:"1",height:"1"}}]},{id:"2",primary:"default",region:[{id:"1",shape:"rectangle",area:{left:"0",top:"1/4",width:"1/2",height:"1/2"}},{id:"2",shape:"rectangle",area:{left:"1/2",top:"1/4",width:"1/2",height:"1/2"}}]},{id:"3",primary:"default",region:[{id:"1",shape:"rectangle",area:{left:"1/4",top:"0",width:"1/2",height:"1/2"}},{id:"2",shape:"rectangle",area:{left:"0",top:"1/2",width:"1/2",height:"1/2"}},{id:"3",shape:"rectangle",area:{left:"1/2",top:"1/2",width:"1/2",height:"1/2"}}]},{id:"4",primary:"default",region:[{id:"1",shape:"rectangle",area:{left:"0",top:"0",width:"1/2",height:"1/2"}},{id:"2",shape:"rectangle",area:{left:"1/2",top:"0",width:"1/2",height:"1/2"}},{id:"3",shape:"rectangle",area:{left:"0",top:"1/2",width:"1/2",height:"1/2"}},{id:"4",shape:"rectangle",area:{left:"1/2",top:"1/2",width:"1/2",height:"1/2"}}]},{id:"5",primary:"default",region:[{id:"1",shape:"rectangle",area:{left:"0",top:"0",width:"2/3",height:"2/3"}},{id:"2",shape:"rectangle",area:{left:"2/3",top:"0",width:"1/3",height:"1/3"}},{id:"3",shape:"rectangle",area:{left:"2/3",top:"1/3",width:"1/3",height:"1/3"}},{id:"4",shape:"rectangle",area:{left:"0",top:"2/3",width:"1/3",height:"1/3"}},{id:"5",shape:"rectangle",area:{left:"1/3",top:"2/3",width:"1/3",height:"1/3"}},{id:"6",shape:"rectangle",area:{left:"2/3",top:"2/3",width:"1/3",height:"1/3"}}]},{id:"6",primary:"default",region:[{id:"1",shape:"rectangle",area:{left:"0",top:"0",width:"3/4",height:"3/4"}},{id:"2",shape:"rectangle",area:{left:"3/4",top:"0",width:"1/4",height:"1/4"}},{id:"3",shape:"rectangle",area:{left:"3/4",top:"1/4",width:"1/4",height:"1/4"}},{id:"4",shape:"rectangle",area:{left:"3/4",top:"1/2",width:"1/4",height:"1/4"}},{id:"5",shape:"rectangle",area:{left:"0",top:"3/4",width:"1/4",height:"1/4"}},{id:"6",shape:"rectangle",area:{left:"1/4",top:"3/4",width:"1/4",height:"1/4"}},{id:"7",shape:"rectangle",area:{left:"1/2",top:"3/4",width:"1/4",height:"1/4"}},{id:"8",shape:"rectangle",area:{left:"3/4",top:"3/4",width:"1/4",height:"1/4"}}]},{id:"7",primary:"default",region:[{id:"1",shape:"rectangle",area:{left:"0",top:"0",width:"1/3",height:"1/3"}},{id:"2",shape:"rectangle",area:{left:"1/3",top:"0",width:"1/3",height:"1/3"}},{id:"3",shape:"rectangle",area:{left:"2/3",top:"0",width:"1/3",height:"1/3"}},{id:"4",shape:"rectangle",area:{left:"0",top:"1/3",width:"1/3",height:"1/3"}},{id:"5",shape:"rectangle",area:{left:"1/3",top:"1/3",width:"1/3",height:"1/3"}},{id:"6",shape:"rectangle",area:{left:"2/3",top:"1/3",width:"1/3",height:"1/3"}},{id:"7",shape:"rectangle",area:{left:"0",top:"2/3",width:"1/3",height:"1/3"}},{id:"8",shape:"rectangle",area:{left:"1/3",top:"2/3",width:"1/3",height:"1/3"}},{id:"9",shape:"rectangle",area:{left:"2/3",top:"2/3",width:"1/3",height:"1/3"}}]},{id:"8",primary:"default",region:[{id:"1",shape:"rectangle",area:{left:"1/4",top:"1/4",width:"1/2",height:"1/2"}},{id:"2",shape:"rectangle",area:{left:"0",top:"0",width:"1/4",height:"1/4"}},{id:"3",shape:"rectangle",area:{left:"1/4",top:"0",width:"1/4",height:"1/4"}},{id:"4",shape:"rectangle",area:{left:"1/2",top:"0",width:"1/4",height:"1/4"}},{id:"5",shape:"rectangle",area:{left:"3/4",top:"0",width:"1/4",height:"1/4"}},{id:"6",shape:"rectangle",area:{left:"0",top:"1/4",width:"1/4",height:"1/4"}},{id:"7",shape:"rectangle",area:{left:"3/4",top:"1/4",width:"1/4",height:"1/4"}},{id:"8",shape:"rectangle",area:{left:"0",top:"1/2",width:"1/4",height:"1/4"}},{id:"9",shape:"rectangle",area:{left:"3/4",top:"1/2",width:"1/4",height:"1/4"}},{id:"10",shape:"rectangle",area:{left:"0",top:"3/4",width:"1/4",height:"1/4"}},{id:"11",shape:"rectangle",area:{left:"1/4",top:"3/4",width:"1/4",height:"1/4"}},{id:"12",shape:"rectangle",area:{left:"1/2",top:"3/4",width:"1/4",height:"1/4"}},{id:"13",shape:"rectangle",area:{left:"3/4",top:"3/4",width:"1/4",height:"1/4"}}]},{id:"9",primary:"default",region:[{id:"1",shape:"rectangle",area:{left:"0",top:"0",width:"1/4",height:"1/4"}},{id:"2",shape:"rectangle",area:{left:"1/4",top:"0",width:"1/4",height:"1/4"}},{id:"3",shape:"rectangle",area:{left:"2/4",top:"0",width:"1/4",height:"1/4"}},{id:"4",shape:"rectangle",area:{left:"3/4",top:"0",width:"1/4",height:"1/4"}},{id:"5",shape:"rectangle",area:{left:"0",top:"1/4",width:"1/4",height:"1/4"}},{id:"6",shape:"rectangle",area:{left:"1/4",top:"1/4",width:"1/4",height:"1/4"}},{id:"7",shape:"rectangle",area:{left:"2/4",top:"1/4",width:"1/4",height:"1/4"}},{id:"8",shape:"rectangle",area:{left:"3/4",top:"1/4",width:"1/4",height:"1/4"}},{id:"9",shape:"rectangle",area:{left:"0",top:"1/2",width:"1/4",height:"1/4"}},{id:"10",shape:"rectangle",area:{left:"1/4",top:"1/2",width:"1/4",height:"1/4"}},{id:"11",shape:"rectangle",area:{left:"2/4",top:"1/2",width:"1/4",height:"1/4"}},{id:"12",shape:"rectangle",area:{left:"3/4",top:"1/2",width:"1/4",height:"1/4"}},{id:"13",shape:"rectangle",area:{left:"0",top:"3/4",width:"1/4",height:"1/4"}},{id:"14",shape:"rectangle",area:{left:"1/4",top:"3/4",width:"1/4",height:"1/4"}},{id:"15",shape:"rectangle",area:{left:"2/4",top:"3/4",width:"1/4",height:"1/4"}},{id:"16",shape:"rectangle",area:{left:"3/4",top:"3/4",width:"1/4",height:"1/4"}}]},{id:"10",primary:"default",region:[{area:{left:"0",top:"0",width:"1/2",height:"1/2"},id:"1",shape:"rectangle"},{area:{left:"1/2",top:"0",width:"1/2",height:"1/2"},id:"2",shape:"rectangle"},{area:{left:"0",top:"1/2",width:"1/4",height:"1/4"},id:"3",shape:"rectangle"},{area:{left:"1/4",top:"1/2",width:"1/4",height:"1/4"},id:"4",shape:"rectangle"},{area:{left:"1/2",top:"1/2",width:"1/4",height:"1/4"},id:"5",shape:"rectangle"},{area:{left:"3/4",top:"1/2",width:"1/4",height:"1/4"},id:"6",shape:"rectangle"},{area:{left:"0",top:"3/4",width:"1/4",height:"1/4"},id:"7",shape:"rectangle"},{area:{left:"1/4",top:"3/4",width:"1/4",height:"1/4"},id:"8",shape:"rectangle"},{area:{left:"1/2",top:"3/4",width:"1/4",height:"1/4"},id:"9",shape:"rectangle"},{area:{left:"3/4",top:"3/4",width:"1/4",height:"1/4"},id:"10",shape:"rectangle"}]},{id:"11",primary:"default",region:[{area:{left:"0",top:"3/28",width:"1/2",height:"1/2"},id:"1",shape:"rectangle"},{area:{left:"1/2",top:"3/28",width:"1/2",height:"1/2"},id:"2",shape:"rectangle"},{area:{left:"0",top:"17/28",width:"1/7",height:"1/7"},id:"3",shape:"rectangle"},{area:{left:"1/7",top:"17/28",width:"1/7",height:"1/7"},id:"4",shape:"rectangle"},{area:{left:"2/7",top:"17/28",width:"1/7",height:"1/7"},id:"5",shape:"rectangle"},{area:{left:"3/7",top:"17/28",width:"1/7",height:"1/7"},id:"6",shape:"rectangle"},{area:{left:"4/7",top:"17/28",width:"1/7",height:"1/7"},id:"7",shape:"rectangle"},{area:{left:"5/7",top:"17/28",width:"1/7",height:"1/7"},id:"8",shape:"rectangle"},{area:{left:"6/7",top:"17/28",width:"1/7",height:"1/7"},id:"9",shape:"rectangle"},{area:{left:"0",top:"21/28",width:"1/7",height:"1/7"},id:"10",shape:"rectangle"},{area:{left:"1/7",top:"21/28",width:"1/7",height:"1/7"},id:"11",shape:"rectangle"},{area:{left:"2/7",top:"21/28",width:"1/7",height:"1/7"},id:"12",shape:"rectangle"},{area:{left:"3/7",top:"21/28",width:"1/7",height:"1/7"},id:"13",shape:"rectangle"},{area:{left:"4/7",top:"21/28",width:"1/7",height:"1/7"},id:"14",shape:"rectangle"},{area:{left:"5/7",top:"21/28",width:"1/7",height:"1/7"},id:"15",shape:"rectangle"},{area:{left:"6/7",top:"21/28",width:"1/7",height:"1/7"},id:"16",shape:"rectangle"}]}],videoDefaultLayout={layout:layout};function webrtc(){class e extends EventDispatcher{constructor(){super(),this.publishLocal={publishStream:null,publication:null,isPublishIng:!1,publishArray:[],errInfo:{video:null,audio:null}},this.publishShare={shareStream:null,publication:null,isPublishIng:!1},this.subscribeMixed={mixedStream:null,subStream:null,isSubscribeIng:!1,subscription:null,subscribeArray:[]},this.subscribeShare={shareStream:null,subscription:null},this.subscribeRemote={remoteStream:null,subscription:null},this.conference=new Conference.ConferenceClient,this.analyser=null,this.microphone=null,this.audioContext=null,this.videoLayoutChange=()=>{},this.voiceStimulationChange=()=>{},this.constraints={video:{},audio:{}},this.setInfo={audio:!0,video:!0,isVideoSource:!0,isAudioSource:!0,isHangup:!1},this.receiverCsrc={audio:null,video:null,videoCsrc:[],allLayoutDataList:[],layoutId:null,startTime:null},this.setUp=new SetUp;}init(e,r){return this.conference||(this.conference=new Conference.ConferenceClient),new Promise((t,i)=>{this.conference.join(e,r).then(async e=>{e.participants.forEach(e=>{e.addEventListener("left",()=>{this.participantleave(e);});}),e.remoteStreams.forEach(e=>{e.addEventListener("ended",()=>{this.streamended(e);});}),t(e);}).catch(e=>{console.log(e),i(e);});})}async createLoaclStream(e,t){this.setInfo.video=!0,this.setInfo.audio=!0,this.setTrackStop(),await this.setUp.updateDeviceList();this.setUp.AudioInputList;var i=this.setUp.VideoInputList,t=t||!0,e=await this.createStream(e||!0,null);e&&e.code?i&&((e=await this.getUsableDevide(i,"video"))&&e.code?this.publishLocal.errInfo.video=e:this.publishLocal.publishStream=e):this.publishLocal.publishStream=e;t=await this.createStream(null,t);t&&t.code?this.publishLocal.errInfo.audio=t:this.publishLocal.publishStream?t&&t.getAudioTracks&&(this.publishLocal.publishStream=null,e.addTrack(t.getAudioTracks()[0]),this.publishLocal.publishStream=e):this.publishLocal.publishStream||(this.publishLocal.publishStream=t),console.log(this.publishLocal.publishStream.getAudioTracks()[0],"this.publishLocal.publishStream"),console.log(this.publishLocal.publishStream.getVideoTracks()[0],"this.publishLocal.publishStream"),this.addEventTrackEnded(),this.setInfo.isHangup&&this.setTrackStop();}async getUsableDevide(n,s){return new Promise(async(e,t)=>{if(0!=n.length){for(const r of n){var i;if((i="video"==s?await this.createStream(r.deviceId,null):await this.createStream(null,r.deviceId))&&!i.code)break}e(i);}else e({code:1,info:{name:"NotAllowedError"}});})}setConfig(e,t){"Firefox"==sysInfo$3().runtime.name&&43<Number(sysInfo$3().runtime.version)||"Edge"==sysInfo$3().runtime.name&&10527<Number(sysInfo$3().runtime.version)||"Chrome"==sysInfo$3().runtime.name&&56<Number(sysInfo$3().runtime.version)?(e&&this.setInfo.video?(this.constraints.video={},this.constraints.video.deviceId={exact:e}):!e&&this.setInfo.video?this.constraints.video=!0:this.setInfo.video||(this.constraints.video=!1),t&&this.setInfo.audio?(this.constraints.audio={},this.constraints.audio={optional:[{sourceId:t}]}):!t&&this.setInfo.audio?this.constraints.audio={sampleRate:16e3}:this.setInfo.audio||(this.constraints.audio=!1)):"Chrome"==sysInfo$3().runtime.name&&56<Number(sysInfo$3().runtime.version)?(this.constraints.video={mandatory:{sourceId:e},optional:[{minWidth:320},{minWidth:640},{minWidth:1024},{minWidth:1280}]},this.constraints.audio={mandatory:{sourceId:t}}):"Chrome"==sysInfo$3().runtime.name&&Number(sysInfo$3().runtime.version)<=56&&(this.constraints.video={width:1280,heigth:720,framerate:30},this.constraints.audio=!0);}async createStream(e,t){if(!this.setInfo.isHangup){if(await this.setConfig(e,t),this.constraints.audio||this.constraints.video){var i=e?{video:this.constraints.video}:{audio:this.constraints.audio};return i.video&&i.video.deviceId&&1==i.video.deviceId.exact&&(i.video=!0),i.video&&"boolean"==typeof i.video?i.video={aspectRatio:1.7777777778}:i.video&&"boolean"!=typeof i.video&&(i.video=Object.assign(i.video,{aspectRatio:1.7777777778})),console.log(i),console.log("-----------------------------"),new Promise((t,e)=>{navigator.getMedia=navigator.getUserMedia||navigator.webkitGetUserMedia||navigator.mozGetUserMedia||navigator.msGetUserMedia,navigator.mediaDevices&&navigator.mediaDevices.getUserMedia?(console.log(i),navigator.mediaDevices.getUserMedia(i).then(async e=>{t(this.getMediaStreamSuccess(e));}).catch(e=>{console.log(e),t({code:1,info:e});})):navigator.getMedia?navigator.getMedia(i).then(async e=>{t(this.getMediaStreamSuccess(e));}).catch(e=>{t({code:1,info:e});}):t({code:1,info:"浏览器不支持"});})}return new Promise((e,t)=>{e(!1);})}}async getMediaStreamSuccess(e){var t=e.getVideoTracks()[0],i=e.getAudioTracks()[0];if(t||i)return t&&await this.setVideoConstraints(e,0),e;return e}async createVideoorAudioStream(s,o,a){if(!this.setInfo.isHangup){await this.setUp.updateDeviceList();let n="video"==o?this.setUp.VideoInputList:this.setUp.AudioInputList;return new Promise(async(e,t)=>{var i,r;i="changeDevice"==a?"video"==o?await this.createStream(s,null):await this.createStream(null,s):await this.getUsableDevide(n,o),console.log(i),i&&i.code?t(i):(this.publishLocal.publishStream?(t="video"==o?(r=!!this.publishLocal.publishStream.getVideoTracks&&this.publishLocal.publishStream.getVideoTracks()[0],i.getVideoTracks()[0]):(r=!!this.publishLocal.publishStream.getAudioTracks&&this.publishLocal.publishStream.getAudioTracks()[0],i.getAudioTracks()[0]),r&&(this.publishLocal.publishStream.removeTrack(r),r.stop()),this.publishLocal.publishStream.addTrack(t)):this.publishLocal.publishStream=i,e());})}}async getMediaStreamErr(e){return await checkDeviceSupport((e,t,i,r)=>{this.setInfo.video=this.setInfo.video&&e&&r,this.setInfo.audio=this.setInfo.audio&&t&&i;}),"NotFoundError"==e.name||"NotAllowedError"==e.name||"NotReadableError"==e.name?("Could not start video source"==e.message&&(this.setInfo.isVideoSource||(this.setInfo.video=!1),this.setInfo.isVideoSource=!1),"Could not start audio source"==e.message&&(this.setInfo.audio=!1),console.log(this.setInfo),await this.createStream(null,null)):"OverconstrainedError"!=e.name||e.message?void 0:await this.createStream(null,null)}_publishLocalStream(n,s){return new Promise(async(t,i)=>{var e,r;this.publishLocal.publishStream?(e=new Base.LocalStream(this.publishLocal.publishStream,new Base.StreamSourceInfo(Base.AudioSourceInfo.MIC,Base.VideoSourceInfo.CAMERA)),r="Firefox"==sysInfo$3().runtime.name?"vp8":"h264",this.conference&&this.conference.publish?(n=!!n&&[{codec:{name:r,profile:""},maxBitrate:2e3}],s=!!s,this.conference.publish(e,{video:n,audio:s}).then(async e=>{this.publishLocal.publication&&this.publishLocal.publication.stop(),this.publishLocal.publication=e,this.setVideoRtpParameters(0),e.addEventListener("ended",e=>{this.publishLocal.isPublishIng||this.publicLocalended(e);}),e.addEventListener("error",e=>{console.log(e),this.publishLocal.isPublishIng||this.publicLocalended(e);}),t(this.publishLocal.publication);}).catch(e=>{i(e);})):this.setTrackStop()):t(!1);})}publishLocalStream(e,r){return this.publishLocal.isPublishIng=!0,new Promise((t,i)=>{this._publishLocalStream(e,r).then(e=>{this.publishLocal.isPublishIng=!1,t(e);}).catch(e=>{i({code:1,errInfo:"发布不成功"});});})}async createShareStream(e){let i=await Base.MediaStreamFactory.createMediaStream(e);return new Promise(async(e,t)=>{i.code||await this.setApplyConstraints(i,{frameRate:{exact:15}}),e(i);})}publishShareScreen(r){return new Promise(async(t,i)=>{if(this.publishShare.isPublishIng=!0,this.publishShare.shareStream=await this.createShareStream(r).catch(e=>e),this.publishShare.shareStream.code&&"mac"==sysInfo$3().os.name)return this.publishShare.isPublishIng=!1,void t({code:1});this.publishShare.isPublishIng=!1;var e=new Base.LocalStream(this.publishShare.shareStream,new Base.StreamSourceInfo("screen-cast","screen-cast"));this.conference.publish(e,{video:[{codec:{name:"vp8",profile:""},frameRate:15,maxBitrate:4096}]}).then(async e=>{this.publishShare.publication=e,await this.setVideoRtpParameters(1),t(this.publishShare.publication),e.addEventListener("ended",e=>{console.log("屏幕共享流结束："),console.log(e);});}).catch(e=>{i(e);});},e=>{reject(e),console.log("Failed to PUBLISH SCREENSHARESTREAM, "+e);})}_SubscribeMixStream(r,e){return new Promise((t,i)=>{var e="Firefox"==sysInfo$3().runtime.name?"vp8":"h264";this.conference.subscribe(r,{video:{codecs:[{name:e}]}}).then(async e=>{this.subscribeMixed.subscription&&this.subscribeMixed.subscription.stop(),r=Object.assign(r,{mixedStream:r.mediaStream,subscription:e}),t(r),console.log(r.mixedStream.getVideoTracks()[0]),e.addEventListener("ended",()=>{this.subscribeMixed.isSubscribeIng||this.subscribeMixended(r);}),e.addEventListener("error",e=>{console.log(e),this.subscribeMixed.isSubscribeIng||this.subscribeMixended(r);}),e.addEventListener("iceStatusChange",e=>{console.log(e),this.iceStatusChange(e.iceStatus);});}).catch(e=>{i(e),console.log("订阅失败:"+e);});})}SubscribeMixStream(e,t){return this.subscribeMixed.subStream=e,this.subscribeMixed.isSubscribeIng=!0,new Promise((t,i)=>{this._SubscribeMixStream(e).then(e=>{this.subscribeMixed.subscription=e.subscription,this.subscribeMixed.mixedStream=e.mixedStream,this.subscribeMixed.isSubscribeIng=!1,t(e);}).catch(e=>{i({code:1,info:e});});})}SubscribeShareStream(r,e){let n=e||!0;return new Promise((t,i)=>{this.conference.subscribe(r,{audio:!1,video:n}).then(e=>{this.subscribeShare.subscription=e,r=Object.assign(r,{streamsrc:r.mediaStream,subscription:e}),t(r),e.addEventListener("ended",()=>{this.subscribeShareended(r);}),e.addEventListener("error",()=>{this.subscribeShareended(r);});}).catch(e=>{i(e),console.log("订阅失败:"+e);});})}SubscribeOneVideo(r,e){let n=e||!0;return new Promise((i,t)=>{this.conference.subscribe(r,{audio:!1,video:n}).then(e=>{let t=Object.assign(r,{streamsrc:r.mediaStream,subscription:e});this.subscribeRemote.remoteStream=t,this.subscribeRemote.subscription=e,i(t),e.addEventListener("ended",()=>{this.subscribeRemoteended(t);});}).catch(e=>{t(e),console.log("订阅单路视频失败:"+e);});})}setAudioConstraints(i){let r=i.getAudioTracks()[0];r.getCapabilities();var n={autoGainControl:!1,echoCancellation:!0,noiseSuppression:!0};return new Promise((t,e)=>{r.applyConstraints(n).then(e=>{t(i),console.log(i.getAudioTracks()[0].getSettings());}).catch(e=>{t(i);});})}async setVideoConstraints(e,t,i){let r=e.getVideoTracks()[0];var n=null;if("Firefox"==sysInfo$3().runtime.name)n={width:{min:640,ideal:1280},height:{min:360,ideal:720},advanced:[{width:1280,height:720},{aspectRatio:1.7777777778}]};else {if(!r.getCapabilities)return;var s,o=0==t?30:15;let e={width:1280<(s=r.getCapabilities().width?r.getCapabilities():{width:{max:1280},height:{max:720}}).width.max?1280:s.width.max,height:720<s.height.max?720:s.height.max};"360p"==i&&640<e.width&&360<e.height?(e.width=640,e.height=360):"720p"==i&&1280<e.width&&720<e.height?(e.width=1280,e.height=720):"1080p"==i&&1920<e.width&&1080<e.height&&(e.width=1920,e.height=1080),n={width:{min:e.width,ideal:e.width,max:e.width},height:{min:9*e.width/16,ideal:9*e.width/16,max:9*e.width/16},frameRate:{ideal:o},advanced:[{frameRate:{ideal:o}}],aspectRatio:1.7777777778};}return 0==t&&(n.aspectRatio=1.7777777778),this.setApplyConstraints(e,n)}setApplyConstraints(i,r){let n=i.getVideoTracks()[0];return new Promise((t,e)=>{n.applyConstraints(r).then(e=>{console.log(videsoTrack.getSettings()),t(i);}).catch(e=>{t(i);});})}setDegradation(e,t){let i=(0==t?this.publishLocal:this.publishShare).publication;i.getSenders().forEach(async e=>{var t;"video"==e.track.kind&&(t=e.getParameters(),console.log(t),await e.setParameters(t),console.log(e.getParameters()));});}setVideoRtpParameters(i){let e=(0==i?this.publishLocal:this.publishShare).publication;e.getSenders().forEach(async e=>{if("video"==e.track.kind){if(e.getParameters){const t=e.getParameters();t.encodings&&(t.encodings.forEach(e=>{e.maxBitrate=0==i?15e5:2e6,e.maxFramerate=0==i?30:15;}),await e.setParameters(t));}}else "audio"==e.track.kind&&e.getParameters&&(e=e.getParameters(),console.log(e));});}async getSendStatus(t){let i=[],r={audio:null,video:null};if(t&&t.getStats){let e=await t.getStats();if("Firefox"==sysInfo$3().runtime.name)for(const n of e.values())"outbound-rtp"===n.type&&("video"==n.kind?r.video=n:r.audio=n);else e.forEach(e=>{i.push(e);}),i.forEach(e=>{e.mediaType&&"audio"==e.mediaType?r.audio=e:e.mediaType&&"video"==e.mediaType&&(r.video=e);});return r}}async getReceiveStats(t){let i=[],r={audio:null,video:null};if(t&&t.getStats){let e=await t.getStats();if("Firefox"==sysInfo$3().runtime.name)for(const n of e.values())"inbound-rtp"===n.type&&("video"==n.kind?r.video=n:r.audio=n);else e.forEach(e=>{i.push(e);}),i.forEach(e=>{e.mediaType&&"audio"==e.mediaType?(r.audio=e,r.audio.lostpacketrate=parseInt(e.packetsLost/(e.packetsLost+e.packetsReceived)*100)):e.mediaType&&"video"==e.mediaType&&(r.video=e,r.video.lostpacketrate=parseInt(e.packetsLost/(e.packetsLost+e.packetsReceived)*100));});return r}}async getReceiverCsrc(e){window.requestAnimationFrame(this.getReceiverCsrc.bind(this)),this.subscribeMixed.subscription&&this.subscribeMixed.subscription.getReceivers&&this.subscribeMixed.subscription.getReceivers().forEach(async e=>{if("audio"==e.track.kind){var r;r="Firefox"==sysInfo$3().runtime.name?e.getContributingSources().sort((e,t)=>{e=e.timestamp;return t.timestamp-e}):e.getContributingSources().reverse();var n=[],t=r.find(e=>0!=e.source&&e.source<=3);t&&((r=r.filter(e=>e.timestamp==t.timestamp)).forEach((e,t)=>{var i;0==t||(i=4294967295&r[0].source)&&t<=i&&n.push({ptid:65535&e.source,voiceNum:e.source>>16});}),JSON.stringify(n)!==JSON.stringify(this.receiverCsrc.audio)&&(this.receiverCsrc.audio=n,this.voiceStimulationChange({data:n})));}else if("Firefox"!=sysInfo$3().runtime.name){var i=(l="Safari"==sysInfo$3().runtime.name?e.getContributingSources().reverse().sort((e,t)=>{e=e.timestamp;return t.timestamp-e}):e.getContributingSources().reverse().sort((e,t)=>{e=e.rtpTimestamp;return t.rtpTimestamp-e})).find(e=>e.source<=100);if(i&&!(0!=(l="Safari"==sysInfo$3().runtime.name?l.filter(e=>e.timestamp==i.timestamp):l.filter(e=>e.rtpTimestamp==i.rtpTimestamp)).length&&0!=this.receiverCsrc.videoCsrc.length&&l[0].timestamp<this.receiverCsrc.videoCsrc[0].timestamp)){this.receiverCsrc.videoCsrc=l;var s=[],o=null,a=null;if(100<l[0].source&&l[l.length-1].source<100&&(l.unshift(l[l.length-1]),l.splice(l.length,1)),0==l[0].source)this.videoLayoutChange({layoutList:[],layoutId:a});else {l.forEach((e,t)=>{a=JSON.stringify(255&l[0].source),0!=t&&(t%3==1?(s.push(4095&e.source),s.push(e.source>>12&4095),o=e.source>>24&255):t%3==2?(o=(15&e.source)<<8|o,s.push(o),s.push(e.source>>4&4095),s.push(e.source>>16&4095),o=e.source>>28&15):t%3==0&&(o=(255&e.source)<<4|o,s.push(o),s.push(e.source>>8&4095),s.push(e.source>>20&4095),o=null));});var c,u,d=[];if(s.forEach(t=>{if(0!=t){let e=parseInt((Array(12).join(0)+t.toString(2)).slice(-10),2);var i=(Array(12).join(0)+t.toString(2)).slice(-11,-10),t=(Array(12).join(0)+t.toString(2)).slice(-12,-11);"0"==i&&"0"==t&&(e=-1),d.push({ptid:e,fixed:"0"!=i,exitCamera:"0"!=t});}else d.push({ptid:-1,fixed:!1,exitCamera:!1});}),a==this.receiverCsrc.layoutId&&JSON.stringify(d)==JSON.stringify(this.receiverCsrc.video))return;this.receiverCsrc.video=d,this.receiverCsrc.layoutId=a,0==this.receiverCsrc.allLayoutDataList.length||(u=(u=this.receiverCsrc.allLayoutDataList.find(e=>e.id==a))||videoDefaultLayout.layout.find(e=>e.id==a))&&(c=[],(u=JSON.parse(JSON.stringify(u))).region.forEach((e,t)=>{this.receiverCsrc.video[t]?c.push({region:e,ptid:this.receiverCsrc.video[t].ptid,fixed:this.receiverCsrc.video[t].fixed,exitCamera:this.receiverCsrc.video[t].exitCamera}):c.push({region:e,ptid:-1,fixed:!1,exitCamera:!1});}));}c&&this.videoLayoutChange({layoutList:c,layoutId:a});}}else var l=e.getContributingSources().sort((e,t)=>{e=e.timestamp;return t.timestamp-e});});}async getReceiveVideoPacketLostData(t){var i=await this.getReceiveStats(t);if(i&&i.video){t=Number(i.video.googNacksSent)?Number(i.video.googNacksSent):Number(i.video.packetsLost);let e=Number(i.video.packetsReceived)-Number(i.video.packetsLost);return e=e<0?0:e,{bytesReceived:i.video.bytesReceived,packetLost:t,packetLostTotal:e,height:parseInt(i.video.googFrameHeightReceived),frameRate:parseInt(i.video.googFrameRateDecoded||i.video.framerateMean)}}return !1}async getSendVideoPacketLostData(e){e=await this.getSendStatus(e);return !(!e||!e.video)&&{frameRate:parseInt(e.video.googFrameRateSent||e.video.framerateMean),bytesSent:e.video.bytesSent}}changeDevice(e,t){e.getSenders().forEach(e=>{"audio"==e.track.kind?e.replaceTrack(t.getAudioTracks()[0]):"video"==e.track.kind&&e.replaceTrack(t.getVideoTracks()[0]);});}setTrackStop(){if(this.publishLocal.publishStream&&!this.publishLocal.publishStream.code){var t=this.publishLocal.publishStream.getTracks();this.publishLocal.publishStream.getVideoTracks()[0]&&this.publishLocal.publishStream.getVideoTracks()[0].stop(),this.publishLocal.publishStream.getAudioTracks()[0]&&this.publishLocal.publishStream.getAudioTracks()[0].stop();for(let e=0;e<t.length;e++)t[e].enabled=!1,t[e].stop(),this.publishLocal.publishStream.removeTrack(t[e]);this.publishLocal.publishStream=null;}}addEventTrackEnded(){let e=this.publishLocal&&this.publishLocal.publishStream&&this.publishLocal.publishStream.getAudioTracks&&this.publishLocal.publishStream.getAudioTracks()[0],t=this.publishLocal&&this.publishLocal.publishStream&&this.publishLocal.publishStream.getVideoTracks&&this.publishLocal.publishStream.getVideoTracks()[0];e&&e.addEventListener("ended",this.audioTrackEnded),t&&t.addEventListener("ended",this.videoTrackEnded);}cancelPublish(){this.publishLocal.publication&&(this.publishLocal.publication.stop(),this.publishLocal.publication=null);}eventListener(){this.conference.addEventListener("streamadded",async e=>{var t=e.stream;this.streamadded(t),e.stream.addEventListener("ended",()=>{this.streamended(e.stream);});}),this.conference.addEventListener("participantjoined",e=>{e.participant.addEventListener("left",()=>{this.participantleave(e.participant);}),this.participantjoined(e.participant);}),this.conference.addEventListener("messagereceived",e=>{this.messagereceived(e);}),this.conference.addEventListener("serverdisconnected",e=>{console.log(e),this.recollectfailed(e);}),this.conference.addEventListener("relogin",e=>{console.log(e),e.room.participants.forEach(e=>{e.addEventListener("left",()=>{this.participantleave(e);});}),e.room.remoteStreams.forEach(e=>{e.addEventListener("ended",()=>{this.streamended(e);});}),this.relogin(e);}),this.conference.addEventListener("owt_reconnect_success",e=>{console.log("owt_reconnect_success");}),this.conference.addEventListener("reconnect_failed",e=>{this.recollectfailed(e);}),this.conference.addEventListener("audiostatuschange",e=>{this.audiostatuschange(e.info);}),this.conference.addEventListener("roomstatuschange",e=>{this.roomStatusChange(e);}),this.conference.addEventListener("exitRoom",e=>{console.log(e),this.exitRoomEvent(e);}),this.conference.addEventListener("iceClose",e=>{console.log(e);}),this.conference.addEventListener("recording",e=>{this.recordMsgEvent(e);});}findParticipant(e,t){return e.find(e=>e.id==t.origin)}clearEventListener(){this.conference&&this.conference.clearEventListener&&this.conference.clearEventListener("streamadded"),this.conference&&this.conference.clearEventListener&&this.conference.clearEventListener("messagereceived"),this.conference&&this.conference.clearEventListener&&this.conference.clearEventListener("serverdisconnected"),this.conference&&this.conference.clearEventListener&&this.conference.clearEventListener("audiostatuschange"),this.conference&&this.conference.clearEventListener&&this.conference.clearEventListener("roomstatuschange"),this.conference&&this.conference.clearEventListener&&this.conference.clearEventListener("exitRoom"),this.conference&&this.conference.clearEventListener&&this.conference.clearEventListener("iceClose"),this.publishLocal.publication&&this.publishLocal.publication.clearEventListener&&this.publishLocal.publication.clearEventListener("ended"),this.publishLocal.publication&&this.publishLocal.publication.clearEventListener&&this.publishLocal.publication.clearEventListener("error"),this.subscribeMixed.subscription&&this.subscribeMixed.subscription.clearEventListener&&this.subscribeMixed.subscription.clearEventListener("ended"),this.subscribeMixed.subscription&&this.subscribeMixed.subscription.clearEventListener&&this.subscribeMixed.subscription.clearEventListener("error"),this.subscribeRemote.subscription&&this.subscribeRemote.subscription.clearEventListener&&this.subscribeRemote.subscription.clearEventListener("ended"),this.subscribeShare.subscription&&this.subscribeShare.subscription.clearEventListener&&this.subscribeShare.subscription.clearEventListener("ended"),this.subscribeShare.subscription&&this.subscribeShare.subscription.clearEventListener&&this.subscribeShare.subscription.clearEventListener("error"),this.publishShare.publication&&this.publishShare.publication.clearEventListener&&this.publishShare.publication.clearEventListener("ended"),this.publishShare.publication&&this.publishShare.publication.clearEventListener&&this.publishShare.publication.clearEventListener("error");}filterAllStreams(e,t){console.log(e);var i=e.find(e=>e.origin==t.origin);i||e.push(t);}createAudioContext(e){window.AudioContext=window.AudioContext||window.webkitAudioContext||window.mozAudioContext||window.msAudioContext;var t=new window.AudioContext,i=t.createMediaStreamSource(e),e=t.createBiquadFilter();e.frequency.value=1e3,e.gain.value=8,i.connect(e),e.connect(t.destination),t.resume&&t.resume();}}return new e}var bind=function(i,r){return function(){for(var e=new Array(arguments.length),t=0;t<e.length;t++)e[t]=arguments[t];return i.apply(r,e)}},toString=Object.prototype.toString;function isArray(e){return "[object Array]"===toString.call(e)}function isUndefined(e){return void 0===e}function isBuffer(e){return null!==e&&!isUndefined(e)&&null!==e.constructor&&!isUndefined(e.constructor)&&"function"==typeof e.constructor.isBuffer&&e.constructor.isBuffer(e)}function isArrayBuffer(e){return "[object ArrayBuffer]"===toString.call(e)}function isFormData(e){return "undefined"!=typeof FormData&&e instanceof FormData}function isArrayBufferView(e){return e="undefined"!=typeof ArrayBuffer&&ArrayBuffer.isView?ArrayBuffer.isView(e):e&&e.buffer&&e.buffer instanceof ArrayBuffer}function isString(e){return "string"==typeof e}function isNumber(e){return "number"==typeof e}function isObject(e){return null!==e&&"object"==typeof e}function isPlainObject(e){return "[object Object]"===toString.call(e)&&(null===(e=Object.getPrototypeOf(e))||e===Object.prototype)}function isDate(e){return "[object Date]"===toString.call(e)}function isFile(e){return "[object File]"===toString.call(e)}function isBlob(e){return "[object Blob]"===toString.call(e)}function isFunction(e){return "[object Function]"===toString.call(e)}function isStream(e){return isObject(e)&&isFunction(e.pipe)}function isURLSearchParams(e){return "undefined"!=typeof URLSearchParams&&e instanceof URLSearchParams}function trim(e){return e.trim?e.trim():e.replace(/^\s+|\s+$/g,"")}function isStandardBrowserEnv(){return ("undefined"==typeof navigator||"ReactNative"!==navigator.product&&"NativeScript"!==navigator.product&&"NS"!==navigator.product)&&"undefined"!=typeof window&&"undefined"!=typeof document}function forEach(e,t){if(null!=e)if(isArray(e="object"!=typeof e?[e]:e))for(var i=0,r=e.length;i<r;i++)t.call(null,e[i],i,e);else for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&t.call(null,e[n],n,e);}function merge(){var i={};function e(e,t){isPlainObject(i[t])&&isPlainObject(e)?i[t]=merge(i[t],e):isPlainObject(e)?i[t]=merge({},e):isArray(e)?i[t]=e.slice():i[t]=e;}for(var t=0,r=arguments.length;t<r;t++)forEach(arguments[t],e);return i}function extend(i,e,r){return forEach(e,function(e,t){i[t]=r&&"function"==typeof e?bind(e,r):e;}),i}function stripBOM(e){return 65279===e.charCodeAt(0)?e.slice(1):e}var utils={isArray:isArray,isArrayBuffer:isArrayBuffer,isBuffer:isBuffer,isFormData:isFormData,isArrayBufferView:isArrayBufferView,isString:isString,isNumber:isNumber,isObject:isObject,isPlainObject:isPlainObject,isUndefined:isUndefined,isDate:isDate,isFile:isFile,isBlob:isBlob,isFunction:isFunction,isStream:isStream,isURLSearchParams:isURLSearchParams,isStandardBrowserEnv:isStandardBrowserEnv,forEach:forEach,merge:merge,extend:extend,trim:trim,stripBOM:stripBOM};function encode$1(e){return encodeURIComponent(e).replace(/%3A/gi,":").replace(/%24/g,"$").replace(/%2C/gi,",").replace(/%20/g,"+").replace(/%5B/gi,"[").replace(/%5D/gi,"]")}var buildURL=function(e,t,i){return t&&(i=i?i(t):utils.isURLSearchParams(t)?t.toString():(r=[],utils.forEach(t,function(e,t){null!=e&&(utils.isArray(e)?t+="[]":e=[e],utils.forEach(e,function(e){utils.isDate(e)?e=e.toISOString():utils.isObject(e)&&(e=JSON.stringify(e)),r.push(encode$1(t)+"="+encode$1(e));}));}),r.join("&")))&&(-1!==(t=e.indexOf("#"))&&(e=e.slice(0,t)),e+=(-1===e.indexOf("?")?"?":"&")+i),e;var r;};function InterceptorManager(){this.handlers=[];}InterceptorManager.prototype.use=function(e,t,i){return this.handlers.push({fulfilled:e,rejected:t,synchronous:!!i&&i.synchronous,runWhen:i?i.runWhen:null}),this.handlers.length-1},InterceptorManager.prototype.eject=function(e){this.handlers[e]&&(this.handlers[e]=null);},InterceptorManager.prototype.forEach=function(t){utils.forEach(this.handlers,function(e){null!==e&&t(e);});};var InterceptorManager_1=InterceptorManager,normalizeHeaderName=function(i,r){utils.forEach(i,function(e,t){t!==r&&t.toUpperCase()===r.toUpperCase()&&(i[r]=e,delete i[t]);});},enhanceError=function(e,t,i,r,n){return e.config=t,i&&(e.code=i),e.request=r,e.response=n,e.isAxiosError=!0,e.toJSON=function(){return {message:this.message,name:this.name,description:this.description,number:this.number,fileName:this.fileName,lineNumber:this.lineNumber,columnNumber:this.columnNumber,stack:this.stack,config:this.config,code:this.code}},e},createError=function(e,t,i,r,n){return e=new Error(e),enhanceError(e,t,i,r,n)},settle=function(e,t,i){var r=i.config.validateStatus;i.status&&r&&!r(i.status)?t(createError("Request failed with status code "+i.status,i.config,null,i.request,i)):e(i);},cookies=utils.isStandardBrowserEnv()?{write:function(e,t,i,r,n,s){var o=[];o.push(e+"="+encodeURIComponent(t)),utils.isNumber(i)&&o.push("expires="+new Date(i).toGMTString()),utils.isString(r)&&o.push("path="+r),utils.isString(n)&&o.push("domain="+n),!0===s&&o.push("secure"),document.cookie=o.join("; ");},read:function(e){return (e=document.cookie.match(new RegExp("(^|;\\s*)("+e+")=([^;]*)")))?decodeURIComponent(e[3]):null},remove:function(e){this.write(e,"",Date.now()-864e5);}}:{write:function(){},read:function(){return null},remove:function(){}},isAbsoluteURL=function(e){return /^([a-z][a-z\d\+\-\.]*:)?\/\//i.test(e)},combineURLs=function(e,t){return t?e.replace(/\/+$/,"")+"/"+t.replace(/^\/+/,""):e},buildFullPath=function(e,t){return e&&!isAbsoluteURL(t)?combineURLs(e,t):t},ignoreDuplicateOf=["age","authorization","content-length","content-type","etag","expires","from","host","if-modified-since","if-unmodified-since","last-modified","location","max-forwards","proxy-authorization","referer","retry-after","user-agent"],parseHeaders=function(e){var t,i,r={};return e&&utils.forEach(e.split("\n"),function(e){i=e.indexOf(":"),t=utils.trim(e.substr(0,i)).toLowerCase(),i=utils.trim(e.substr(i+1)),t&&(r[t]&&0<=ignoreDuplicateOf.indexOf(t)||(r[t]="set-cookie"===t?(r[t]||[]).concat([i]):r[t]?r[t]+", "+i:i));}),r},isURLSameOrigin=utils.isStandardBrowserEnv()?function(){var t,i=/(msie|trident)/i.test(navigator.userAgent),r=document.createElement("a");function n(e){return i&&(r.setAttribute("href",e),e=r.href),r.setAttribute("href",e),{href:r.href,protocol:r.protocol?r.protocol.replace(/:$/,""):"",host:r.host,search:r.search?r.search.replace(/^\?/,""):"",hash:r.hash?r.hash.replace(/^#/,""):"",hostname:r.hostname,port:r.port,pathname:"/"===r.pathname.charAt(0)?r.pathname:"/"+r.pathname}}return t=n(window.location.href),function(e){return (e=utils.isString(e)?n(e):e).protocol===t.protocol&&e.host===t.host}}():function(){return !0},xhr=function(u){return new Promise(function(t,i){var r=u.data,n=u.headers,s=u.responseType;utils.isFormData(r)&&delete n["Content-Type"];var e,o=new XMLHttpRequest;u.auth&&(e=u.auth.username||"",a=u.auth.password?unescape(encodeURIComponent(u.auth.password)):"",n.Authorization="Basic "+btoa(e+":"+a));var a=buildFullPath(u.baseURL,u.url);function c(){var e;o&&(e="getAllResponseHeaders"in o?parseHeaders(o.getAllResponseHeaders()):null,e={data:s&&"text"!==s&&"json"!==s?o.response:o.responseText,status:o.status,statusText:o.statusText,headers:e,config:u,request:o},settle(t,i,e),o=null);}o.open(u.method.toUpperCase(),buildURL(a,u.params,u.paramsSerializer),!0),o.timeout=u.timeout,"onloadend"in o?o.onloadend=c:o.onreadystatechange=function(){o&&4===o.readyState&&(0!==o.status||o.responseURL&&0===o.responseURL.indexOf("file:"))&&setTimeout(c);},o.onabort=function(){o&&(i(createError("Request aborted",u,"ECONNABORTED",o)),o=null);},o.onerror=function(){i(createError("Network Error",u,null,o)),o=null;},o.ontimeout=function(){var e="timeout of "+u.timeout+"ms exceeded";u.timeoutErrorMessage&&(e=u.timeoutErrorMessage),i(createError(e,u,u.transitional&&u.transitional.clarifyTimeoutError?"ETIMEDOUT":"ECONNABORTED",o)),o=null;},!utils.isStandardBrowserEnv()||(a=(u.withCredentials||isURLSameOrigin(a))&&u.xsrfCookieName?cookies.read(u.xsrfCookieName):void 0)&&(n[u.xsrfHeaderName]=a),"setRequestHeader"in o&&utils.forEach(n,function(e,t){void 0===r&&"content-type"===t.toLowerCase()?delete n[t]:o.setRequestHeader(t,e);}),utils.isUndefined(u.withCredentials)||(o.withCredentials=!!u.withCredentials),s&&"json"!==s&&(o.responseType=u.responseType),"function"==typeof u.onDownloadProgress&&o.addEventListener("progress",u.onDownloadProgress),"function"==typeof u.onUploadProgress&&o.upload&&o.upload.addEventListener("progress",u.onUploadProgress),u.cancelToken&&u.cancelToken.promise.then(function(e){o&&(o.abort(),i(e),o=null);}),r=r||null,o.send(r);})},DEFAULT_CONTENT_TYPE={"Content-Type":"application/x-www-form-urlencoded"};function setContentTypeIfUnset(e,t){!utils.isUndefined(e)&&utils.isUndefined(e["Content-Type"])&&(e["Content-Type"]=t);}function getDefaultAdapter(){var e;return "undefined"!=typeof XMLHttpRequest||"undefined"!=typeof process&&"[object process]"===Object.prototype.toString.call(process)?xhr:e}function stringifySafely(e,t,i){if(utils.isString(e))try{return (t||JSON.parse)(e),utils.trim(e)}catch(e){if("SyntaxError"!==e.name)throw e}return (i||JSON.stringify)(e)}var defaults={transitional:{silentJSONParsing:!0,forcedJSONParsing:!0,clarifyTimeoutError:!1},adapter:getDefaultAdapter(),transformRequest:[function(e,t){return normalizeHeaderName(t,"Accept"),normalizeHeaderName(t,"Content-Type"),utils.isFormData(e)||utils.isArrayBuffer(e)||utils.isBuffer(e)||utils.isStream(e)||utils.isFile(e)||utils.isBlob(e)?e:utils.isArrayBufferView(e)?e.buffer:utils.isURLSearchParams(e)?(setContentTypeIfUnset(t,"application/x-www-form-urlencoded;charset=utf-8"),e.toString()):utils.isObject(e)||t&&"application/json"===t["Content-Type"]?(setContentTypeIfUnset(t,"application/json"),stringifySafely(e)):e}],transformResponse:[function(e){var t=(i=this.transitional)&&i.silentJSONParsing,i=i&&i.forcedJSONParsing;if((t=!t&&"json"===this.responseType)||i&&utils.isString(e)&&e.length)try{return JSON.parse(e)}catch(e){if(t){if("SyntaxError"===e.name)throw enhanceError(e,this,"E_JSON_PARSE");throw e}}return e}],timeout:0,xsrfCookieName:"XSRF-TOKEN",xsrfHeaderName:"X-XSRF-TOKEN",maxContentLength:-1,maxBodyLength:-1,validateStatus:function(e){return 200<=e&&e<300},headers:{common:{Accept:"application/json, text/plain, */*"}}};utils.forEach(["delete","get","head"],function(e){defaults.headers[e]={};}),utils.forEach(["post","put","patch"],function(e){defaults.headers[e]=utils.merge(DEFAULT_CONTENT_TYPE);});var defaults_1=defaults,transformData=function(t,i,e){var r=this||defaults_1;return utils.forEach(e,function(e){t=e.call(r,t,i);}),t},isCancel=function(e){return !(!e||!e.__CANCEL__)};function throwIfCancellationRequested(e){e.cancelToken&&e.cancelToken.throwIfRequested();}var dispatchRequest=function(t){return throwIfCancellationRequested(t),t.headers=t.headers||{},t.data=transformData.call(t,t.data,t.headers,t.transformRequest),t.headers=utils.merge(t.headers.common||{},t.headers[t.method]||{},t.headers),utils.forEach(["delete","get","head","post","put","patch","common"],function(e){delete t.headers[e];}),(t.adapter||defaults_1.adapter)(t).then(function(e){return throwIfCancellationRequested(t),e.data=transformData.call(t,e.data,e.headers,t.transformResponse),e},function(e){return isCancel(e)||(throwIfCancellationRequested(t),e&&e.response&&(e.response.data=transformData.call(t,e.response.data,e.response.headers,t.transformResponse))),Promise.reject(e)})},mergeConfig=function(t,i){i=i||{};var r={},e=["url","method","data"],n=["headers","auth","proxy","params"],s=["baseURL","transformRequest","transformResponse","paramsSerializer","timeout","timeoutMessage","withCredentials","adapter","responseType","xsrfCookieName","xsrfHeaderName","onUploadProgress","onDownloadProgress","decompress","maxContentLength","maxBodyLength","maxRedirects","transport","httpAgent","httpsAgent","cancelToken","socketPath","responseEncoding"],o=["validateStatus"];function a(e,t){return utils.isPlainObject(e)&&utils.isPlainObject(t)?utils.merge(e,t):utils.isPlainObject(t)?utils.merge({},t):utils.isArray(t)?t.slice():t}function c(e){utils.isUndefined(i[e])?utils.isUndefined(t[e])||(r[e]=a(void 0,t[e])):r[e]=a(t[e],i[e]);}utils.forEach(e,function(e){utils.isUndefined(i[e])||(r[e]=a(void 0,i[e]));}),utils.forEach(n,c),utils.forEach(s,function(e){utils.isUndefined(i[e])?utils.isUndefined(t[e])||(r[e]=a(void 0,t[e])):r[e]=a(void 0,i[e]);}),utils.forEach(o,function(e){e in i?r[e]=a(t[e],i[e]):e in t&&(r[e]=a(void 0,t[e]));});var u=e.concat(n).concat(s).concat(o),o=Object.keys(t).concat(Object.keys(i)).filter(function(e){return -1===u.indexOf(e)});return utils.forEach(o,c),r},name="axios",version$1="0.21.4",description="Promise based HTTP client for the browser and node.js",main="index.js",scripts={test:"grunt test",start:"node ./sandbox/server.js",build:"NODE_ENV=production grunt build",preversion:"npm test",version:"npm run build && grunt version && git add -A dist && git add CHANGELOG.md bower.json package.json",postversion:"git push && git push --tags",examples:"node ./examples/server.js",coveralls:"cat coverage/lcov.info | ./node_modules/coveralls/bin/coveralls.js",fix:"eslint --fix lib/**/*.js"},repository={type:"git",url:"https://github.com/axios/axios.git"},keywords=["xhr","http","ajax","promise","node"],author="Matt Zabriskie",license="MIT",bugs={url:"https://github.com/axios/axios/issues"},homepage="https://axios-http.com",devDependencies={coveralls:"^3.0.0","es6-promise":"^4.2.4",grunt:"^1.3.0","grunt-banner":"^0.6.0","grunt-cli":"^1.2.0","grunt-contrib-clean":"^1.1.0","grunt-contrib-watch":"^1.0.0","grunt-eslint":"^23.0.0","grunt-karma":"^4.0.0","grunt-mocha-test":"^0.13.3","grunt-ts":"^6.0.0-beta.19","grunt-webpack":"^4.0.2","istanbul-instrumenter-loader":"^1.0.0","jasmine-core":"^2.4.1",karma:"^6.3.2","karma-chrome-launcher":"^3.1.0","karma-firefox-launcher":"^2.1.0","karma-jasmine":"^1.1.1","karma-jasmine-ajax":"^0.1.13","karma-safari-launcher":"^1.0.0","karma-sauce-launcher":"^4.3.6","karma-sinon":"^1.0.5","karma-sourcemap-loader":"^0.3.8","karma-webpack":"^4.0.2","load-grunt-tasks":"^3.5.2",minimist:"^1.2.0",mocha:"^8.2.1",sinon:"^4.5.0","terser-webpack-plugin":"^4.2.3",typescript:"^4.0.5","url-search-params":"^0.10.0",webpack:"^4.44.2","webpack-dev-server":"^3.11.0"},browser={"./lib/adapters/http.js":"./lib/adapters/xhr.js"},jsdelivr="dist/axios.min.js",unpkg="dist/axios.min.js",typings="./index.d.ts",dependencies={"follow-redirects":"^1.14.0"},bundlesize=[{path:"./dist/axios.min.js",threshold:"5kB"}],__npminstall_done="Tue Nov 09 2021 20:37:49 GMT+0800 (中国标准时间)",_from="axios@0.21.4",_resolved="https://registry.npmmirror.com/axios/download/axios-0.21.4.tgz?cache=0&sync_timestamp=1635213986012&other_urls=https%3A%2F%2Fregistry.npmmirror.com%2Faxios%2Fdownload%2Faxios-0.21.4.tgz",_package={name:name,version:version$1,description:description,main:main,scripts:scripts,repository:repository,keywords:keywords,author:author,license:license,bugs:bugs,homepage:homepage,devDependencies:devDependencies,browser:browser,jsdelivr:jsdelivr,unpkg:unpkg,typings:typings,dependencies:dependencies,bundlesize:bundlesize,__npminstall_done:__npminstall_done,_from:_from,_resolved:_resolved},_package$1=Object.freeze({__proto__:null,name:name,version:version$1,description:description,main:main,scripts:scripts,repository:repository,keywords:keywords,author:author,license:license,bugs:bugs,homepage:homepage,devDependencies:devDependencies,browser:browser,jsdelivr:jsdelivr,unpkg:unpkg,typings:typings,dependencies:dependencies,bundlesize:bundlesize,__npminstall_done:__npminstall_done,_from:_from,_resolved:_resolved,default:_package});function getCjsExportFromNamespace(e){return e&&e.default||e}var pkg=getCjsExportFromNamespace(_package$1),validators={};["object","boolean","number","function","string","symbol"].forEach(function(t,i){validators[t]=function(e){return typeof e===t||"a"+(i<1?"n ":" ")+t};});var deprecatedWarnings={},currentVerArr=pkg.version.split(".");function isOlderVersion(e,t){for(var i=t?t.split("."):currentVerArr,r=e.split("."),n=0;n<3;n++){if(i[n]>r[n])return !0;if(i[n]<r[n])return !1}return !1}function assertOptions(e,t,i){if("object"!=typeof e)throw new TypeError("options must be an object");for(var r=Object.keys(e),n=r.length;0<n--;){var s=r[n],o=t[s];if(o){var a=e[s];if(!0!==(a=void 0===a||o(a,s,e)))throw new TypeError("option "+s+" must be "+a)}else if(!0!==i)throw Error("Unknown option "+s)}}validators.transitional=function(r,n,i){var s=n&&isOlderVersion(n);function o(e,t){return "[Axios v"+pkg.version+"] Transitional option '"+e+"'"+t+(i?". "+i:"")}return function(e,t,i){if(!1===r)throw new Error(o(t," has been removed in "+n));return s&&!deprecatedWarnings[t]&&(deprecatedWarnings[t]=!0,console.warn(o(t," has been deprecated since v"+n+" and will be removed in the near future"))),!r||r(e,t,i)}};var validator={isOlderVersion:isOlderVersion,assertOptions:assertOptions,validators:validators},validators$1=validator.validators;function Axios(e){this.defaults=e,this.interceptors={request:new InterceptorManager_1,response:new InterceptorManager_1};}Axios.prototype.request=function(t){"string"==typeof t?(t=arguments[1]||{}).url=arguments[0]:t=t||{},(t=mergeConfig(this.defaults,t)).method?t.method=t.method.toLowerCase():this.defaults.method?t.method=this.defaults.method.toLowerCase():t.method="get";var e=t.transitional;void 0!==e&&validator.assertOptions(e,{silentJSONParsing:validators$1.transitional(validators$1.boolean,"1.0.0"),forcedJSONParsing:validators$1.transitional(validators$1.boolean,"1.0.0"),clarifyTimeoutError:validators$1.transitional(validators$1.boolean,"1.0.0")},!1);var i=[],r=!0;this.interceptors.request.forEach(function(e){"function"==typeof e.runWhen&&!1===e.runWhen(t)||(r=r&&e.synchronous,i.unshift(e.fulfilled,e.rejected));});var n,s=[];if(this.interceptors.response.forEach(function(e){s.push(e.fulfilled,e.rejected);}),!r){var o=[dispatchRequest,void 0];for(Array.prototype.unshift.apply(o,i),o=o.concat(s),n=Promise.resolve(t);o.length;)n=n.then(o.shift(),o.shift());return n}for(var a=t;i.length;){var c=i.shift(),u=i.shift();try{a=c(a);}catch(e){u(e);break}}try{n=dispatchRequest(a);}catch(e){return Promise.reject(e)}for(;s.length;)n=n.then(s.shift(),s.shift());return n},Axios.prototype.getUri=function(e){return e=mergeConfig(this.defaults,e),buildURL(e.url,e.params,e.paramsSerializer).replace(/^\?/,"")},utils.forEach(["delete","get","head","options"],function(i){Axios.prototype[i]=function(e,t){return this.request(mergeConfig(t||{},{method:i,url:e,data:(t||{}).data}))};}),utils.forEach(["post","put","patch"],function(r){Axios.prototype[r]=function(e,t,i){return this.request(mergeConfig(i||{},{method:r,url:e,data:t}))};});var Axios_1=Axios;function Cancel(e){this.message=e;}Cancel.prototype.toString=function(){return "Cancel"+(this.message?": "+this.message:"")},Cancel.prototype.__CANCEL__=!0;var Cancel_1=Cancel;function CancelToken(e){if("function"!=typeof e)throw new TypeError("executor must be a function.");var t;this.promise=new Promise(function(e){t=e;});var i=this;e(function(e){i.reason||(i.reason=new Cancel_1(e),t(i.reason));});}CancelToken.prototype.throwIfRequested=function(){if(this.reason)throw this.reason},CancelToken.source=function(){var t;return {token:new CancelToken(function(e){t=e;}),cancel:t}};var CancelToken_1=CancelToken,spread=function(t){return function(e){return t.apply(null,e)}},isAxiosError=function(e){return "object"==typeof e&&!0===e.isAxiosError};function createInstance(e){var t=new Axios_1(e),e=bind(Axios_1.prototype.request,t);return utils.extend(e,Axios_1.prototype,t),utils.extend(e,t),e}var axios=createInstance(defaults_1);axios.Axios=Axios_1,axios.create=function(e){return createInstance(mergeConfig(axios.defaults,e))},axios.Cancel=Cancel_1,axios.CancelToken=CancelToken_1,axios.isCancel=isCancel,axios.all=function(e){return Promise.all(e)},axios.spread=spread,axios.isAxiosError=isAxiosError;var axios_1=axios,default_1=axios;axios_1.default=default_1;var _axios_0_21_4_axios=axios_1;function fetch(n,s){return console.log(n),new Promise((t,e)=>{var i=Object.assign({"Content-Type":"text/plain;charset=UTF-8"},n.headers);const r=_axios_0_21_4_axios.create({baseURL:s,headers:i,timeout:3e4});r(n.options).then(e=>{t(e),console.log(e);}).catch(e=>{console.log(e),t(e);});})}function fetchJson(n,s,o){return new Promise((t,e)=>{console.log(o);var i=Object.assign({accessToken:o,"Content-Type":"application/json"},n.headers);const r=_axios_0_21_4_axios.create({headers:i,baseURL:s,timeout:3e4});r(n.options).then(e=>{t(e);}).catch(e=>{t(e);});})}function fetchSessionJson(n,s,o){return new Promise((t,e)=>{console.log(o);var i=Object.assign({sessionToken:o,"Content-Type":"application/json"},n.headers);const r=_axios_0_21_4_axios.create({headers:i,baseURL:s,timeout:3e4});r(n.options).then(e=>{t(e);}).catch(e=>{console.log(e),t(e);});})}let accessToken=null,sessionToken=null,appServerUrl=null;function getAccessToken(e,t){appServerUrl=t,e=Object.assign({tag:""},e);let r={options:{url:"/1.0/auth",method:"post",data:JSON.stringify(e)},headers:{"Content-Type":"application/json"}};return new Promise((t,i)=>{fetch(r,appServerUrl).then(e=>{accessToken=e.data.token,t(e.data);}).catch(e=>{console.log(e),i(e);});})}function createRoom(e,t){return e={compere:e.compere,name:e.name,password:{host:"haha",participant:"xixi",visitor:""},templt:0},fetchJson({options:{url:"/1.0/rooms",method:"post",data:JSON.stringify(e)},headers:t},appServerUrl,accessToken)}function getRoomInfo(e){return fetchSessionJson({options:{url:"/1.0/rooms/"+e,method:"get"},headers:{"Content-Type":"application/json"}},appServerUrl,sessionToken)}function joinRoom(e,t,i){console.log(e);let r={options:{url:`/1.0/rooms/${e}/token`,method:"post",data:t},headers:{"Content-Type":"application/json"}};return new Promise((t,i)=>{fetchJson(r,appServerUrl,accessToken).then(e=>{e.data&&e.data.sessionToken?(sessionToken=e.data.sessionToken,t(e.data)):t(e);}).catch(e=>{console.log(e),i(e);});})}function deleteRoom(e,t){return fetchSessionJson({options:{url:"/1.0/rooms/"+e,method:"delete"},headers:t},appServerUrl,sessionToken)}function setDeviceInfos(e,t,i,r){return fetchSessionJson({options:{url:`/1.0/rooms/${e}/streams/`+t,method:"post",data:Object.assign({op:""},i)},headers:r},appServerUrl,sessionToken)}function delParticipant(e,t,i){return fetchSessionJson({options:{url:`/1.0/rooms/${e}/participants/`+t,method:"delete"},headers:i},appServerUrl,sessionToken)}function record(e,t,i){return fetchSessionJson({options:{url:`/1.0/rooms/${e}/recordings`,method:"post",data:{audio:t+"-recording",video:t+"-recording"}},headers:i},appServerUrl,sessionToken)}function stopRecord(e,t,i){return fetchSessionJson({options:{url:`/1.0/rooms/${e}/recordings/`+t,method:"delete"},headers:i},appServerUrl,sessionToken)}function assignAttendee(e,r,t){let n=[];r.curLayoutInfo.region.forEach(t=>{var e;r.settledStreams&&(e=r.settledStreams.find(e=>e.id==t.id));let i={region:t};e&&(i={region:t,settledStream:{user:e.user,stream:e.stream}}),n.push(i);});var i={mixInfos:[{customLayout:n,name:"common",manual:!0,layoutid:r.layoutId}]};return fetchSessionJson({options:{url:`/1.0/rooms/${e}/status`,method:"post",data:JSON.stringify(i)},headers:t},appServerUrl,sessionToken)}function setAutoRegion(e,t){return fetchSessionJson({options:{url:`/1.0/rooms/${e}/status`,method:"post",data:JSON.stringify({mixInfos:[{name:"common",manual:!1}]})},headers:t},appServerUrl,sessionToken)}function setMixInterval(e,t,i){return fetchSessionJson({options:{url:`/1.0/rooms/${e}/status`,method:"post",data:JSON.stringify({mixInfos:[{mixInterval:t,name:"common"}]})},headers:i},appServerUrl,sessionToken)}function getRoomStatus(e,t){return fetchSessionJson({options:{url:`/1.0/rooms/${e}/status`,method:"get"},headers:t},appServerUrl,sessionToken)}function setRoomStatus(e,t,i){return fetchSessionJson({options:{url:`/1.0/rooms/${e}/status`,method:"post",data:{audio:t}},headers:i},appServerUrl,sessionToken)}function setRoomVideoStatus(e,t,i){return fetchSessionJson({options:{url:`/1.0/rooms/${e}/status`,method:"post",data:{video:t}},headers:i},appServerUrl,sessionToken)}function setVoiceStatus(e,t,i){return fetchSessionJson({options:{url:`/1.0/rooms/${e}/voice/status`,method:"post",data:{status:t}},headers:i},appServerUrl,sessionToken)}function getAllLayout(e){return fetchSessionJson({options:{url:`/1.0/rooms/${e}/voice/layouts`,method:"get"}},appServerUrl,sessionToken)}function pullStreamToMeet(e,t){return fetchSessionJson({options:{url:`/1.0/rooms/${e}/streaming-ins`,method:"post",data:t}},appServerUrl,sessionToken)}function StopPullStreamToMeet(e){return fetchSessionJson({options:{url:`/1.0/rooms/${e}/streaming-ins`,method:"delete"}},appServerUrl,sessionToken)}function getInterCutDetail(e){return fetchSessionJson({options:{url:`/1.0/rooms/${e}/streaming-ins`,method:"get"}},appServerUrl,sessionToken)}function setPushStreamLayout(e,t,i){return fetchSessionJson({options:{url:`/1.0/rooms/${e}/live2/layout`,method:"patch",data:t}},appServerUrl,sessionToken)}function getPushStreamLayout(e,t){return fetchSessionJson({options:{url:`/1.0/rooms/${e}/live2/layout`,method:"get"}},appServerUrl,sessionToken)}function setInterCutVolume(e,t,i){return fetchSessionJson({options:{url:`/1.0/rooms/${e}/streaming-ins/volume`,method:"post",data:t},headers:i},appServerUrl,sessionToken)}function getInterCutVolume(e,t){return fetchSessionJson({options:{url:`/1.0/rooms/${e}/streaming-ins/volume`,method:"get"},headers:t},appServerUrl,sessionToken)}const EventDispatcher$1=function(){const i={dispatcher:{}};i.dispatcher.eventListeners={},this.addEventListener=function(e,t){void 0===i.dispatcher.eventListeners[e]&&(i.dispatcher.eventListeners[e]=[]),i.dispatcher.eventListeners[e].push(t);},this.removeEventListener=function(e,t){!i.dispatcher.eventListeners[e]||-1!==(t=i.dispatcher.eventListeners[e].indexOf(t))&&i.dispatcher.eventListeners[e].splice(t,1);},this.clearEventListener=function(e){i.dispatcher.eventListeners[e]=[];},this.dispatchEvent=function(t){i.dispatcher.eventListeners[t.type]&&i.dispatcher.eventListeners[t.type].map(function(e){e(t);});};};class PartChange{constructor(e,t){this.type=e,this.event=t.event,this.data=t.data;}}class RoomStatusChange{constructor(e,t){this.type=e,this.event=t.event,this.data=t.data;}}class RoomHostMsg{constructor(e,t){this.type=e,this.event=t.event,this.data=t.data;}}let participants=new Map,remoteStreams=new Map,groupUserList=new Map,noParticipants=new Map,selfParticipants=null,roomId=null;const clean=Symbol("clean"),initPart=Symbol("initPart"),eventListener=Symbol("initPart"),getAllLayoutInfo=Symbol("getAllLayoutInfo"),getUserInfos=Symbol("getUserInfos"),setGroupMemberInfo=Symbol("setGroupMemberInfo"),setGroupInfo=Symbol("setGroupInfo"),updateNoParticipants=Symbol("updateNoParticipants"),updateParticipants=Symbol("updateParticipants"),joinCCResResolve={resolve:null};class RTCRoom{constructor(e){Object.assign(this,new EventDispatcher$1),this.webrtc=new webrtc,this.RTMsession=e,this[eventListener](),this.groupInfo=null,this.roomInfo=null,this.remoteMixStream=[],this.shareStream=null,this.hostCode=null;}async _connectMic(e,t){if(!e)return Promise.reject({info:"please input roomtoken"});try{this.webrtc.eventListener();var i=await this.webrtc.init(e,t).catch(e=>e);this[initPart](i);await this.publishLocalStream({VideoInputDeviceId:!1,AudioInputDeviceId:!0}),await this.subscribeMixStream();}catch(e){return Promise.reject({info:e})}}async _JoinConference(e,t,i,r){var n=await joinRoom(e,{sid:this.RTMsession.sid,force:i||!0});if(n&&n.roomToken){this.groupInfo={gid:n.groupid,cid:n.cid},this.hostCode=t;var s=await this.applyJoinMeet(t);if(s.info&&!JSON.parse(s.info).passcodeOk)return Object.assign(this.roomInfo,{loginCCRes:s,groupInfo:o});this.webrtc.eventListener();i=await this.webrtc.init(n.roomToken,r);console.log(i);const o=await this[getUserInfos](),a=await getRoomStatus(e);t=await getRoomInfo(e);return console.log(t),console.log(o,"groupInfo"),200==a.status&&200==t.status&&(r=(r=a.data.mixInfos.find(e=>"common"==e.name))&&this.unifyLayout(r),this.roomInfo=Object.assign(a.data,t.data)),this[initPart](i),roomId=e,Object.assign(this.roomInfo,{loginCCRes:s,groupInfo:o})}return n}getRoomInfo(){return this.roomInfo}async getOrgcontacts(){var e=this.RTMsession.sid,t=this.RTMsession.userInfo.uid;return this.RTMsession.CcHttpClient.orgcontacts({sid:e,cid:t})}historyMsgSync(e,t){this.RTMsession.CcWebSocket.historyMsgSync({type:"group",session:{id:this.groupInfo.gid,cid:this.groupInfo.cid},max:e,updatetime:t});}async publishLocalStream(e,t,i){console.log("发布本地流");let r=e.VideoInputDeviceId||!1,n=e.AudioInputDeviceId||!1;if(r||n)return this.webrtc.publishLocal.publishStream||await this.webrtc.createLoaclStream(r,n,i),new Promise((t,i)=>{this.webrtc.publishLocalStream(r,n).then(e=>{t({streamsrc:this.webrtc.publishLocal.publishStream,publication:e});}).catch(e=>{i(e);});})}unPublishLocalStream(){this.webrtc.publishLocal.publication&&this.webrtc.publishLocal.publication.stop&&(this.webrtc.setTrackStop(),this.webrtc.publishLocal.publication.stop(),this.webrtc.publishLocal.publication=null);}async publishShareScreen(e){return {publication:await this.webrtc.publishShareScreen(e),stream:this.webrtc.publishShare.shareStream}}unPublishShareScreen(){this.webrtc.publishShare.publication&&this.webrtc.publishShare.publication.stop&&(this.webrtc.publishShare.publication.stop(),this.webrtc.publishShare.publication=null);}async subscribeMixStream(){const e=this.remoteMixStream.find(e=>"common"==e.id.split("-")[1]);return new Promise((t,i)=>{this.webrtc.SubscribeMixStream(e).then(async e=>{await this[getAllLayoutInfo](),this.webrtc.getReceiverCsrc(),t(e);}).catch(e=>{i(e);});})}unsubscribeMixStream(){this.webrtc.subscribeMixed.subscription&&this.webrtc.subscribeMixed.subscription.stop&&(this.webrtc.subscribeMixed.subscription.stop(),this.webrtc.subscribeMixed.subscription=null);}subscribeShareStream(e){return this.unsubscribeShareStream(),console.log(this.shareStream),new Promise((t,i)=>{this.shareStream||i(),this.webrtc.SubscribeShareStream(this.shareStream,e).then(e=>{t(e);}).catch(e=>{i(e);});})}unsubscribeShareStream(){this.webrtc.subscribeShare.subscription&&this.webrtc.subscribeShare.subscription.stop&&(this.webrtc.subscribeShare.subscription.stop(),this.webrtc.subscribeShare.subscription=null,this.shareStream=null);}subscribeStream(r,e,t){let n=e||!0,s=t||!0;return new Promise((t,i)=>{this.webrtc.conference.subscribe(r,{audio:s,video:n}).then(e=>{t({subscription:e,stream:r});}).catch(e=>{i(e);});})}async subscribeSingleStream(e,t){t=remoteStreams.get(e+"_"+t);if(t)return this.webrtc.SubscribeOneVideo(t)}unsubscribeSingleStream(){this.webrtc.subscribeRemote.subscription&&this.webrtc.subscribeRemote.subscription.stop&&(this.webrtc.subscribeRemote.subscription.stop(),this.webrtc.subscribeRemote.subscription=null);}async getReceiveStats(e){e=("share"==e?this.webrtc.subscribeShare:"single"==e?this.webrtc.subscribeRemote:this.webrtc.subscribeMixed).subscription;return this.webrtc.getReceiveStats(e)}resetCameraPublishSettings(e){this.webrtc.setApplyConstraints(this.webrtc.publishLocal.publishStream,e);}getCameraPublishSettings(){if(this.webrtc.publishLocal.publishStream&&this.webrtc.publishLocal.publishStream.getVideoTracks)return this.webrtc.publishLocal.publishStream.getVideoTracks()[0].getSettings()}async getSendStatus(e){e=("share"==e?this.webrtc.publishShare:this.webrtc.publishLocal).publication;return this.webrtc.getSendStatus(e)}async getDeviceList(){if(this.webrtc&&this.webrtc.setUp)return await this.webrtc.setUp.updateDeviceList(),{AudioInputList:this.webrtc.setUp.AudioInputList,AudioOutPutList:this.webrtc.setUp.AudioOutPutList,VideoInputList:this.webrtc.setUp.VideoInputList}}getJoinedList(){return Array.from(participants.values())}getUnJoinedList(){return Array.from(noParticipants.values())}async kickParticipant(e,t){console.log(e);t=participants.get(e+"_"+t);if(roomId&&t)return delParticipant(roomId,t.id)}async MuteRoomAudio(e){if(roomId)return setRoomStatus(roomId,e)}async MuteRoomVideo(e){if(roomId)return setRoomVideoStatus(roomId,e)}async EnableRecord(){var e=this.remoteMixStream.find(e=>"common"==e.id.split("-")[1]);return record(roomId,e)}async stopRecord(e){return stopRecord(roomId,e)}async muteParticipant(e,t,i){var r="inactive"==i?"stopAudio":"startAudio",n="inactive"==i?0:1,i=participants.get(e+"_"+t);if(roomId&&i)return this[setGroupMemberInfo](e,t,{type:"audio",value:n}),setDeviceInfos(roomId,i.streamId,{op:r})}async handleParticipantCamera(e,t,i){var r="inactive"==i?"stopVideo":"startVideo",n="inactive"==i?0:1,i=participants.get(e+"_"+t);if(roomId&&i)return this[setGroupMemberInfo](e,t,{type:"video",value:n}),setDeviceInfos(roomId,i.streamId,{op:r})}async isTopParticipant(e,t){let i=0;for(var r of participants.values())r.sort&&r.sort>i&&(i=r.sort);participants.get(e+"_"+t)&&this[setGroupMemberInfo](e,t,{type:"sort",value:i});}async changeShareAuth(e,t){var i;participants.get(e+"_"+t)&&(i=0!=part.share?0:1,this[setGroupMemberInfo](e,t,{type:"share",value:i}));}transferHost(e,t){t=participants.get(e+"_"+t);t&&this.RTMsession.CcWebSocket.transferHost({gid:this.groupInfo.gid,cid:this.groupInfo.cid,owner:{uid:t.uid,cid:t.cid,name:t.userName}});}revokeAdmin(){this.RTMsession.CcWebSocket.transferHost({gid:this.groupInfo.gid,cid:this.groupInfo.cid,passcode:"CREATOR"});}responseInivte(e,t){this.RTMsession.CcWebSocket.responseInivte({gid:this.groupInfo.gid,cid:this.groupInfo.cid,response:t,inviter:e});}sendMessageToChat(e){this.RTMsession.CcWebSocket.sendMessageToGroup({gid:this.groupInfo.gid,cid:this.groupInfo.cid,type:0,body:e});}applyJoinMeet(s){return new Promise((e,t)=>{joinCCResResolve.resolve=e;var i=this.RTMsession.userInfo.uid,r=this.RTMsession.userInfo.cid,e=this.RTMsession.userInfo.name;let n={gid:this.groupInfo.gid,cid:this.groupInfo.cid,proposer:{uid:i,cid:r,name:e}};s&&(n=Object.assign(n,{passcode:s})),this.RTMsession.CcWebSocket.applyJoinGroup(n);})}setAutoLayout(){if(roomId)return setAutoRegion(roomId).then(e=>e).catch(e=>e)}setManualLayout(e){if(roomId)return assignAttendee(roomId,e).then(e=>e).catch(e=>e)}setRoomViewInterval(e){if(roomId)return setMixInterval(roomId,e).then(e=>e).catch(e=>e)}setVoiceActiveEnable(e){e=e?"on":"off";return setVoiceStatus(roomId,e).then(e=>e).catch(e=>e)}callParticipants(e,t){var i=this.RTMsession.userInfo.uid,r=this.RTMsession.userInfo.cid,n=this.roomInfo.roomName;this.RTMsession.CcWebSocket.inviteGroup({gid:this.groupInfo.gid,cid:this.groupInfo.cid,cancel:t,name:this.groupInfo.name,inviter:{uid:i,cid:r},info:JSON.stringify({roomid:roomId,roomName:n}),invitee:e});}replyParticipant(e,t,i){this.RTMsession.CcWebSocket.responseApply({gid:this.groupInfo.gid,cid:this.groupInfo.cid,response:i?"agree":"refuse",proposer:{uid:e,cid:t}});}async pullStreamToMeet(e){return pullStreamToMeet(roomId,e)}async setPushStreamLayout(e){return setPushStreamLayout(roomId,e)}async getPushStreamLayout(){return getPushStreamLayout(roomId)}async getInterCutVolume(){return getInterCutVolume(roomId)}async setInterCutVolume(e){return setInterCutVolume(roomId,e)}async StopPullStreamToMeet(e){return StopPullStreamToMeet(roomId)}async getInterCutDetail(){return getInterCutDetail(roomId)}leaveRoom(){this.unsubscribeMixStream(),this.unPublishLocalStream(),this.unsubscribeShareStream(),this.unPublishShareScreen(),this.webrtc.conference&&this.webrtc.conference.leave&&(this.webrtc.conference.leave(),this.webrtc.conference=null),this[clean]();}setRoomAuth(e){this[setGroupInfo]({type:e.type,value:e.value});}async overConference(){await deleteRoom(roomId).catch(e=>e);this.leaveRoom();}async muteLocalAudio(e){var t=e?"stopAudio":"startAudio",e=selfParticipants.streamId;await setDeviceInfos(roomId,e,{op:t});}async muteLocalVideo(e){var t=e?"stopVideo":"startVideo",i=selfParticipants.streamId;this.webrtc.publishLocal.publishStream&&this.webrtc.publishLocal.publishStream.getVideoTracks&&(this.webrtc.publishLocal.publishStream.getVideoTracks()[0].enabled=e),await setDeviceInfos(roomId,i,{op:t});}applyParticipantAuth(e){this.RTMsession.CcWebSocket.sendPowerApplyInfo({gid:this.groupInfo.gid,cid:this.groupInfo.cid,type:e});}[initPart](e,t){selfParticipants=e.self;for(const s of e.remoteStreams)s.userInfo&&(!s.source||!s.source.video||s.source&&s.source.video&&"screen-cast"!=s.source.video)&&remoteStreams.set(s.userInfo.uid+"_"+s.userInfo.cid,s),s.source&&s.source.video&&"mixed"==s.source.video&&this.remoteMixStream.push(s),(s.source&&s.source.video&&"screen-cast"==s.source.video||s&&s.type&&"streaming"==s.type)&&(this.shareStream=s);for(var i of e.participants){var r,n=JSON.parse(gBase64.decode(i.userId));console.log(remoteStreams,"remoteStreams"),remoteStreams.has(n.uid+"_"+n.cid)&&(r=remoteStreams.get(n.uid+"_"+n.cid),i=Object.assign(i,{streamId:r.id,mediaStatus:r.mediaStatus})),this[updateNoParticipants](n.uid,n.cid,"del"),this[updateParticipants](n.uid,n.cid,"modity",Object.assign({id:i.id,ptid:i.ptid,platform:i.platform,role:i.role,streamId:i.streamId,mediaStatus:i.mediaStatus},{uid:n.uid,cid:n.cid}),t),console.log(Object.assign(i,n)," Object.assign(p, user)");}}[clean](){selfParticipants=null,this.remoteMixStream=[],this.shareStream=null,participants.clear(),remoteStreams.clear(),this.RTMsession&&this.RTMsession.CcWebSocket&&(this.RTMsession.CcWebSocket.close(),console.log("关闭cc socket"));}async[getAllLayoutInfo](){var e;!roomId||(e=await getAllLayout(roomId).catch(e=>e))&&e.data&&(this.allLayoutDataList=e.data.layouts,this.webrtc.receiverCsrc.allLayoutDataList=this.allLayoutDataList);}async getAllLayout(){if(roomId){var e=await getAllLayout(roomId).catch(e=>e);return 200==e.status?e.data.layouts:[]}}async getCurLayout(){const e=await getRoomStatus(roomId);let t=null;return 200==e.status&&(t=e.data.mixInfos.find(e=>"common"==e.name),t=t&&this.unifyLayout(t)),t}async getHostInfo(){var e=await getRoomStatus(roomId);let t=null;return 200==e.status&&(t=e.data.compere),t}async[getUserInfos](){if(console.log(this.RTMsession),this.RTMsession){var e=this.groupInfo.gid,t=this.groupInfo.cid,i=this.RTMsession.userInfo.uid,r=this.RTMsession.sid,i=await this.RTMsession.CcHttpClient.getGroupInfo({gid:e,cid:t,sid:r,uid:i}),r=await this.RTMsession.CcHttpClient.getGroupMember({gid:e,cid:t,sid:r});if(r&&200==r.status){for(var n=r.data.fixedgroups_user,s=0,o=n.length;s<o;s++){let e=n[s];var a=e.cid;e.cid=e.ucid,this.updateGrouoList(e.uid,e.cid,Object.assign(e,{gcid:a})),this[updateNoParticipants](e.uid,e.cid,"modity",Object.assign(e,{gcid:a}));}return i.data.fixedgroups[0]}}}[setGroupMemberInfo](e,t,i){this.RTMsession.CcWebSocket.setGroupMemberInfo({gid:this.groupInfo.gid,cid:this.groupInfo.cid,user:[{uid:e,cid:t}],set:{type:i.type,value:i.value}});}[setGroupInfo](e){this.RTMsession.CcWebSocket.setGroupPower({gid:this.groupInfo.gid,cid:this.groupInfo.cid,set:{type:e.type,value:e.value}});}[updateNoParticipants](e,t,i,r){noParticipants.has(e+"_"+t)&&"del"==i?(noParticipants.delete(e+"_"+t),n={uid:e,cid:t}):"modity"==i&&(n=noParticipants.get(e+"_"+t)||{},n=Object.assign(n,r),noParticipants.set(e+"_"+t,Object.assign(n,r)));var n=new PartChange("noParticipantChange",{event:i,data:n});this.dispatchEvent(n),console.log("未入会列表",noParticipants);}[updateParticipants](e,t,i,r,n=!0){var s,o;participants.has(e+"_"+t)&&"del"==i?(participants.delete(e+"_"+t),o={uid:e,cid:t}):"modity"==i&&((o=participants.get(e+"_"+t))&&null!=o.audio||!groupUserList.has(e+"_"+t)||(s=groupUserList.get(e+"_"+t),o=Object.assign(o||{},s)),o=Object.assign(o||{},r),console.log(o,"curPartInfo"),participants.set(e+"_"+t,o)),n&&(o=new PartChange("participantChange",{event:i,data:o}),console.log(this.getJoinedList()),this.dispatchEvent(o)),console.log("updateParticipants 参会人列表",participants);}updateGrouoList(e,t,i){groupUserList.set(e+"_"+t,i);}unifyLayout(e){let i=e.curLayout;for(let t=0;t<i.length;t++)if(i[t].region)for(var r in i[t].region.area){let e=i[t].region.area[r];null!=e.numerator?i[t].region.area[r]=i[t].region.area[r].numerator/i[t].region.area[r].denominator:"0"!=e&&"1"!=e?i[t].region.area[r]=e.split("/")[0]/e.split("/")[1]:i[t].region.area[r]=JSON.parse(e);}if(e&&null==e.layoutId)switch(i.length){case 1:e.layoutId="1";break;case 2:e.layoutId="2";break;case 3:e.layoutId="3";break;case 4:e.layoutId="4";break;case 6:e.layoutId="5";break;case 8:e.layoutId="6";break;case 9:e.layoutId="7";break;case 10:e.layoutId="10";break;case 13:e.layoutId="8";break;case 16:"0"==i[0].region.area.top?e.layoutId="9":e.layoutId="11";}return e}[eventListener](){this.webrtc.streamadded=async e=>{var t,i;console.log(e),e&&e.type&&"streaming"==e.type&&(this.shareStream=e,this.dispatchEvent(new RoomStatusChange("roomStatusChange",{event:"onStreamShareadded",data:e}))),e&&e.source?"camera"==e.source.video||"mic"==e.source.audio?(t=e.userInfo.uid+"_"+e.userInfo.cid,this[updateParticipants](e.userInfo.uid,e.userInfo.cid,"modity",{streamId:e.id,mediaStatus:e.mediaStatus}),this.selfParticipants&&t==this.selfParticipants.uid+"_"+this.selfParticipants.cid&&(this.selfParticipants[streamId]=e.id)):"mixed"==e.source.video?(this.remoteMixStream.push(e),this.dispatchEvent(new RoomStatusChange("roomStatusChange",{event:"onStreamadded",data:e}))):"screen-cast"==e.source.video?e&&e.type&&"streaming"==e.type||(this.shareStream=e,this.dispatchEvent(new RoomStatusChange("roomStatusChange",{event:"onStreamShareadded",data:e}))):e&&e.type&&"streaming"==e.type||(i=e.userInfo.uid+"_"+e.userInfo.cid,this[updateParticipants](e.userInfo.uid,e.userInfo.cid,"modity",{streamId:e.id,mediaStatus:e.mediaStatus}),this.selfParticipants&&i==this.selfParticipants.uid+"_"+this.selfParticipants.cid&&(this.selfParticipants[streamId]=e.id)):(i=e.userInfo.uid+"_"+e.userInfo.cid,this[updateParticipants](e.userInfo.uid,e.userInfo.cid,"modity",{streamId:e.id,mediaStatus:e.mediaStatus}),this.selfParticipants&&i==this.selfParticipants.uid+"_"+this.selfParticipants.cid&&(this.selfParticipants[streamId]=e.id),console.log("其他流源"));},this.webrtc.streamended=async e=>{var t;console.log(e),e&&e.source&&(this.dispatchEvent(new RoomStatusChange("roomStatusChange",{event:"onStreamended",data:e})),"screen-cast"==e.source.video?(this.webrtc.subscribeShare.subscription&&e.id&&this.unsubscribeShareStream(),this.shareStream&&e.id==this.shareStream.id&&(this.shareStream=null)):e&&e.type&&"streaming"==e.type?this.shareStream&&e.id==this.shareStream.id&&(this.shareStream=null):e.userInfo&&(t=e.userInfo.uid+"_"+e.userInfo.cid,remoteStreams.has(t)&&remoteStreams.delete(t),participants.has(e.userInfo.uid+"_"+e.userInfo.cid)&&this[updateParticipants](e.userInfo.uid,e.userInfo.cid,"modity",{streamId:null,mediaStatus:{video:null,audio:null}})));},this.webrtc.subscribeMixended=async e=>{console.log(e),this.dispatchEvent(new RoomStatusChange("roomStatusChange",{event:"onSubscribeMixended",data:e}));},this.webrtc.publicLocalended=async e=>{console.log(e),this.dispatchEvent(new RoomStatusChange("roomStatusChange",{event:"onPublicLocalended",data:e}));},this.webrtc.iceStatusChange=async e=>{console.log(e),this.dispatchEvent(new RoomStatusChange("roomStatusChange",{event:"onIceStatusChange",data:e}));},this.webrtc.subscribeShareended=async e=>{console.log(e),this.dispatchEvent(new RoomStatusChange("roomStatusChange",{event:"onSubscribeShareended",data:e}));},this.webrtc.subscribeRemoteended=async e=>{console.log(e),this.dispatchEvent(new RoomStatusChange("roomStatusChange",{event:"onSubscribeSingleended",data:e}));},this.webrtc.messagereceived=async e=>{console.log(e);},this.webrtc.participantjoined=async e=>{console.log(e);var t=JSON.parse(gBase64.decode(e.userId));this[updateNoParticipants](t.uid,t.cid,"del"),this[updateParticipants](t.uid,t.cid,"modity",Object.assign({id:e.id,ptid:e.ptid,platform:e.platform,role:e.role},{uid:t.uid,cid:t.cid}));},this.webrtc.participantleave=async e=>{var t=JSON.parse(gBase64.decode(e.userId));this[updateNoParticipants](t.uid,t.cid,"modity",Object.assign({id:e.id,ptid:e.ptid,platform:e.platform,role:e.role,status:6},t)),this[updateParticipants](t.uid,t.cid,"del"),console.log("particpant leave参会人列表",participants),console.log("particpant leave未入会列表",participants);},this.webrtc.audiostatuschange=async e=>{let t=null;for(var i of participants.values())i.streamId==e.id&&(t=i);var r;t&&(r="audio.status"==e.data.field?"audio":"video",t.mediaStatus[r]=e.data.value,this[updateParticipants](t.uid,t.cid,"modity"));},this.webrtc.roomStatusChange=async e=>{"update"==e.roomStatus.status?e.roomStatus.video?this.dispatchEvent(new RoomStatusChange("roomStatusChange",{event:"onVideostatuschange",data:{video:e.roomStatus.data}})):e.roomStatus.audio&&this.dispatchEvent(new RoomStatusChange("roomStatusChange",{event:"onAudiostatuschange",data:{audio:e.roomStatus.data}})):"destroy"==e.roomStatus.status&&(this.leaveRoom(),this.dispatchEvent(new RoomStatusChange("roomStatusChange",{event:"onRoomStatusChange",data:{meetStatus:"end"}})));},this.webrtc.exitRoomEvent=async e=>{console.log(e),this.leaveRoom(),this.dispatchEvent(new RoomStatusChange("roomStatusChange",{event:"onRoomStatusChange",data:{meetStatus:"leave",msg:e}}));},this.webrtc.recordMsgEvent=async e=>{e="start"==e.recordMsg.status?1:0;this.dispatchEvent(new RoomStatusChange("roomStatusChange",{event:"onRecordStatusChange",data:{recordStatus:e}}));},this.webrtc.recollectfailed=async e=>{console.log(e),this.dispatchEvent(new RoomStatusChange("roomStatusChange",{event:"onOwtStatusChange",data:e}));},this.webrtc.videoTrackEnded=async e=>{console.log(e);},this.webrtc.audioTrackEnded=async e=>{console.log(e);},this.webrtc.voiceStimulationChange=async e=>{this.dispatchEvent(new RoomStatusChange("roomStatusChange",{event:"onVoiceStimulationChange",data:e}));},this.webrtc.videoLayoutChange=async e=>{e.layoutList&&0!=e.layoutList.length&&this.dispatchEvent(new RoomStatusChange("roomStatusChange",{event:"onLayoutChange",data:this.unifyLayout({curLayout:e.layoutList,layoutId:e.layoutId})}));},this.webrtc.relogin=async e=>{console.log(e),console.log("%cowt重连了","color:green;font-size:14px"),participants.clear(),remoteStreams.clear(),groupUserList.clear(),noParticipants.clear(),selfParticipants=null,this.remoteMixStream=[];var t=e.room;this.webrtc.eventListener();var i=await this[getUserInfos]();const r=await getRoomStatus(roomId);var n=await getRoomInfo(roomId);console.log(n),console.log(i,"groupInfo"),200==r.status&&200==n.status&&(e=(e=r.data.mixInfos.find(e=>"common"==e.name))&&this.unifyLayout(e),this.roomInfo=Object.assign(r.data,n.data)),this[initPart](t,!1),console.log("%cowt重连成功了","color:green;font-size:14px"),console.log(Object.assign(this.roomInfo,{groupInfo:i})),this.dispatchEvent(new RoomStatusChange("roomStatusChange",{event:"onRelogin",data:Object.assign(this.roomInfo,{groupInfo:i})}));},this.RTMsession&&this.RTMsession.CcWebSocket&&(this.RTMsession.CcWebSocket.getApplyGroupNotice=e=>{var t=e.proposer.uid,i=e.proposer.cid,r=Object.assign(e.proposer,e.power);this.RTMsession.userInfo.uid==t&&this.dispatchEvent({type:"participantApplyNotice",data:e});let n=1;e.info&&JSON.parse(e.info)&&JSON.parse(e.info).passcodeType&&("host"==JSON.parse(e.info).passcodeType?n=3:"admin"==JSON.parse(e.info).passcodeType?n=2:"guest"==JSON.parse(e.info).passcodeType&&(n=1)),this.updateGrouoList(t,i,Object.assign(r,{type:n,delflag:-1})),console.log(e,"notice111111111111"),console.log(participants.has(t+"_"+i)),participants.has(t+"_"+i)&&(console.log("4137更新个人属性"),this[updateParticipants](t,i,"modity",Object.assign(r,{type:n,delflag:-1}))),joinCCResResolve.resolve(e);},this.RTMsession.CcWebSocket.OnchangeUserStatus=e=>{if(e.requestData.gid==this.groupInfo.gid){for(var t=e.requestData.set.type,i=e.requestData.set.value,r=0;r<e.requestData.user.length;r++){var n=e.requestData.user[r].uid,s=e.requestData.user[r].cid,o=groupUserList.get(n+"_"+s);this.updateGrouoList(n,s,Object.assign(o,{[t]:i})),participants.has(n+"_"+s)&&(console.log("4131更新个人属性"),this[updateParticipants](n,s,"modity",{[t]:i}));}console.log("cc user auth change participants参会人列表",participants),console.log("cc user auth change noparticipants参会人列表",noParticipants);}},this.RTMsession.CcWebSocket.onGroupPower=e=>{e.requestData.gid==this.groupInfo.gid&&this.dispatchEvent(new RoomStatusChange("roomStatusChange",{event:"onAuthChange",data:e.requestData.set}));},this.RTMsession.CcWebSocket.onReceiveGroupMsg=e=>{console.log(e,"聊天消息"),this.dispatchEvent(new RoomStatusChange("roomStatusChange",{event:"onMsgReceive",data:{lock:groupInfo.requestData.set.value}}));},this.RTMsession.CcWebSocket.onReceiveApplyMsg=e=>{console.log(e,"申请消息"),e.gid==this.groupInfo.gid&&this[updateNoParticipants](e.proposer.uid,e.proposer.cid,"modity",Object.assign(e.proposer,{status:3}));},this.RTMsession.CcWebSocket.getreplyInviteMsg=t=>{if(t.gid==this.groupInfo.gid){let e=null;e="refuse"==t.response?"kBusy"==t.info.reason?100:2:1,this[updateNoParticipants](t.invitee.uid,t.invitee.cid,"modity",Object.assign(notice.invitee,{status:e}));}},this.RTMsession.CcWebSocket.getHostIdentity=e=>{e.gid==this.groupInfo.gid&&this.dispatchEvent(new RoomStatusChange("roomStatusChange",{event:"onHostChange",data:e}));},this.RTMsession.CcWebSocket.onRecPowerApplyMsg=e=>{e.gid==this.groupInfo.gid&&this.dispatchEvent(new RoomHostMsg("roomHostMsg",{event:"onApplyChange",data:e}));},this.RTMsession.CcWebSocket.getInviteNotice=e=>{this.dispatchEvent({type:"participantInviteChange",data:e});},this.RTMsession.CcWebSocket.exitCurLoign=e=>{this.dispatchEvent({type:"accountStatusChange",data:e});},this.RTMsession.CcWebSocket.recollecting=()=>{this.dispatchEvent(new RoomStatusChange("roomStatusChange",{event:"onSocketStatusChange",data:"ReConnected"}));},this.RTMsession.CcWebSocket.recollectSuccess=async()=>{console.log("%cc重连成功","color:green;font-size:14px");await this.applyJoinMeet(this.hostCode);this.dispatchEvent(new RoomStatusChange("roomStatusChange",{event:"onSocketStatusChange",data:"Connected"}));},this.RTMsession.CcWebSocket.recollectFailed=()=>{this.dispatchEvent(new RoomStatusChange("roomStatusChange",{event:"onSocketStatusChange",data:"DisConnected"}));});}}var bind$1=function(i,r){return function(){for(var e=new Array(arguments.length),t=0;t<e.length;t++)e[t]=arguments[t];return i.apply(r,e)}},toString$1=Object.prototype.toString;function isArray$1(e){return "[object Array]"===toString$1.call(e)}function isUndefined$1(e){return void 0===e}function isBuffer$1(e){return null!==e&&!isUndefined$1(e)&&null!==e.constructor&&!isUndefined$1(e.constructor)&&"function"==typeof e.constructor.isBuffer&&e.constructor.isBuffer(e)}function isArrayBuffer$1(e){return "[object ArrayBuffer]"===toString$1.call(e)}function isFormData$1(e){return "undefined"!=typeof FormData&&e instanceof FormData}function isArrayBufferView$1(e){e="undefined"!=typeof ArrayBuffer&&ArrayBuffer.isView?ArrayBuffer.isView(e):e&&e.buffer&&e.buffer instanceof ArrayBuffer;return e}function isString$1(e){return "string"==typeof e}function isNumber$1(e){return "number"==typeof e}function isObject$1(e){return null!==e&&"object"==typeof e}function isPlainObject$1(e){if("[object Object]"!==toString$1.call(e))return !1;e=Object.getPrototypeOf(e);return null===e||e===Object.prototype}function isDate$1(e){return "[object Date]"===toString$1.call(e)}function isFile$1(e){return "[object File]"===toString$1.call(e)}function isBlob$1(e){return "[object Blob]"===toString$1.call(e)}function isFunction$1(e){return "[object Function]"===toString$1.call(e)}function isStream$1(e){return isObject$1(e)&&isFunction$1(e.pipe)}function isURLSearchParams$1(e){return "undefined"!=typeof URLSearchParams&&e instanceof URLSearchParams}function trim$1(e){return e.trim?e.trim():e.replace(/^\s+|\s+$/g,"")}function isStandardBrowserEnv$1(){return ("undefined"==typeof navigator||"ReactNative"!==navigator.product&&"NativeScript"!==navigator.product&&"NS"!==navigator.product)&&("undefined"!=typeof window&&"undefined"!=typeof document)}function forEach$1(e,t){if(null!=e)if(isArray$1(e="object"!=typeof e?[e]:e))for(var i=0,r=e.length;i<r;i++)t.call(null,e[i],i,e);else for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&t.call(null,e[n],n,e);}function merge$1(){var i={};function e(e,t){isPlainObject$1(i[t])&&isPlainObject$1(e)?i[t]=merge$1(i[t],e):isPlainObject$1(e)?i[t]=merge$1({},e):isArray$1(e)?i[t]=e.slice():i[t]=e;}for(var t=0,r=arguments.length;t<r;t++)forEach$1(arguments[t],e);return i}function extend$1(i,e,r){return forEach$1(e,function(e,t){i[t]=r&&"function"==typeof e?bind$1(e,r):e;}),i}function stripBOM$1(e){return e=65279===e.charCodeAt(0)?e.slice(1):e}var utils$1={isArray:isArray$1,isArrayBuffer:isArrayBuffer$1,isBuffer:isBuffer$1,isFormData:isFormData$1,isArrayBufferView:isArrayBufferView$1,isString:isString$1,isNumber:isNumber$1,isObject:isObject$1,isPlainObject:isPlainObject$1,isUndefined:isUndefined$1,isDate:isDate$1,isFile:isFile$1,isBlob:isBlob$1,isFunction:isFunction$1,isStream:isStream$1,isURLSearchParams:isURLSearchParams$1,isStandardBrowserEnv:isStandardBrowserEnv$1,forEach:forEach$1,merge:merge$1,extend:extend$1,trim:trim$1,stripBOM:stripBOM$1};function encode$2(e){return encodeURIComponent(e).replace(/%3A/gi,":").replace(/%24/g,"$").replace(/%2C/gi,",").replace(/%20/g,"+").replace(/%5B/gi,"[").replace(/%5D/gi,"]")}var buildURL$1=function(e,t,i){if(!t)return e;var r,i=i?i(t):utils$1.isURLSearchParams(t)?t.toString():(r=[],utils$1.forEach(t,function(e,t){null!=e&&(utils$1.isArray(e)?t+="[]":e=[e],utils$1.forEach(e,function(e){utils$1.isDate(e)?e=e.toISOString():utils$1.isObject(e)&&(e=JSON.stringify(e)),r.push(encode$2(t)+"="+encode$2(e));}));}),r.join("&"));return i&&(-1!==(t=e.indexOf("#"))&&(e=e.slice(0,t)),e+=(-1===e.indexOf("?")?"?":"&")+i),e};function InterceptorManager$1(){this.handlers=[];}InterceptorManager$1.prototype.use=function(e,t,i){return this.handlers.push({fulfilled:e,rejected:t,synchronous:!!i&&i.synchronous,runWhen:i?i.runWhen:null}),this.handlers.length-1},InterceptorManager$1.prototype.eject=function(e){this.handlers[e]&&(this.handlers[e]=null);},InterceptorManager$1.prototype.forEach=function(t){utils$1.forEach(this.handlers,function(e){null!==e&&t(e);});};var InterceptorManager_1$1=InterceptorManager$1,normalizeHeaderName$1=function(i,r){utils$1.forEach(i,function(e,t){t!==r&&t.toUpperCase()===r.toUpperCase()&&(i[r]=e,delete i[t]);});},enhanceError$1=function(e,t,i,r,n){return e.config=t,i&&(e.code=i),e.request=r,e.response=n,e.isAxiosError=!0,e.toJSON=function(){return {message:this.message,name:this.name,description:this.description,number:this.number,fileName:this.fileName,lineNumber:this.lineNumber,columnNumber:this.columnNumber,stack:this.stack,config:this.config,code:this.code}},e},createError$1=function(e,t,i,r,n){e=new Error(e);return enhanceError$1(e,t,i,r,n)},settle$1=function(e,t,i){var r=i.config.validateStatus;i.status&&r&&!r(i.status)?t(createError$1("Request failed with status code "+i.status,i.config,null,i.request,i)):e(i);},cookies$1=utils$1.isStandardBrowserEnv()?{write:function(e,t,i,r,n,s){var o=[];o.push(e+"="+encodeURIComponent(t)),utils$1.isNumber(i)&&o.push("expires="+new Date(i).toGMTString()),utils$1.isString(r)&&o.push("path="+r),utils$1.isString(n)&&o.push("domain="+n),!0===s&&o.push("secure"),document.cookie=o.join("; ");},read:function(e){e=document.cookie.match(new RegExp("(^|;\\s*)("+e+")=([^;]*)"));return e?decodeURIComponent(e[3]):null},remove:function(e){this.write(e,"",Date.now()-864e5);}}:{write:function(){},read:function(){return null},remove:function(){}},isAbsoluteURL$1=function(e){return /^([a-z][a-z\d\+\-\.]*:)?\/\//i.test(e)},combineURLs$1=function(e,t){return t?e.replace(/\/+$/,"")+"/"+t.replace(/^\/+/,""):e},buildFullPath$1=function(e,t){return e&&!isAbsoluteURL$1(t)?combineURLs$1(e,t):t},ignoreDuplicateOf$1=["age","authorization","content-length","content-type","etag","expires","from","host","if-modified-since","if-unmodified-since","last-modified","location","max-forwards","proxy-authorization","referer","retry-after","user-agent"],parseHeaders$1=function(e){var t,i,r={};return e&&utils$1.forEach(e.split("\n"),function(e){i=e.indexOf(":"),t=utils$1.trim(e.substr(0,i)).toLowerCase(),i=utils$1.trim(e.substr(i+1)),t&&(r[t]&&0<=ignoreDuplicateOf$1.indexOf(t)||(r[t]="set-cookie"===t?(r[t]||[]).concat([i]):r[t]?r[t]+", "+i:i));}),r},isURLSameOrigin$1=utils$1.isStandardBrowserEnv()?function(){var t,i=/(msie|trident)/i.test(navigator.userAgent),r=document.createElement("a");function n(e){return i&&(r.setAttribute("href",e),e=r.href),r.setAttribute("href",e),{href:r.href,protocol:r.protocol?r.protocol.replace(/:$/,""):"",host:r.host,search:r.search?r.search.replace(/^\?/,""):"",hash:r.hash?r.hash.replace(/^#/,""):"",hostname:r.hostname,port:r.port,pathname:"/"===r.pathname.charAt(0)?r.pathname:"/"+r.pathname}}return t=n(window.location.href),function(e){e=utils$1.isString(e)?n(e):e;return e.protocol===t.protocol&&e.host===t.host}}():function(){return !0},xhr$1=function(u){return new Promise(function(t,i){var r=u.data,n=u.headers,s=u.responseType;utils$1.isFormData(r)&&delete n["Content-Type"];var e,o=new XMLHttpRequest;u.auth&&(e=u.auth.username||"",a=u.auth.password?unescape(encodeURIComponent(u.auth.password)):"",n.Authorization="Basic "+btoa(e+":"+a));var a=buildFullPath$1(u.baseURL,u.url);function c(){var e;o&&(e="getAllResponseHeaders"in o?parseHeaders$1(o.getAllResponseHeaders()):null,e={data:s&&"text"!==s&&"json"!==s?o.response:o.responseText,status:o.status,statusText:o.statusText,headers:e,config:u,request:o},settle$1(t,i,e),o=null);}o.open(u.method.toUpperCase(),buildURL$1(a,u.params,u.paramsSerializer),!0),o.timeout=u.timeout,"onloadend"in o?o.onloadend=c:o.onreadystatechange=function(){o&&4===o.readyState&&(0!==o.status||o.responseURL&&0===o.responseURL.indexOf("file:"))&&setTimeout(c);},o.onabort=function(){o&&(i(createError$1("Request aborted",u,"ECONNABORTED",o)),o=null);},o.onerror=function(){i(createError$1("Network Error",u,null,o)),o=null;},o.ontimeout=function(){var e="timeout of "+u.timeout+"ms exceeded";u.timeoutErrorMessage&&(e=u.timeoutErrorMessage),i(createError$1(e,u,u.transitional&&u.transitional.clarifyTimeoutError?"ETIMEDOUT":"ECONNABORTED",o)),o=null;},!utils$1.isStandardBrowserEnv()||(a=(u.withCredentials||isURLSameOrigin$1(a))&&u.xsrfCookieName?cookies$1.read(u.xsrfCookieName):void 0)&&(n[u.xsrfHeaderName]=a),"setRequestHeader"in o&&utils$1.forEach(n,function(e,t){void 0===r&&"content-type"===t.toLowerCase()?delete n[t]:o.setRequestHeader(t,e);}),utils$1.isUndefined(u.withCredentials)||(o.withCredentials=!!u.withCredentials),s&&"json"!==s&&(o.responseType=u.responseType),"function"==typeof u.onDownloadProgress&&o.addEventListener("progress",u.onDownloadProgress),"function"==typeof u.onUploadProgress&&o.upload&&o.upload.addEventListener("progress",u.onUploadProgress),u.cancelToken&&u.cancelToken.promise.then(function(e){o&&(o.abort(),i(e),o=null);}),r=r||null,o.send(r);})},DEFAULT_CONTENT_TYPE$1={"Content-Type":"application/x-www-form-urlencoded"};function setContentTypeIfUnset$1(e,t){!utils$1.isUndefined(e)&&utils$1.isUndefined(e["Content-Type"])&&(e["Content-Type"]=t);}function getDefaultAdapter$1(){var e;return e="undefined"!=typeof XMLHttpRequest||"undefined"!=typeof process&&"[object process]"===Object.prototype.toString.call(process)?xhr$1:e}function stringifySafely$1(e,t,i){if(utils$1.isString(e))try{return (t||JSON.parse)(e),utils$1.trim(e)}catch(e){if("SyntaxError"!==e.name)throw e}return (i||JSON.stringify)(e)}var defaults$1={transitional:{silentJSONParsing:!0,forcedJSONParsing:!0,clarifyTimeoutError:!1},adapter:getDefaultAdapter$1(),transformRequest:[function(e,t){return normalizeHeaderName$1(t,"Accept"),normalizeHeaderName$1(t,"Content-Type"),utils$1.isFormData(e)||utils$1.isArrayBuffer(e)||utils$1.isBuffer(e)||utils$1.isStream(e)||utils$1.isFile(e)||utils$1.isBlob(e)?e:utils$1.isArrayBufferView(e)?e.buffer:utils$1.isURLSearchParams(e)?(setContentTypeIfUnset$1(t,"application/x-www-form-urlencoded;charset=utf-8"),e.toString()):utils$1.isObject(e)||t&&"application/json"===t["Content-Type"]?(setContentTypeIfUnset$1(t,"application/json"),stringifySafely$1(e)):e}],transformResponse:[function(e){var t=this.transitional,i=t&&t.silentJSONParsing,t=t&&t.forcedJSONParsing,i=!i&&"json"===this.responseType;if(i||t&&utils$1.isString(e)&&e.length)try{return JSON.parse(e)}catch(e){if(i){if("SyntaxError"===e.name)throw enhanceError$1(e,this,"E_JSON_PARSE");throw e}}return e}],timeout:0,xsrfCookieName:"XSRF-TOKEN",xsrfHeaderName:"X-XSRF-TOKEN",maxContentLength:-1,maxBodyLength:-1,validateStatus:function(e){return 200<=e&&e<300},headers:{common:{Accept:"application/json, text/plain, */*"}}};utils$1.forEach(["delete","get","head"],function(e){defaults$1.headers[e]={};}),utils$1.forEach(["post","put","patch"],function(e){defaults$1.headers[e]=utils$1.merge(DEFAULT_CONTENT_TYPE$1);});var defaults_1$1=defaults$1,transformData$1=function(t,i,e){var r=this||defaults_1$1;return utils$1.forEach(e,function(e){t=e.call(r,t,i);}),t},isCancel$1=function(e){return !(!e||!e.__CANCEL__)};function throwIfCancellationRequested$1(e){e.cancelToken&&e.cancelToken.throwIfRequested();}var dispatchRequest$1=function(t){return throwIfCancellationRequested$1(t),t.headers=t.headers||{},t.data=transformData$1.call(t,t.data,t.headers,t.transformRequest),t.headers=utils$1.merge(t.headers.common||{},t.headers[t.method]||{},t.headers),utils$1.forEach(["delete","get","head","post","put","patch","common"],function(e){delete t.headers[e];}),(t.adapter||defaults_1$1.adapter)(t).then(function(e){return throwIfCancellationRequested$1(t),e.data=transformData$1.call(t,e.data,e.headers,t.transformResponse),e},function(e){return isCancel$1(e)||(throwIfCancellationRequested$1(t),e&&e.response&&(e.response.data=transformData$1.call(t,e.response.data,e.response.headers,t.transformResponse))),Promise.reject(e)})},mergeConfig$1=function(t,i){i=i||{};var r={},e=["url","method","data"],n=["headers","auth","proxy","params"],s=["baseURL","transformRequest","transformResponse","paramsSerializer","timeout","timeoutMessage","withCredentials","adapter","responseType","xsrfCookieName","xsrfHeaderName","onUploadProgress","onDownloadProgress","decompress","maxContentLength","maxBodyLength","maxRedirects","transport","httpAgent","httpsAgent","cancelToken","socketPath","responseEncoding"],o=["validateStatus"];function a(e,t){return utils$1.isPlainObject(e)&&utils$1.isPlainObject(t)?utils$1.merge(e,t):utils$1.isPlainObject(t)?utils$1.merge({},t):utils$1.isArray(t)?t.slice():t}function c(e){utils$1.isUndefined(i[e])?utils$1.isUndefined(t[e])||(r[e]=a(void 0,t[e])):r[e]=a(t[e],i[e]);}utils$1.forEach(e,function(e){utils$1.isUndefined(i[e])||(r[e]=a(void 0,i[e]));}),utils$1.forEach(n,c),utils$1.forEach(s,function(e){utils$1.isUndefined(i[e])?utils$1.isUndefined(t[e])||(r[e]=a(void 0,t[e])):r[e]=a(void 0,i[e]);}),utils$1.forEach(o,function(e){e in i?r[e]=a(t[e],i[e]):e in t&&(r[e]=a(void 0,t[e]));});var u=e.concat(n).concat(s).concat(o),o=Object.keys(t).concat(Object.keys(i)).filter(function(e){return -1===u.indexOf(e)});return utils$1.forEach(o,c),r},name$1="axios",version$2="0.21.4",description$1="Promise based HTTP client for the browser and node.js",main$1="index.js",scripts$1={test:"grunt test",start:"node ./sandbox/server.js",build:"NODE_ENV=production grunt build",preversion:"npm test",version:"npm run build && grunt version && git add -A dist && git add CHANGELOG.md bower.json package.json",postversion:"git push && git push --tags",examples:"node ./examples/server.js",coveralls:"cat coverage/lcov.info | ./node_modules/coveralls/bin/coveralls.js",fix:"eslint --fix lib/**/*.js"},repository$1={type:"git",url:"https://github.com/axios/axios.git"},keywords$1=["xhr","http","ajax","promise","node"],author$1="Matt Zabriskie",license$1="MIT",bugs$1={url:"https://github.com/axios/axios/issues"},homepage$1="https://axios-http.com",devDependencies$1={coveralls:"^3.0.0","es6-promise":"^4.2.4",grunt:"^1.3.0","grunt-banner":"^0.6.0","grunt-cli":"^1.2.0","grunt-contrib-clean":"^1.1.0","grunt-contrib-watch":"^1.0.0","grunt-eslint":"^23.0.0","grunt-karma":"^4.0.0","grunt-mocha-test":"^0.13.3","grunt-ts":"^6.0.0-beta.19","grunt-webpack":"^4.0.2","istanbul-instrumenter-loader":"^1.0.0","jasmine-core":"^2.4.1",karma:"^6.3.2","karma-chrome-launcher":"^3.1.0","karma-firefox-launcher":"^2.1.0","karma-jasmine":"^1.1.1","karma-jasmine-ajax":"^0.1.13","karma-safari-launcher":"^1.0.0","karma-sauce-launcher":"^4.3.6","karma-sinon":"^1.0.5","karma-sourcemap-loader":"^0.3.8","karma-webpack":"^4.0.2","load-grunt-tasks":"^3.5.2",minimist:"^1.2.0",mocha:"^8.2.1",sinon:"^4.5.0","terser-webpack-plugin":"^4.2.3",typescript:"^4.0.5","url-search-params":"^0.10.0",webpack:"^4.44.2","webpack-dev-server":"^3.11.0"},browser$1={"./lib/adapters/http.js":"./lib/adapters/xhr.js"},jsdelivr$1="dist/axios.min.js",unpkg$1="dist/axios.min.js",typings$1="./index.d.ts",dependencies$1={"follow-redirects":"^1.14.0"},bundlesize$1=[{path:"./dist/axios.min.js",threshold:"5kB"}],__npminstall_done$1="Tue Nov 09 2021 20:37:49 GMT+0800 (中国标准时间)",_from$1="axios@0.21.4",_resolved$1="https://registry.npmmirror.com/axios/download/axios-0.21.4.tgz?cache=0&sync_timestamp=1635213986012&other_urls=https%3A%2F%2Fregistry.npmmirror.com%2Faxios%2Fdownload%2Faxios-0.21.4.tgz",_package$2={name:name$1,version:version$2,description:description$1,main:main$1,scripts:scripts$1,repository:repository$1,keywords:keywords$1,author:author$1,license:license$1,bugs:bugs$1,homepage:homepage$1,devDependencies:devDependencies$1,browser:browser$1,jsdelivr:jsdelivr$1,unpkg:unpkg$1,typings:typings$1,dependencies:dependencies$1,bundlesize:bundlesize$1,__npminstall_done:__npminstall_done$1,_from:_from$1,_resolved:_resolved$1},_package$3=Object.freeze({__proto__:null,name:name$1,version:version$2,description:description$1,main:main$1,scripts:scripts$1,repository:repository$1,keywords:keywords$1,author:author$1,license:license$1,bugs:bugs$1,homepage:homepage$1,devDependencies:devDependencies$1,browser:browser$1,jsdelivr:jsdelivr$1,unpkg:unpkg$1,typings:typings$1,dependencies:dependencies$1,bundlesize:bundlesize$1,__npminstall_done:__npminstall_done$1,_from:_from$1,_resolved:_resolved$1,default:_package$2}),commonjsGlobal="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function createCommonjsModule(e,t){return e(t={exports:{}},t.exports),t.exports}function getCjsExportFromNamespace$1(e){return e&&e.default||e}var pkg$1=getCjsExportFromNamespace$1(_package$3),validators$2={};["object","boolean","number","function","string","symbol"].forEach(function(t,i){validators$2[t]=function(e){return typeof e===t||"a"+(i<1?"n ":" ")+t};});var deprecatedWarnings$1={},currentVerArr$1=pkg$1.version.split(".");function isOlderVersion$1(e,t){for(var i=t?t.split("."):currentVerArr$1,r=e.split("."),n=0;n<3;n++){if(i[n]>r[n])return !0;if(i[n]<r[n])return !1}return !1}function assertOptions$1(e,t,i){if("object"!=typeof e)throw new TypeError("options must be an object");for(var r=Object.keys(e),n=r.length;0<n--;){var s=r[n],o=t[s];if(o){var a=e[s],a=void 0===a||o(a,s,e);if(!0!==a)throw new TypeError("option "+s+" must be "+a)}else if(!0!==i)throw Error("Unknown option "+s)}}validators$2.transitional=function(r,n,i){var s=n&&isOlderVersion$1(n);function o(e,t){return "[Axios v"+pkg$1.version+"] Transitional option '"+e+"'"+t+(i?". "+i:"")}return function(e,t,i){if(!1===r)throw new Error(o(t," has been removed in "+n));return s&&!deprecatedWarnings$1[t]&&(deprecatedWarnings$1[t]=!0,console.warn(o(t," has been deprecated since v"+n+" and will be removed in the near future"))),!r||r(e,t,i)}};var validator$1={isOlderVersion:isOlderVersion$1,assertOptions:assertOptions$1,validators:validators$2},validators$3=validator$1.validators;function Axios$1(e){this.defaults=e,this.interceptors={request:new InterceptorManager_1$1,response:new InterceptorManager_1$1};}Axios$1.prototype.request=function(t){"string"==typeof t?(t=arguments[1]||{}).url=arguments[0]:t=t||{},(t=mergeConfig$1(this.defaults,t)).method?t.method=t.method.toLowerCase():this.defaults.method?t.method=this.defaults.method.toLowerCase():t.method="get";var e=t.transitional;void 0!==e&&validator$1.assertOptions(e,{silentJSONParsing:validators$3.transitional(validators$3.boolean,"1.0.0"),forcedJSONParsing:validators$3.transitional(validators$3.boolean,"1.0.0"),clarifyTimeoutError:validators$3.transitional(validators$3.boolean,"1.0.0")},!1);var i=[],r=!0;this.interceptors.request.forEach(function(e){"function"==typeof e.runWhen&&!1===e.runWhen(t)||(r=r&&e.synchronous,i.unshift(e.fulfilled,e.rejected));});var n,s=[];if(this.interceptors.response.forEach(function(e){s.push(e.fulfilled,e.rejected);}),!r){var o=[dispatchRequest$1,void 0];for(Array.prototype.unshift.apply(o,i),o=o.concat(s),n=Promise.resolve(t);o.length;)n=n.then(o.shift(),o.shift());return n}for(var a=t;i.length;){var c=i.shift(),u=i.shift();try{a=c(a);}catch(e){u(e);break}}try{n=dispatchRequest$1(a);}catch(e){return Promise.reject(e)}for(;s.length;)n=n.then(s.shift(),s.shift());return n},Axios$1.prototype.getUri=function(e){return e=mergeConfig$1(this.defaults,e),buildURL$1(e.url,e.params,e.paramsSerializer).replace(/^\?/,"")},utils$1.forEach(["delete","get","head","options"],function(i){Axios$1.prototype[i]=function(e,t){return this.request(mergeConfig$1(t||{},{method:i,url:e,data:(t||{}).data}))};}),utils$1.forEach(["post","put","patch"],function(r){Axios$1.prototype[r]=function(e,t,i){return this.request(mergeConfig$1(i||{},{method:r,url:e,data:t}))};});var Axios_1$1=Axios$1;function Cancel$1(e){this.message=e;}Cancel$1.prototype.toString=function(){return "Cancel"+(this.message?": "+this.message:"")},Cancel$1.prototype.__CANCEL__=!0;var Cancel_1$1=Cancel$1;function CancelToken$1(e){if("function"!=typeof e)throw new TypeError("executor must be a function.");var t;this.promise=new Promise(function(e){t=e;});var i=this;e(function(e){i.reason||(i.reason=new Cancel_1$1(e),t(i.reason));});}CancelToken$1.prototype.throwIfRequested=function(){if(this.reason)throw this.reason},CancelToken$1.source=function(){var t;return {token:new CancelToken$1(function(e){t=e;}),cancel:t}};var CancelToken_1$1=CancelToken$1,spread$1=function(t){return function(e){return t.apply(null,e)}},isAxiosError$1=function(e){return "object"==typeof e&&!0===e.isAxiosError};function createInstance$1(e){var t=new Axios_1$1(e),e=bind$1(Axios_1$1.prototype.request,t);return utils$1.extend(e,Axios_1$1.prototype,t),utils$1.extend(e,t),e}var axios$1=createInstance$1(defaults_1$1);axios$1.Axios=Axios_1$1,axios$1.create=function(e){return createInstance$1(mergeConfig$1(axios$1.defaults,e))},axios$1.Cancel=Cancel_1$1,axios$1.CancelToken=CancelToken_1$1,axios$1.isCancel=isCancel$1,axios$1.all=function(e){return Promise.all(e)},axios$1.spread=spread$1,axios$1.isAxiosError=isAxiosError$1;var axios_1$1=axios$1,default_1$1=axios$1;axios_1$1.default=default_1$1;var _axios_0_21_4_axios$1=axios_1$1;function fetch$1(n,s){return console.log(n),new Promise((t,e)=>{var i=Object.assign({"Content-Type":"text/plain;charset=UTF-8"},n.headers);const r=_axios_0_21_4_axios$1.create({baseURL:s,headers:i,timeout:3e4});r(n.options).then(e=>{t(e),console.log(e);}).catch(e=>{console.log(e),t(e.response);});})}function uuid(e,t){var i,r,n="0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz".split(""),s=[];if(t=t||n.length,e)for(i=0;i<e;i++)s[i]=n[0|Math.random()*t];else for(s[8]=s[13]=s[18]=s[23]="-",s[14]="4",i=0;i<36;i++)s[i]||(r=0|16*Math.random(),s[i]=n[19==i?3&r|8:r]);return s.join("")}function getMoble(){for(var e=new Array("130","131","132","133","135","137","138","170","187","189")[parseInt(10*Math.random())],t=0;t<8;t++)e+=Math.floor(10*Math.random());return e}class ccServer{constructor(){this.serverUrl=[];}findUrl(t){return 0!=this.serverUrl.length&&"https://"+this.serverUrl.find(e=>e.type==t).addr}}var crypt=createCommonjsModule(function(e){var s,i;s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",i={rotl:function(e,t){return e<<t|e>>>32-t},rotr:function(e,t){return e<<32-t|e>>>t},endian:function(e){if(e.constructor==Number)return 16711935&i.rotl(e,8)|4278255360&i.rotl(e,24);for(var t=0;t<e.length;t++)e[t]=i.endian(e[t]);return e},randomBytes:function(e){for(var t=[];0<e;e--)t.push(Math.floor(256*Math.random()));return t},bytesToWords:function(e){for(var t=[],i=0,r=0;i<e.length;i++,r+=8)t[r>>>5]|=e[i]<<24-r%32;return t},wordsToBytes:function(e){for(var t=[],i=0;i<32*e.length;i+=8)t.push(e[i>>>5]>>>24-i%32&255);return t},bytesToHex:function(e){for(var t=[],i=0;i<e.length;i++)t.push((e[i]>>>4).toString(16)),t.push((15&e[i]).toString(16));return t.join("")},hexToBytes:function(e){for(var t=[],i=0;i<e.length;i+=2)t.push(parseInt(e.substr(i,2),16));return t},bytesToBase64:function(e){for(var t=[],i=0;i<e.length;i+=3)for(var r=e[i]<<16|e[i+1]<<8|e[i+2],n=0;n<4;n++)8*i+6*n<=8*e.length?t.push(s.charAt(r>>>6*(3-n)&63)):t.push("=");return t.join("")},base64ToBytes:function(e){e=e.replace(/[^A-Z0-9+\/]/gi,"");for(var t=[],i=0,r=0;i<e.length;r=++i%4)0!=r&&t.push((s.indexOf(e.charAt(i-1))&Math.pow(2,-2*r+8)-1)<<2*r|s.indexOf(e.charAt(i))>>>6-2*r);return t}},e.exports=i;}),charenc={utf8:{stringToBytes:function(e){return charenc.bin.stringToBytes(unescape(encodeURIComponent(e)))},bytesToString:function(e){return decodeURIComponent(escape(charenc.bin.bytesToString(e)))}},bin:{stringToBytes:function(e){for(var t=[],i=0;i<e.length;i++)t.push(255&e.charCodeAt(i));return t},bytesToString:function(e){for(var t=[],i=0;i<e.length;i++)t.push(String.fromCharCode(e[i]));return t.join("")}}},charenc_1=charenc,_isBuffer_1_1_6_isBuffer=function(e){return null!=e&&(isBuffer$2(e)||isSlowBuffer(e)||!!e._isBuffer)};function isBuffer$2(e){return !!e.constructor&&"function"==typeof e.constructor.isBuffer&&e.constructor.isBuffer(e)}function isSlowBuffer(e){return "function"==typeof e.readFloatLE&&"function"==typeof e.slice&&isBuffer$2(e.slice(0,0))}var md5=createCommonjsModule(function(e){function g(e,t){e.constructor==String?e=(t&&"binary"===t.encoding?y:b).stringToBytes(e):S(e)?e=Array.prototype.slice.call(e,0):Array.isArray(e)||e.constructor===Uint8Array||(e=e.toString());for(var i=v.bytesToWords(e),e=8*e.length,r=1732584193,n=-271733879,s=-1732584194,o=271733878,a=0;a<i.length;a++)i[a]=16711935&(i[a]<<8|i[a]>>>24)|4278255360&(i[a]<<24|i[a]>>>8);i[e>>>5]|=128<<e%32,i[14+(64+e>>>9<<4)]=e;for(var c=g._ff,u=g._gg,d=g._hh,l=g._ii,a=0;a<i.length;a+=16){var h=r,p=n,f=s,m=o,r=c(r,n,s,o,i[a+0],7,-680876936),o=c(o,r,n,s,i[a+1],12,-389564586),s=c(s,o,r,n,i[a+2],17,606105819),n=c(n,s,o,r,i[a+3],22,-1044525330);r=c(r,n,s,o,i[a+4],7,-176418897),o=c(o,r,n,s,i[a+5],12,1200080426),s=c(s,o,r,n,i[a+6],17,-1473231341),n=c(n,s,o,r,i[a+7],22,-45705983),r=c(r,n,s,o,i[a+8],7,1770035416),o=c(o,r,n,s,i[a+9],12,-1958414417),s=c(s,o,r,n,i[a+10],17,-42063),n=c(n,s,o,r,i[a+11],22,-1990404162),r=c(r,n,s,o,i[a+12],7,1804603682),o=c(o,r,n,s,i[a+13],12,-40341101),s=c(s,o,r,n,i[a+14],17,-1502002290),r=u(r,n=c(n,s,o,r,i[a+15],22,1236535329),s,o,i[a+1],5,-165796510),o=u(o,r,n,s,i[a+6],9,-1069501632),s=u(s,o,r,n,i[a+11],14,643717713),n=u(n,s,o,r,i[a+0],20,-373897302),r=u(r,n,s,o,i[a+5],5,-701558691),o=u(o,r,n,s,i[a+10],9,38016083),s=u(s,o,r,n,i[a+15],14,-660478335),n=u(n,s,o,r,i[a+4],20,-405537848),r=u(r,n,s,o,i[a+9],5,568446438),o=u(o,r,n,s,i[a+14],9,-1019803690),s=u(s,o,r,n,i[a+3],14,-187363961),n=u(n,s,o,r,i[a+8],20,1163531501),r=u(r,n,s,o,i[a+13],5,-1444681467),o=u(o,r,n,s,i[a+2],9,-51403784),s=u(s,o,r,n,i[a+7],14,1735328473),r=d(r,n=u(n,s,o,r,i[a+12],20,-1926607734),s,o,i[a+5],4,-378558),o=d(o,r,n,s,i[a+8],11,-2022574463),s=d(s,o,r,n,i[a+11],16,1839030562),n=d(n,s,o,r,i[a+14],23,-35309556),r=d(r,n,s,o,i[a+1],4,-1530992060),o=d(o,r,n,s,i[a+4],11,1272893353),s=d(s,o,r,n,i[a+7],16,-155497632),n=d(n,s,o,r,i[a+10],23,-1094730640),r=d(r,n,s,o,i[a+13],4,681279174),o=d(o,r,n,s,i[a+0],11,-358537222),s=d(s,o,r,n,i[a+3],16,-722521979),n=d(n,s,o,r,i[a+6],23,76029189),r=d(r,n,s,o,i[a+9],4,-640364487),o=d(o,r,n,s,i[a+12],11,-421815835),s=d(s,o,r,n,i[a+15],16,530742520),r=l(r,n=d(n,s,o,r,i[a+2],23,-995338651),s,o,i[a+0],6,-198630844),o=l(o,r,n,s,i[a+7],10,1126891415),s=l(s,o,r,n,i[a+14],15,-1416354905),n=l(n,s,o,r,i[a+5],21,-57434055),r=l(r,n,s,o,i[a+12],6,1700485571),o=l(o,r,n,s,i[a+3],10,-1894986606),s=l(s,o,r,n,i[a+10],15,-1051523),n=l(n,s,o,r,i[a+1],21,-2054922799),r=l(r,n,s,o,i[a+8],6,1873313359),o=l(o,r,n,s,i[a+15],10,-30611744),s=l(s,o,r,n,i[a+6],15,-1560198380),n=l(n,s,o,r,i[a+13],21,1309151649),r=l(r,n,s,o,i[a+4],6,-145523070),o=l(o,r,n,s,i[a+11],10,-1120210379),s=l(s,o,r,n,i[a+2],15,718787259),n=l(n,s,o,r,i[a+9],21,-343485551),r=r+h>>>0,n=n+p>>>0,s=s+f>>>0,o=o+m>>>0;}return v.endian([r,n,s,o])}var v,b,S,y;v=crypt,b=charenc_1.utf8,S=_isBuffer_1_1_6_isBuffer,y=charenc_1.bin,g._ff=function(e,t,i,r,n,s,o){o=e+(t&i|~t&r)+(n>>>0)+o;return (o<<s|o>>>32-s)+t},g._gg=function(e,t,i,r,n,s,o){o=e+(t&r|i&~r)+(n>>>0)+o;return (o<<s|o>>>32-s)+t},g._hh=function(e,t,i,r,n,s,o){o=e+(t^i^r)+(n>>>0)+o;return (o<<s|o>>>32-s)+t},g._ii=function(e,t,i,r,n,s,o){o=e+(i^(t|~r))+(n>>>0)+o;return (o<<s|o>>>32-s)+t},g._blocksize=16,g._digestsize=16,e.exports=function(e,t){if(null==e)throw new Error("Illegal argument "+e);e=v.wordsToBytes(g(e,t));return t&&t.asBytes?e:t&&t.asString?y.bytesToString(e):v.bytesToHex(e)};});class ccHttpClient extends ccServer{constructor(){super();}location(e,r){var t={tag:null,cmd:"lookup",ver:"4.0",dev:"",devt:"web",os:navigator.userAgent.toLowerCase()},e=Object.assign(t,e);let n={options:{url:"/login/location?cmd=lookup",method:"post",data:JSON.stringify(e)}};return new Promise((t,i)=>{fetch$1(n,r).then(e=>{this.serverUrl=e.data.serverAddress,t(!0);}).catch(e=>{console.log(e),i(!1);});})}async registerCC(e,t){var i=getMoble();!e.user&&e.name&&(e.user=md5(e.name));var r,i={options:{url:"/regist?cmd=register",method:"post",data:JSON.stringify({user:e,info:{email:i+"@net263.com",tel:i,phone:i,fax:i}})}};return !!(r=0==this.serverUrl.length?await this.location({name:e.name},t):r)&&fetch$1(i,this.findUrl(9))}async ulogin(e,t){var i={tag:"",cmd:"auth",ver:"4.0",dev:"web",devt:"web",os:navigator.userAgent.toLowerCase(),captcha:85},i=Object.assign(i,e);console.log(i);i={options:{url:"/login/ulogin?cmd=auth",method:"post",data:JSON.stringify(i)}};0==this.serverUrl.length&&await this.location({name:e.name},t);t=this.findUrl(1);console.log(t);let r={serverUrlList:this.serverUrl,data:null};return r.data=await fetch$1(i,t),r}async logAuth(e,t){var i={tag:"",cmd:"sa",ver:"4.0",dev:"web",devt:"web",os:navigator.userAgent.toLowerCase(),captcha:85},e=Object.assign(i,e),e={options:{url:"/login/ulogin?cmd=auth&bindid="+t,method:"post",data:JSON.stringify(e)}};return !!await this.location(locationbaseUrl)&&fetch$1(e,this.findUrl(1))}getaptcha(e){return fetch$1({options:{url:"/login/ulogin?cmd=captcha&captchas=15",method:"post",data:JSON.stringify(e)}},this.findUrl(1))}department(e){var t={cmd:"get",obj:"department",tag:"",updatetime:0,version:"",ver:"1.0.0",dev:"web",devt:"web",os:navigator.userAgent.toLowerCase()},e=Object.assign(t,e);return fetch$1({options:{url:"/resource/userdata?cmd=get&obj=department",method:"post",data:JSON.stringify(e)}},this.findUrl(5))}departmentuser(e){var t={cmd:"get",obj:"department_user",tag:"",updatetime:0,version:"",ver:"1.0.0",dev:"web",devt:"web",os:navigator.userAgent.toLowerCase()},e=Object.assign(t,e);return fetch$1({options:{url:"/resource/userdata?cmd=get&obj=department_user",method:"post",data:JSON.stringify(e)}},this.findUrl(5))}user(e){var t={cmd:"get",obj:"user",tag:"",updatetime:0,version:"",ver:"1.0.0",dev:"web",devt:"web",os:navigator.userAgent.toLowerCase()},e=Object.assign(t,e);return fetch$1({options:{url:"/resource/userdata?cmd=get&obj=user",method:"post",data:JSON.stringify(e)}},this.findUrl(5))}orgcontacts(e){var t={cmd:"download",obj:"orgcontacts",tag:"",updatetime:0,version:"",ver:"1.0.0",dev:"web",devt:"web",os:navigator.userAgent.toLowerCase()},e=Object.assign(t,e);return fetch$1({options:{url:"/resource/userdata?cmd=download&obj=orgcontacts",method:"post",data:JSON.stringify(e)}},this.findUrl(5))}getGroupMember(e){var t={cmd:"get",obj:"fixedgroups_user",tag:"",updatetime:0,ver:"1.0.0",dev:"web",devt:"web",os:navigator.userAgent.toLowerCase()},e=Object.assign(t,e);return fetch$1({options:{url:"/resource/userdata?cmd=get&obj=fixedgroups_user",method:"post",data:JSON.stringify(e)}},this.findUrl(5))}getGroupInfo(e){var t={cmd:"get",obj:"fixedgroups",tag:"",updatetime:0,ver:"1.0.0",dev:"web",devt:"web",os:navigator.userAgent.toLowerCase()},e=Object.assign(t,e);return fetch$1({options:{url:"/resource/userdata?cmd=get&obj=fixedgroups",method:"post",data:JSON.stringify(e)}},this.findUrl(5))}}var bignumber=createCommonjsModule(function(e){function M(e){var t=0|e;return 0<e||e===t?t:t-1}function N(e){for(var t,i,r=1,n=e.length,s=e[0]+"";r<n;){for(t=e[r++]+"",i=X-t.length;i--;t="0"+t);s+=t;}for(n=s.length;48===s.charCodeAt(--n););return s.slice(0,n+1||1)}function U(e,t){var i,r=e.c,n=t.c,s=e.s,o=t.s,a=e.e,e=t.e;if(!s||!o)return null;if(i=r&&!r[0],t=n&&!n[0],i||t)return i?t?0:-o:s;if(s!=o)return s;if(i=s<0,t=a==e,!r||!n)return t?0:!r^i?1:-1;if(!t)return e<a^i?1:-1;for(o=(a=r.length)<(e=n.length)?a:e,s=0;s<o;s++)if(r[s]!=n[s])return r[s]>n[s]^i?1:-1;return a==e?0:e<a^i?1:-1}function D(e,t,i,r){if(e<t||i<e||e!==G(e))throw Error(H+(r||"Argument")+("number"==typeof e?e<t||i<e?" out of range: ":" not an integer: ":" not a primitive number: ")+String(e))}function B(e){var t=e.c.length-1;return M(e.e/X)==t&&e.c[t]%2!=0}function F(e,t){return (1<e.length?e.charAt(0)+"."+e.slice(1):e)+(t<0?"e":"e+")+t}function V(e,t,i){var r,n;if(t<0){for(n=i+".";++t;n+=i);e=n+e;}else if(++t>(r=e.length)){for(n=i,t-=r;--t;n+=i);e+=n;}else t<r&&(e=e.slice(0,t)+"."+e.slice(t));return e}var t,i,J,q,G,H,W,z,X,Y,Z,K,Q;t=commonjsGlobal,J=/^-?(?:\d+(?:\.\d*)?|\.\d+)(?:e[+-]?\d+)?$/i,q=Math.ceil,G=Math.floor,W=(H="[BigNumber Error] ")+"Number primitive has more than 15 significant digits: ",z=1e14,X=14,Y=9007199254740991,Z=[1,10,100,1e3,1e4,1e5,1e6,1e7,1e8,1e9,1e10,1e11,1e12,1e13],K=1e7,Q=1e9,(i=function e(t){var g,l,h,i,u,v,o,a,c,d,p,r=x.prototype={constructor:x,toString:null,valueOf:null},f=new x(1),b=20,S=4,m=-7,y=21,w=-1e7,C=1e7,_=!1,n=1,I=0,E={prefix:"",groupSize:3,secondaryGroupSize:0,groupSeparator:",",decimalSeparator:".",fractionGroupSize:0,fractionGroupSeparator:" ",suffix:""},k="0123456789abcdefghijklmnopqrstuvwxyz";function x(e,t){var i,r,n,s,o,a,c,u,d=this;if(!(d instanceof x))return new x(e,t);if(null==t){if(e&&!0===e._isBigNumber)return d.s=e.s,void(!e.c||e.e>C?d.c=d.e=null:e.e<w?d.c=[d.e=0]:(d.e=e.e,d.c=e.c.slice()));if((a="number"==typeof e)&&0*e==0){if(d.s=1/e<0?(e=-e,-1):1,e===~~e){for(s=0,o=e;10<=o;o/=10,s++);return void(C<s?d.c=d.e=null:(d.e=s,d.c=[e]))}u=String(e);}else {if(!J.test(u=String(e)))return h(d,u,a);d.s=45==u.charCodeAt(0)?(u=u.slice(1),-1):1;}0<(o=(u=-1<(s=u.indexOf("."))?u.replace(".",""):u).search(/e/i))?(s<0&&(s=o),s+=+u.slice(o+1),u=u.substring(0,o)):s<0&&(s=u.length);}else {if(D(t,2,k.length,"Base"),10==t)return O(d=new x(e),b+d.e+1,S);if(u=String(e),a="number"==typeof e){if(0*e!=0)return h(d,u,a,t);if(d.s=1/e<0?(u=u.slice(1),-1):1,x.DEBUG&&15<u.replace(/^0\.0*|\./,"").length)throw Error(W+e)}else d.s=45===u.charCodeAt(0)?(u=u.slice(1),-1):1;for(i=k.slice(0,t),s=o=0,c=u.length;o<c;o++)if(i.indexOf(r=u.charAt(o))<0){if("."==r){if(s<o){s=c;continue}}else if(!n&&(u==u.toUpperCase()&&(u=u.toLowerCase())||u==u.toLowerCase()&&(u=u.toUpperCase()))){n=!0,o=-1,s=0;continue}return h(d,String(e),a,t)}a=!1,-1<(s=(u=l(u,t,10,d.s)).indexOf("."))?u=u.replace(".",""):s=u.length;}for(o=0;48===u.charCodeAt(o);o++);for(c=u.length;48===u.charCodeAt(--c););if(u=u.slice(o,++c)){if(c-=o,a&&x.DEBUG&&15<c&&(Y<e||e!==G(e)))throw Error(W+d.s*e);if((s=s-o-1)>C)d.c=d.e=null;else if(s<w)d.c=[d.e=0];else {if(d.e=s,d.c=[],o=(s+1)%X,s<0&&(o+=X),o<c){for(o&&d.c.push(+u.slice(0,o)),c-=X;o<c;)d.c.push(+u.slice(o,o+=X));o=X-(u=u.slice(o)).length;}else o-=c;for(;o--;u+="0");d.c.push(+u);}}else d.c=[d.e=0];}function A(e,t,i,r){for(var n,s,o=[0],a=0,c=e.length;a<c;){for(s=o.length;s--;o[s]*=t);for(o[0]+=r.indexOf(e.charAt(a++)),n=0;n<o.length;n++)o[n]>i-1&&(null==o[n+1]&&(o[n+1]=0),o[n+1]+=o[n]/i|0,o[n]%=i);}return o.reverse()}function T(e,t,i){var r,n,s,o=0,a=e.length,c=t%K,u=t/K|0;for(e=e.slice();a--;)o=((n=c*(n=e[a]%K)+(r=u*n+(s=e[a]/K|0)*c)%K*K+o)/i|0)+(r/K|0)+u*s,e[a]=n%i;return e=o?[o].concat(e):e}function R(e,t,i,r){var n,s;if(i!=r)s=r<i?1:-1;else for(n=s=0;n<i;n++)if(e[n]!=t[n]){s=e[n]>t[n]?1:-1;break}return s}function L(e,t,i,r){for(var n=0;i--;)e[i]-=n,n=e[i]<t[i]?1:0,e[i]=n*r+e[i]-t[i];for(;!e[0]&&1<e.length;e.splice(0,1));}function s(e,t,i,r){var n,s,o,a;if(null==i?i=S:D(i,0,8),!e.c)return e.toString();if(n=e.c[0],s=e.e,null==t)a=N(e.c),a=1==r||2==r&&(s<=m||y<=s)?F(a,s):V(a,s,"0");else if(i=(e=O(new x(e),t,i)).e,o=(a=N(e.c)).length,1==r||2==r&&(t<=i||i<=m)){for(;o<t;a+="0",o++);a=F(a,i);}else if(t-=s,a=V(a,i,"0"),o<i+1){if(0<--t)for(a+=".";t--;a+="0");}else if(0<(t+=i-o))for(i+1==o&&(a+=".");t--;a+="0");return e.s<0&&n?"-"+a:a}function P(e,t){for(var i,r=1,n=new x(e[0]);r<e.length;r++){if(!(i=new x(e[r])).s){n=i;break}t.call(n,i)&&(n=i);}return n}function $(e,t,i){for(var r=1,n=t.length;!t[--n];t.pop());for(n=t[0];10<=n;n/=10,r++);return (i=r+i*X-1)>C?e.c=e.e=null:i<w?e.c=[e.e=0]:(e.e=i,e.c=t),e}function O(e,t,i,r){var n,s,o,a,c,u,d,l=e.c,h=Z;if(l){e:{for(n=1,a=l[0];10<=a;a/=10,n++);if((s=t-n)<0)s+=X,o=t,d=(c=l[u=0])/h[n-o-1]%10|0;else if((u=q((s+1)/X))>=l.length){if(!r)break e;for(;l.length<=u;l.push(0));c=d=0,o=(s%=X)-X+(n=1);}else {for(c=a=l[u],n=1;10<=a;a/=10,n++);d=(o=(s%=X)-X+n)<0?0:c/h[n-o-1]%10|0;}if(r=r||t<0||null!=l[u+1]||(o<0?c:c%h[n-o-1]),r=i<4?(d||r)&&(0==i||i==(e.s<0?3:2)):5<d||5==d&&(4==i||r||6==i&&(0<s?0<o?c/h[n-o]:0:l[u-1])%10&1||i==(e.s<0?8:7)),t<1||!l[0])return l.length=0,r?(t-=e.e+1,l[0]=h[(X-t%X)%X],e.e=-t||0):l[0]=e.e=0,e;if(0==s?(l.length=u,a=1,u--):(l.length=u+1,a=h[X-s],l[u]=0<o?G(c/h[n-o]%h[o])*a:0),r)for(;;){if(0==u){for(s=1,o=l[0];10<=o;o/=10,s++);for(o=l[0]+=a,a=1;10<=o;o/=10,a++);s!=a&&(e.e++,l[0]==z&&(l[0]=1));break}if(l[u]+=a,l[u]!=z)break;l[u--]=0,a=1;}for(s=l.length;0===l[--s];l.pop());}e.e>C?e.c=e.e=null:e.e<w&&(e.c=[e.e=0]);}return e}function j(e){var t,i=e.e;return null===i?e.toString():(t=N(e.c),t=i<=m||y<=i?F(t,i):V(t,i,"0"),e.s<0?"-"+t:t)}return x.clone=e,x.ROUND_UP=0,x.ROUND_DOWN=1,x.ROUND_CEIL=2,x.ROUND_FLOOR=3,x.ROUND_HALF_UP=4,x.ROUND_HALF_DOWN=5,x.ROUND_HALF_EVEN=6,x.ROUND_HALF_CEIL=7,x.ROUND_HALF_FLOOR=8,x.EUCLID=9,x.config=x.set=function(e){var t,i;if(null!=e){if("object"!=typeof e)throw Error(H+"Object expected: "+e);if(e.hasOwnProperty(t="DECIMAL_PLACES")&&(D(i=e[t],0,Q,t),b=i),e.hasOwnProperty(t="ROUNDING_MODE")&&(D(i=e[t],0,8,t),S=i),e.hasOwnProperty(t="EXPONENTIAL_AT")&&((i=e[t])&&i.pop?(D(i[0],-Q,0,t),D(i[1],0,Q,t),m=i[0],y=i[1]):(D(i,-Q,Q,t),m=-(y=i<0?-i:i))),e.hasOwnProperty(t="RANGE"))if((i=e[t])&&i.pop)D(i[0],-Q,-1,t),D(i[1],1,Q,t),w=i[0],C=i[1];else {if(D(i,-Q,Q,t),!i)throw Error(H+t+" cannot be zero: "+i);w=-(C=i<0?-i:i);}if(e.hasOwnProperty(t="CRYPTO")){if((i=e[t])!==!!i)throw Error(H+t+" not true or false: "+i);if(i){if("undefined"==typeof crypto||!crypto||!crypto.getRandomValues&&!crypto.randomBytes)throw _=!i,Error(H+"crypto unavailable");_=i;}else _=i;}if(e.hasOwnProperty(t="MODULO_MODE")&&(D(i=e[t],0,9,t),n=i),e.hasOwnProperty(t="POW_PRECISION")&&(D(i=e[t],0,Q,t),I=i),e.hasOwnProperty(t="FORMAT")){if("object"!=typeof(i=e[t]))throw Error(H+t+" not an object: "+i);E=i;}if(e.hasOwnProperty(t="ALPHABET")){if("string"!=typeof(i=e[t])||/^.?$|[+\-.\s]|(.).*\1/.test(i))throw Error(H+t+" invalid: "+i);k=i;}}return {DECIMAL_PLACES:b,ROUNDING_MODE:S,EXPONENTIAL_AT:[m,y],RANGE:[w,C],CRYPTO:_,MODULO_MODE:n,POW_PRECISION:I,FORMAT:E,ALPHABET:k}},x.isBigNumber=function(e){if(!e||!0!==e._isBigNumber)return !1;if(!x.DEBUG)return !0;var t,i,r=e.c,n=e.e,s=e.s;e:if("[object Array]"=={}.toString.call(r)){if((1===s||-1===s)&&-Q<=n&&n<=Q&&n===G(n))if(0!==r[0]){if((t=(n+1)%X)<1&&(t+=X),String(r[0]).length==t){for(t=0;t<r.length;t++)if((i=r[t])<0||z<=i||i!==G(i))break e;if(0!==i)return !0}}else if(0===n&&1===r.length)return !0}else if(null===r&&null===n&&(null===s||1===s||-1===s))return !0;throw Error(H+"Invalid BigNumber: "+e)},x.maximum=x.max=function(){return P(arguments,r.lt)},x.minimum=x.min=function(){return P(arguments,r.gt)},x.random=(i=9007199254740992,u=Math.random()*i&2097151?function(){return G(Math.random()*i)}:function(){return 8388608*(1073741824*Math.random()|0)+(8388608*Math.random()|0)},function(e){var t,i,r,n,s,o=0,a=[],c=new x(f);if(null==e?e=b:D(e,0,Q),n=q(e/X),_)if(crypto.getRandomValues){for(t=crypto.getRandomValues(new Uint32Array(n*=2));o<n;)9e15<=(s=131072*t[o]+(t[o+1]>>>11))?(i=crypto.getRandomValues(new Uint32Array(2)),t[o]=i[0],t[o+1]=i[1]):(a.push(s%1e14),o+=2);o=n/2;}else {if(!crypto.randomBytes)throw _=!1,Error(H+"crypto unavailable");for(t=crypto.randomBytes(n*=7);o<n;)9e15<=(s=281474976710656*(31&t[o])+1099511627776*t[o+1]+4294967296*t[o+2]+16777216*t[o+3]+(t[o+4]<<16)+(t[o+5]<<8)+t[o+6])?crypto.randomBytes(7).copy(t,o):(a.push(s%1e14),o+=7);o=n/7;}if(!_)for(;o<n;)(s=u())<9e15&&(a[o++]=s%1e14);for(n=a[--o],e%=X,n&&e&&(a[o]=G(n/(s=Z[X-e]))*s);0===a[o];a.pop(),o--);if(o<0)a=[r=0];else {for(r=-1;0===a[0];a.splice(0,1),r-=X);for(o=1,s=a[0];10<=s;s/=10,o++);o<X&&(r-=X-o);}return c.e=r,c.c=a,c}),x.sum=function(){for(var e=1,t=arguments,i=new x(t[0]);e<t.length;)i=i.plus(t[e++]);return i},v="0123456789",l=function(e,t,i,r,n){var s,o,a,c,u,d,l,h,p=e.indexOf("."),f=b,m=S;for(0<=p&&(c=I,I=0,e=e.replace(".",""),d=(h=new x(t)).pow(e.length-p),I=c,h.c=A(V(N(d.c),d.e,"0"),10,i,v),h.e=h.c.length),a=c=(l=A(e,t,i,n?(s=k,v):(s=v,k))).length;0==l[--c];l.pop());if(!l[0])return s.charAt(0);if(p<0?--a:(d.c=l,d.e=a,d.s=r,l=(d=g(d,h,f,m,i)).c,u=d.r,a=d.e),p=l[o=a+f+1],c=i/2,u=u||o<0||null!=l[o+1],u=m<4?(null!=p||u)&&(0==m||m==(d.s<0?3:2)):c<p||p==c&&(4==m||u||6==m&&1&l[o-1]||m==(d.s<0?8:7)),o<1||!l[0])e=u?V(s.charAt(1),-f,s.charAt(0)):s.charAt(0);else {if(l.length=o,u)for(--i;++l[--o]>i;)l[o]=0,o||(++a,l=[1].concat(l));for(c=l.length;!l[--c];);for(p=0,e="";p<=c;e+=s.charAt(l[p++]));e=V(e,a,s.charAt(0));}return e},g=function(e,t,i,r,n){var s,o,a,c,u,d,l,h,p,f,m,g,v,b,S,y,w,C=e.s==t.s?1:-1,_=e.c,I=t.c;if(!(_&&_[0]&&I&&I[0]))return new x(e.s&&t.s&&(_?!I||_[0]!=I[0]:I)?_&&0==_[0]||!I?0*C:C/0:NaN);for(p=(h=new x(C)).c=[],C=i+(o=e.e-t.e)+1,n||(n=z,o=M(e.e/X)-M(t.e/X),C=C/X|0),a=0;I[a]==(_[a]||0);a++);if(I[a]>(_[a]||0)&&o--,C<0)p.push(1),c=!0;else {for(b=_.length,y=I.length,C+=2,1<(u=G(n/(I[a=0]+1)))&&(I=T(I,u,n),_=T(_,u,n),y=I.length,b=_.length),v=y,m=(f=_.slice(0,y)).length;m<y;f[m++]=0);w=I.slice(),w=[0].concat(w),S=I[0],I[1]>=n/2&&S++;do{if(u=0,(s=R(I,f,y,m))<0){if(g=f[0],y!=m&&(g=g*n+(f[1]||0)),1<(u=G(g/S)))for(l=(d=T(I,u=n<=u?n-1:u,n)).length,m=f.length;1==R(d,f,l,m);)u--,L(d,y<l?w:I,l,n),l=d.length,s=1;else 0==u&&(s=u=1),l=(d=I.slice()).length;if(L(f,d=l<m?[0].concat(d):d,m,n),m=f.length,-1==s)for(;R(I,f,y,m)<1;)u++,L(f,y<m?w:I,m,n),m=f.length;}else 0===s&&(u++,f=[0]);}while(p[a++]=u,f[0]?f[m++]=_[v]||0:(f=[_[v]],m=1),(v++<b||null!=f[0])&&C--);c=null!=f[0],p[0]||p.splice(0,1);}if(n==z){for(a=1,C=p[0];10<=C;C/=10,a++);O(h,i+(h.e=a+o*X-1)+1,r,c);}else h.e=o,h.r=+c;return h},o=/^(-?)0([xbo])(?=\w[\w.]*$)/i,a=/^([^.]+)\.$/,c=/^\.([^.]+)$/,d=/^-?(Infinity|NaN)$/,p=/^\s*\+(?=[\w.])|^\s+|\s+$/g,h=function(e,t,i,r){var n,s=i?t:t.replace(p,"");if(d.test(s))e.s=isNaN(s)?null:s<0?-1:1;else {if(!i&&(s=s.replace(o,function(e,t,i){return n="x"==(i=i.toLowerCase())?16:"b"==i?2:8,r&&r!=n?e:t}),r&&(n=r,s=s.replace(a,"$1").replace(c,"0.$1")),t!=s))return new x(s,n);if(x.DEBUG)throw Error(H+"Not a"+(r?" base "+r:"")+" number: "+t);e.s=null;}e.c=e.e=null;},r.absoluteValue=r.abs=function(){var e=new x(this);return e.s<0&&(e.s=1),e},r.comparedTo=function(e,t){return U(this,new x(e,t))},r.decimalPlaces=r.dp=function(e,t){var i,r;if(null!=e)return D(e,0,Q),null==t?t=S:D(t,0,8),O(new x(this),e+this.e+1,t);if(!(t=this.c))return null;if(i=((r=t.length-1)-M(this.e/X))*X,r=t[r])for(;r%10==0;r/=10,i--);return i=i<0?0:i},r.dividedBy=r.div=function(e,t){return g(this,new x(e,t),b,S)},r.dividedToIntegerBy=r.idiv=function(e,t){return g(this,new x(e,t),0,1)},r.exponentiatedBy=r.pow=function(e,t){var i,r,n,s,o,a,c,u,d=this;if((e=new x(e)).c&&!e.isInteger())throw Error(H+"Exponent not an integer: "+j(e));if(null!=t&&(t=new x(t)),o=14<e.e,!d.c||!d.c[0]||1==d.c[0]&&!d.e&&1==d.c.length||!e.c||!e.c[0])return u=new x(Math.pow(+j(d),o?2-B(e):+j(e))),t?u.mod(t):u;if(a=e.s<0,t){if(t.c?!t.c[0]:!t.s)return new x(NaN);(r=!a&&d.isInteger()&&t.isInteger())&&(d=d.mod(t));}else {if(9<e.e&&(0<d.e||d.e<-1||(0==d.e?1<d.c[0]||o&&24e7<=d.c[1]:d.c[0]<8e13||o&&d.c[0]<=9999975e7)))return s=d.s<0&&B(e)?-0:0,-1<d.e&&(s=1/s),new x(a?1/s:s);I&&(s=q(I/X+2));}for(c=o?(i=new x(.5),a&&(e.s=1),B(e)):(n=Math.abs(+j(e)))%2,u=new x(f);;){if(c){if(!(u=u.times(d)).c)break;s?u.c.length>s&&(u.c.length=s):r&&(u=u.mod(t));}if(n){if(0===(n=G(n/2)))break;c=n%2;}else if(O(e=e.times(i),e.e+1,1),14<e.e)c=B(e);else {if(0==(n=+j(e)))break;c=n%2;}d=d.times(d),s?d.c&&d.c.length>s&&(d.c.length=s):r&&(d=d.mod(t));}return r?u:(a&&(u=f.div(u)),t?u.mod(t):s?O(u,I,S,void 0):u)},r.integerValue=function(e){var t=new x(this);return null==e?e=S:D(e,0,8),O(t,t.e+1,e)},r.isEqualTo=r.eq=function(e,t){return 0===U(this,new x(e,t))},r.isFinite=function(){return !!this.c},r.isGreaterThan=r.gt=function(e,t){return 0<U(this,new x(e,t))},r.isGreaterThanOrEqualTo=r.gte=function(e,t){return 1===(t=U(this,new x(e,t)))||0===t},r.isInteger=function(){return !!this.c&&M(this.e/X)>this.c.length-2},r.isLessThan=r.lt=function(e,t){return U(this,new x(e,t))<0},r.isLessThanOrEqualTo=r.lte=function(e,t){return -1===(t=U(this,new x(e,t)))||0===t},r.isNaN=function(){return !this.s},r.isNegative=function(){return this.s<0},r.isPositive=function(){return 0<this.s},r.isZero=function(){return !!this.c&&0==this.c[0]},r.minus=function(e,t){var i,r,n,s,o=this,a=o.s;if(t=(e=new x(e,t)).s,!a||!t)return new x(NaN);if(a!=t)return e.s=-t,o.plus(e);var c=o.e/X,u=e.e/X,d=o.c,l=e.c;if(!c||!u){if(!d||!l)return d?(e.s=-t,e):new x(l?o:NaN);if(!d[0]||!l[0])return l[0]?(e.s=-t,e):new x(d[0]?o:3==S?-0:0)}if(c=M(c),u=M(u),d=d.slice(),a=c-u){for((n=(s=a<0)?(a=-a,d):(u=c,l)).reverse(),t=a;t--;n.push(0));n.reverse();}else for(r=(s=(a=d.length)<(t=l.length))?a:t,a=t=0;t<r;t++)if(d[t]!=l[t]){s=d[t]<l[t];break}if(s&&(n=d,d=l,l=n,e.s=-e.s),0<(t=(r=l.length)-(i=d.length)))for(;t--;d[i++]=0);for(t=z-1;a<r;){if(d[--r]<l[r]){for(i=r;i&&!d[--i];d[i]=t);--d[i],d[r]+=z;}d[r]-=l[r];}for(;0==d[0];d.splice(0,1),--u);return d[0]?$(e,d,u):(e.s=3==S?-1:1,e.c=[e.e=0],e)},r.modulo=r.mod=function(e,t){var i,r=this;return e=new x(e,t),!r.c||!e.s||e.c&&!e.c[0]?new x(NaN):!e.c||r.c&&!r.c[0]?new x(r):(9==n?(t=e.s,e.s=1,i=g(r,e,0,3),e.s=t,i.s*=t):i=g(r,e,0,n),(e=r.minus(i.times(e))).c[0]||1!=n||(e.s=r.s),e)},r.multipliedBy=r.times=function(e,t){var i,r,n,s,o,a,c,u,d,l,h,p=this,f=p.c,m=(e=new x(e,t)).c;if(!(f&&m&&f[0]&&m[0]))return !p.s||!e.s||f&&!f[0]&&!m||m&&!m[0]&&!f?e.c=e.e=e.s=null:(e.s*=p.s,f&&m?(e.c=[0],e.e=0):e.c=e.e=null),e;for(t=M(p.e/X)+M(e.e/X),e.s*=p.s,(a=f.length)<(p=m.length)&&(h=f,f=m,m=h,r=a,a=p,p=r),r=a+p,h=[];r--;h.push(0));for(r=p;0<=--r;){for(d=m[r]%1e7,l=m[r]/1e7|(i=0),n=r+(s=a);r<n;)i=((c=d*(c=f[--s]%1e7)+(o=l*c+(u=f[s]/1e7|0)*d)%1e7*1e7+h[n]+i)/1e14|0)+(o/1e7|0)+l*u,h[n--]=c%1e14;h[n]=i;}return i?++t:h.splice(0,1),$(e,h,t)},r.negated=function(){var e=new x(this);return e.s=-e.s||null,e},r.plus=function(e,t){var i,r=this,n=r.s;if(t=(e=new x(e,t)).s,!n||!t)return new x(NaN);if(n!=t)return e.s=-t,r.minus(e);var s=r.e/X,o=e.e/X,a=r.c,c=e.c;if(!s||!o){if(!a||!c)return new x(n/0);if(!a[0]||!c[0])return c[0]?e:new x(a[0]?r:0*n)}if(s=M(s),o=M(o),a=a.slice(),n=s-o){for((i=0<n?(o=s,c):(n=-n,a)).reverse();n--;i.push(0));i.reverse();}for((n=a.length)-(t=c.length)<0&&(i=c,c=a,a=i,t=n),n=0;t;)n=(a[--t]=a[t]+c[t]+n)/z|0,a[t]=z===a[t]?0:a[t]%z;return n&&(a=[n].concat(a),++o),$(e,a,o)},r.precision=r.sd=function(e,t){var i,r;if(null!=e&&e!==!!e)return D(e,1,Q),null==t?t=S:D(t,0,8),O(new x(this),e,t);if(!(t=this.c))return null;if(i=(r=t.length-1)*X+1,r=t[r]){for(;r%10==0;r/=10,i--);for(r=t[0];10<=r;r/=10,i++);}return i=e&&this.e+1>i?this.e+1:i},r.shiftedBy=function(e){return D(e,-Y,Y),this.times("1e"+e)},r.squareRoot=r.sqrt=function(){var e,t,i,r,n,s=this,o=s.c,a=s.s,c=s.e,u=b+4,d=new x("0.5");if(1!==a||!o||!o[0])return new x(!a||a<0&&(!o||o[0])?NaN:o?s:1/0);if((i=0==(a=Math.sqrt(+j(s)))||a==1/0?(((t=N(o)).length+c)%2==0&&(t+="0"),a=Math.sqrt(+t),c=M((c+1)/2)-(c<0||c%2),new x(t=a==1/0?"5e"+c:(t=a.toExponential()).slice(0,t.indexOf("e")+1)+c)):new x(a+"")).c[0])for((a=(c=i.e)+u)<3&&(a=0);;)if(n=i,i=d.times(n.plus(g(s,n,u,1))),N(n.c).slice(0,a)===(t=N(i.c)).slice(0,a)){if(i.e<c&&--a,"9999"!=(t=t.slice(a-3,a+1))&&(r||"4999"!=t)){+t&&(+t.slice(1)||"5"!=t.charAt(0))||(O(i,i.e+b+2,1),e=!i.times(i).eq(s));break}if(!r&&(O(n,n.e+b+2,0),n.times(n).eq(s))){i=n;break}u+=4,a+=4,r=1;}return O(i,i.e+b+1,S,e)},r.toExponential=function(e,t){return null!=e&&(D(e,0,Q),e++),s(this,e,t,1)},r.toFixed=function(e,t){return null!=e&&(D(e,0,Q),e=e+this.e+1),s(this,e,t)},r.toFormat=function(e,t,i){var r;if(null==i)null!=e&&t&&"object"==typeof t?(i=t,t=null):e&&"object"==typeof e?(i=e,e=t=null):i=E;else if("object"!=typeof i)throw Error(H+"Argument not an object: "+i);if(r=this.toFixed(e,t),this.c){var n,s=r.split("."),o=+i.groupSize,e=+i.secondaryGroupSize,a=i.groupSeparator||"",c=s[0],t=s[1],u=(s=this.s<0)?c.slice(1):c,d=u.length;if(e&&(n=o,o=e,d-=e=n),0<o&&0<d){for(c=u.substr(0,n=d%o||o);n<d;n+=o)c+=a+u.substr(n,o);0<e&&(c+=a+u.slice(n)),s&&(c="-"+c);}r=t?c+(i.decimalSeparator||"")+((e=+i.fractionGroupSize)?t.replace(new RegExp("\\d{"+e+"}\\B","g"),"$&"+(i.fractionGroupSeparator||"")):t):c;}return (i.prefix||"")+r+(i.suffix||"")},r.toFraction=function(e){var t,i,r,n,s,o,a,c,u,d,l=this,h=this.c;if(null!=e&&(!(o=new x(e)).isInteger()&&(o.c||1!==o.s)||o.lt(f)))throw Error(H+"Argument "+(o.isInteger()?"out of range: ":"not an integer: ")+j(o));if(!h)return new x(this);for(t=new x(f),c=i=new x(f),r=a=new x(f),d=N(h),s=t.e=d.length-this.e-1,t.c[0]=Z[(h=s%X)<0?X+h:h],e=!e||0<o.comparedTo(t)?0<s?t:c:o,h=C,C=1/0,o=new x(d),a.c[0]=0;u=g(o,t,0,1),1!=(n=i.plus(u.times(r))).comparedTo(e);)i=r,r=n,c=a.plus(u.times(n=c)),a=n,t=o.minus(u.times(n=t)),o=n;return n=g(e.minus(i),r,0,1),a=a.plus(n.times(c)),i=i.plus(n.times(r)),a.s=c.s=this.s,l=g(c,r,s*=2,S).minus(this).abs().comparedTo(g(a,i,s,S).minus(this).abs())<1?[c,r]:[a,i],C=h,l},r.toNumber=function(){return +j(this)},r.toPrecision=function(e,t){return null!=e&&D(e,1,Q),s(this,e,t,2)},r.toString=function(e){var t,i=this,r=i.s,n=i.e;return null===n?r?(t="Infinity",r<0&&(t="-"+t)):t="NaN":(t=null==e?n<=m||y<=n?F(N(i.c),n):V(N(i.c),n,"0"):10===e?V(N((i=O(new x(i),b+n+1,S)).c),i.e,"0"):(D(e,2,k.length,"Base"),l(V(N(i.c),n,"0"),10,e,r,!0)),r<0&&i.c[0]&&(t="-"+t)),t},r.valueOf=r.toJSON=function(){return j(this)},r._isBigNumber=!0,null!=t&&x.set(t),x}()).default=i.BigNumber=i,e.exports?e.exports=i:(t=t||("undefined"!=typeof self&&self?self:window)).BigNumber=i;}),stringify=createCommonjsModule(function(e){var l,h,p,t,i,e=e.exports;function f(e){return t.lastIndex=0,t.test(e)?'"'+e.replace(t,function(e){var t=i[e];return "string"==typeof t?t:"\\u"+("0000"+e.charCodeAt(0).toString(16)).slice(-4)})+'"':'"'+e+'"'}t=/[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,i={"\b":"\\b","\t":"\\t","\n":"\\n","\f":"\\f","\r":"\\r",'"':'\\"',"\\":"\\\\"},"function"!=typeof e.stringify&&(e.stringify=function(e,t,i){var r;if(h=l="","number"==typeof i)for(r=0;r<i;r+=1)h+=" ";else "string"==typeof i&&(h=i);if((p=t)&&"function"!=typeof t&&("object"!=typeof t||"number"!=typeof t.length))throw new Error("JSON.stringify");return function i(e,t){var r,n,s,o,a,c=l,u=t[e],d=null!=u&&(u instanceof bignumber||bignumber.isBigNumber(u));switch(u&&"object"==typeof u&&"function"==typeof u.toJSON&&(u=u.toJSON(e)),typeof(u="function"==typeof p?p.call(t,e,u):u)){case"string":return d?u:f(u);case"number":return isFinite(u)?String(u):"null";case"boolean":case"null":case"bigint":return String(u);case"object":if(!u)return "null";if(l+=h,a=[],"[object Array]"===Object.prototype.toString.apply(u)){for(o=u.length,r=0;r<o;r+=1)a[r]=i(r,u)||"null";return s=0===a.length?"[]":l?"[\n"+l+a.join(",\n"+l)+"\n"+c+"]":"["+a.join(",")+"]",l=c,s}if(p&&"object"==typeof p)for(o=p.length,r=0;r<o;r+=1)"string"==typeof p[r]&&(s=i(n=p[r],u))&&a.push(f(n)+(l?": ":":")+s);else Object.keys(u).forEach(function(e){var t=i(e,u);t&&a.push(f(e)+(l?": ":":")+t);});return s=0===a.length?"{}":l?"{\n"+l+a.join(",\n"+l)+"\n"+c+"}":"{"+a.join(",")+"}",l=c,s}}("",{"":e})});}),BigNumber=null;const suspectProtoRx=/(?:_|\\u005[Ff])(?:_|\\u005[Ff])(?:p|\\u0070)(?:r|\\u0072)(?:o|\\u006[Ff])(?:t|\\u0074)(?:o|\\u006[Ff])(?:_|\\u005[Ff])(?:_|\\u005[Ff])/,suspectConstructorRx=/(?:c|\\u0063)(?:o|\\u006[Ff])(?:n|\\u006[Ee])(?:s|\\u0073)(?:t|\\u0074)(?:r|\\u0072)(?:u|\\u0075)(?:c|\\u0063)(?:t|\\u0074)(?:o|\\u006[Ff])(?:r|\\u0072)/;var json_parse=function(e){var i={strict:!1,storeAsString:!1,alwaysParseAsBig:!1,useNativeBigInt:!1,protoAction:"error",constructorAction:"error"};if(null!=e){if(!0===e.strict&&(i.strict=!0),!0===e.storeAsString&&(i.storeAsString=!0),i.alwaysParseAsBig=!0===e.alwaysParseAsBig&&e.alwaysParseAsBig,i.useNativeBigInt=!0===e.useNativeBigInt&&e.useNativeBigInt,void 0!==e.constructorAction){if("error"!==e.constructorAction&&"ignore"!==e.constructorAction&&"preserve"!==e.constructorAction)throw new Error('Incorrect value for constructorAction option, must be "error", "ignore" or undefined but passed '+e.constructorAction);i.constructorAction=e.constructorAction;}if(void 0!==e.protoAction){if("error"!==e.protoAction&&"ignore"!==e.protoAction&&"preserve"!==e.protoAction)throw new Error('Incorrect value for protoAction option, must be "error", "ignore" or undefined but passed '+e.protoAction);i.protoAction=e.protoAction;}}function t(){var e,t="";for("-"===a&&d(t="-");"0"<=a&&a<="9";)t+=a,d();if("."===a)for(t+=".";d()&&"0"<=a&&a<="9";)t+=a;if("e"===a||"E"===a)for(t+=a,d(),"-"!==a&&"+"!==a||(t+=a,d());"0"<=a&&a<="9";)t+=a,d();if(e=+t,isFinite(e))return null==BigNumber&&(BigNumber=bignumber),15<t.length?i.storeAsString?t:i.useNativeBigInt?BigInt(t):new BigNumber(t):i.alwaysParseAsBig?i.useNativeBigInt?BigInt(e):new BigNumber(e):e;u("Bad number");}var o,a,c,s={'"':'"',"\\":"\\","/":"/",b:"\b",f:"\f",n:"\n",r:"\r",t:"\t"},u=function(e){throw {name:"SyntaxError",message:e,at:o,text:c}},d=function(e){return e&&e!==a&&u("Expected '"+e+"' instead of '"+a+"'"),a=c.charAt(o),o+=1,a},r=function(){var e,t,i,r="";if('"'===a)for(var n=o;d();){if('"'===a)return n<o-1&&(r+=c.substring(n,o-1)),d(),r;if("\\"===a){if(n<o-1&&(r+=c.substring(n,o-1)),d(),"u"===a){for(t=i=0;t<4&&(e=parseInt(d(),16),isFinite(e));t+=1)i=16*i+e;r+=String.fromCharCode(i);}else {if("string"!=typeof s[a])break;r+=s[a];}n=o;}}u("Bad string");},n=function(){for(;a&&a<=" ";)d();},l=function(){switch(n(),a){case"{":return function(){var e,t=Object.create(null);if("{"===a){if(d("{"),n(),"}"===a)return d("}"),t;for(;a;){if(e=r(),n(),d(":"),!0===i.strict&&Object.hasOwnProperty.call(t,e)&&u('Duplicate key "'+e+'"'),!0===suspectProtoRx.test(e)?"error"===i.protoAction?u("Object contains forbidden prototype property"):"ignore"===i.protoAction?l():t[e]=l():!0===suspectConstructorRx.test(e)?"error"===i.constructorAction?u("Object contains forbidden constructor property"):"ignore"===i.constructorAction?l():t[e]=l():t[e]=l(),n(),"}"===a)return d("}"),t;d(","),n();}}u("Bad object");}();case"[":return function(){var e=[];if("["===a){if(d("["),n(),"]"===a)return d("]"),e;for(;a;){if(e.push(l()),n(),"]"===a)return d("]"),e;d(","),n();}}u("Bad array");}();case'"':return r();case"-":return t();default:return ("0"<=a&&a<="9"?t:function(){switch(a){case"t":return d("t"),d("r"),d("u"),d("e"),!0;case"f":return d("f"),d("a"),d("l"),d("s"),d("e"),!1;case"n":return d("n"),d("u"),d("l"),d("l"),null}u("Unexpected '"+a+"'");})()}};return function(e,s){return c=e+"",o=0,a=" ",e=l(),n(),a&&u("Syntax error"),"function"==typeof s?function t(e,i){var r,n=e[i];return n&&"object"==typeof n&&Object.keys(n).forEach(function(e){void 0!==(r=t(n,e))?n[e]=r:delete n[e];}),s.call(e,i,n)}({"":e},""):e}},parse=json_parse,json_stringify=stringify.stringify,_jsonBigint_1_0_0_jsonBigint=function(e){return {parse:parse(e),stringify:json_stringify}},parse$1=parse(),stringify$1=json_stringify;_jsonBigint_1_0_0_jsonBigint.parse=parse$1,_jsonBigint_1_0_0_jsonBigint.stringify=stringify$1;var MAX_TRIALS$1=25;function websocket(){class e extends ccServer{constructor(){super(),this.socket=null,this.timeoutObj=null,this.reloginTimer=null,this._reconnectTimes=0,this._json=_jsonBigint_1_0_0_jsonBigint({storeAsString:!0}),this.onopen=function(){},this.onmessage=function(e){},this.onclose=function(){},this.onerror=function(e){},this.getPushGroupMsg=()=>{},this.groupInfo=()=>{},this.getInviteNotice=()=>{},this.getreplyInviteMsg=()=>{},this.onReceiveApplyMsg=()=>{},this.getApplyGroupNotice=()=>{},this.onGroupPower=()=>{},this.onP2PMag=()=>{},this.OnchangeUserStatus=()=>{},this.getHostIdentity=()=>{},this.groupDelMemberMsg=()=>{},this.memberExitGroupMsg=()=>{},this.onReceiveGroupMsg=()=>{},this.onGroupAdminer=()=>{},this.exitCurLoign=()=>{},this.recollectSuccess=()=>{},this.recollecting=()=>{},this.recollectFailed=()=>{},this.getCvMcRoomControl=()=>{},this.getCvMcRoomMessage=()=>{},this.promisePool={},this.loginpromisePool={},this.lockReconnect=!1,this.url=null,this.sid=null;}connect(e){let t=this;t.url=e||this.findUrl(2),window.WebSocket=window.WebSocket||window.MozWebSocket,window.webSocket?console.log("Error: WebSocket is not supported ."):(this.socket=new WebSocket(t.url),this.socket.onopen=function(){t.lockReconnect=!1,t.clearIntelval(),t._reconnectTimes=0,t.setInterval(`cmd:9001\r
\r
id:${uuid(32,16)}\r
\r
`,3e4),t.onopen();},this.socket.onmessage=function(e){t.onmessage(e),t.DealGroupMessage(e);},this.socket.onclose=e=>{console.log(this.lockReconnect),this.lockReconnect||(this.lockReconnect=!0,setTimeout(()=>(console.log(this._reconnectTimes),this._reconnectTimes>MAX_TRIALS$1?(this._reconnectTimes=0,void(this.lockReconnect=!1)):(0==this._reconnectTimes&&this.recollecting(),this.recollect(),void(this.lockReconnect=!1))),2e3));},this.socket.onerror=function(e){t.onerror();});}send(e){return this.socket&&3!=this.socket.readyState?(this.socket.send(e),!0):3==this.socket.readyState?(this.clearIntelval(),void console.log("websocket connect is close,pleace try again")):(this.error("please connect to the server first !!!"),!1)}recollect(){this._reconnectTimes<MAX_TRIALS$1?(this.connect(this.url),this._reconnectTimes++,3==this.socket.readyState||(clearInterval(this.reloginTimer),this.clearIntelval(),this.onopen=async()=>{this._reconnectTimes=0,await this.login(this.sid),console.log("sdk cc reconnect success"),this.recollectSuccess(),this.setInterval(`cmd:9001\r
\r
id:${uuid(32,16)}\r
\r
`,3e4);})):(this.recollectFailed(),clearInterval(this.reloginTimer),this.clearIntelval());}login(i){return new Promise((e,t)=>{this.loginPromisePool={resolve:e,reject:t},this.sid=i,this.socket.send(JSON.stringify({cmd:"login",aid:100,sid:i}));})}sendP2PMsg(e,t,i,r){var n=r||1,r={node_type:5,start:JSON.parse(JSON.stringify((new Date).getTime()).substr(0,10))},r=i?Object.assign(r,i):r;this.socket.send(`cmd:1101\r
id:${uuid(32,16)}\r
\r
`+JSON.stringify({to:e,tocid:t,type:n,body:JSON.stringify(r)}));}createGroup(e){var t={name:"名称",topic:"公告",type:3,maxnum:500,auth:1},t=Object.assign(t,e);this.socket.send(`cmd:1401\r
id:${uuid(32,16)}\r
\r
`+JSON.stringify(t));}inviteGroup(e){this.socket.send(`cmd:1403\r
id:${uuid(32,16)}\r
\r
`+JSON.stringify(e));}responseInivte(e){this.socket.send(`cmd:1405\r
id:${uuid(32,16)}\r
\r
`+JSON.stringify(e));}setGroupAttr(e){this.socket.send(`cmd:1415\r
id:${uuid(32,16)}\r
\r
`+JSON.stringify(e));}async applyJoinGroup(e){e=await this.sendMessage(1407,e);return console.log(e),e}responseApply(e){this.socket.send(`cmd:1409\r
tag:1\r
id:${uuid(32,16)}\r
\r
`+JSON.stringify(e));}delGroupMember(e){this.socket.send(`cmd:1411\r
tag:1\r
id:${uuid(32,16)}\r
\r
`+JSON.stringify(e));}eixtGroup(e){this.socket.send(`cmd:1413\r
tag:1\r
id:${uuid(32,16)}\r
\r
`+JSON.stringify(e));}async transferHost(e){if(1==this.socket.readyState)return this.sendMessage(1421,e)}async setGroupMemberInfo(e){return 1==this.socket.readyState?this.sendMessage(1431,e):{info:"socket is not connect",status:500}}setGroupPower(e){this.socket.send(`cmd:1429\r
tag:1\r
id:${uuid(32,16)}\r
\r
`+JSON.stringify(e));}sendMessageToGroup(e,t){t=t||uuid(32,16);this.socket.send(`cmd:1301\r
tag:1\r
id:${t}\r
\r
`+JSON.stringify(e));}setGroupMsgReceive(e){this.socket.send(`cmd:1425\r
id:${uuid(32,16)}\r
\r
`+JSON.stringify(e));}sendPowerApplyInfo(e){this.socket.send(`cmd:1433\r
id:${uuid(32,16)}\r
\r
`+JSON.stringify(e));}setAdminer(e){this.socket.send(`cmd:1417\r
id:${uuid(32,16)}\r
\r
`+JSON.stringify(e));}confirmService(e){this.socket.send(`cmd:${e}\r
id:${uuid(32,16)}\r
\r
`);}historyMsgSync(e){this.socket.send(`cmd:2401\r
id:${uuid(32,16)}\r
\r
`+JSON.stringify(e));}setAlreadyReadGroupMsg(e){this.socket.send(`cmd:1501\r
id:${uuid(32,16)}\r
\r
`+JSON.stringify(e));}analysis(e){var t=this._json.parse(e.data.split("\r\n\r\n")[1]);let i=null,r=null,n=null,s=e.data.split("\r\n"),o={};for(let t=0;t<s.length;t++){let e=s[t].split(":")[0];var a=s[t].split(":")[1];-1!=s[t].indexOf("id")&&"id"==e?i=a:-1!=s[t].indexOf("cmd")&&"cmd"==e?r=a:-1!=s[t].indexOf("subtype")&&"subtype"==e?n=a:e&&a&&-1==e.indexOf("{")&&(o[e]=a);}return {requestData:t,cmd:r,subtype:n,msgId:i,resDataInfo:o}}sendMessage(i,r){return new Promise((e,t)=>{this.promisePool[i]={content:r,resolve:e,reject:t};t=`cmd:${i}\r
id:`+uuid(32,16),t=r?t+`\r
\r
`+JSON.stringify(r):t;this.socket.send(t);})}joinCvMcRoom(i,r){return new Promise((e,t)=>{this.promisePool[1605]={content:i,resolve:e,reject:t},this.socket.send(`cmd:1605\r
id:${uuid(32,16)}\r
app_id:${r}\r
\r
`+JSON.stringify(i));})}quitCvMcRoom(i,r){return new Promise((e,t)=>{this.promisePool[1607]={roomId:i,resolve:e,reject:t},this.socket.send(`cmd:1607\r
id:${uuid(32,16)}\r
app_id:${r}\r
room_id:${i}\r
\r
`+JSON.stringify({}));})}kickoutCvMcRoom(i,r,n,s){return new Promise((e,t)=>{this.promisePool[1613]={userList:r,resolve:e,reject:t};t=n||100;this.socket.send(`cmd:1613\r
id:${uuid(32,16)}\r
app_id:${s}\r
room_id:${i}\r
\r
`+JSON.stringify({users:r,kick_reason:t}));})}setCvMcRoomAttr(i,r,n){return new Promise((e,t)=>{this.promisePool[1617]={attrInfo:r,resolve:e,reject:t},this.socket.send(`cmd:1617\r
id:${uuid(32,16)}\r
app_id:${n}\r
room_id:${i}\r
\r
`+JSON.stringify({attr:r}));})}setCvMcRoomUserAttr(i,r,n){return new Promise((e,t)=>{this.promisePool[1623]={userList:r,resolve:e,reject:t},this.socket.send(`cmd:1623\r
id:${uuid(32,16)}\r
app_id:${n}\r
room_id:${i}\r
\r
`+JSON.stringify({users:r}));})}customizeSendMsg(o,a){return new Promise((e,t)=>{this.promisePool[o.cmd]={Json:a,resolve:e,reject:t};var i,r=null;for(i in o)var n=`${i}:${o[i]}\r\n`,r=r?r+n:n;console.log(r);let s=r;a&&(s=r+`\r
`+JSON.stringify(a)),this.socket.send(s);})}DealGroupMessage(e){var t=this.analysis(e);switch(t.cmd=JSON.parse(t.cmd),console.log(t),!t.cmd||6167!=t.cmd&&6107!=t.cmd&&6105!=t.cmd&&6147!=t.cmd&&6113!=t.cmd&&6117!=t.cmd&&6157!=t.cmd&&6121!=t.cmd&&6161!=t.cmd&&6123!=t.cmd&&6125!=t.cmd&&6165!=t.cmd||(this.sendMessage(t.cmd+1),this.getCvMcRoomControl(t)),!t.cmd||7101!=t.cmd&&7103!=t.cmd&&7105!=t.cmd&&7107!=t.cmd&&7109!=t.cmd&&7111!=t.cmd&&7113!=t.cmd&&7115!=t.cmd&&7119!=t.cmd&&7121!=t.cmd&&7123!=t.cmd&&7125!=t.cmd&&7127!=t.cmd||this.getCvMcRoomMessage(t),t.cmd){case 1100:1100==t.cmd&&200!=t.requestData.status&&(this.close(),this.exitCurLoign(t)),this.loginPromisePool.resolve(t);break;case 1303:this.getPushGroupMsg(t);break;case 1103:this.onP2PMag(t);break;case 4101:var i={cmd:t.cmd,groupInfo:t.requestData};this.groupInfo(i);break;case 4103:i={gid:t.requestData.gid,cid:t.requestData.cid,info:JSON.parse(t.requestData.info),inviter:t.requestData.inviter,invitee:t.requestData.invitee,cancel:t.cancel};this.getInviteNotice(i);break;case 4105:var r={gid:t.requestData.gid,cid:t.requestData.cid,info:t.requestData.info?JSON.parse(t.requestData.info):null,inviter:t.requestData.inviter,invitee:t.requestData.invitee,response:t.requestData.response};this.getreplyInviteMsg(r);break;case 4107:this.onReceiveApplyMsg(t.requestData);break;case 4109:this.getApplyGroupNotice(t.requestData);break;case 4111:this.groupDelMemberMsg(t.requestData);break;case 4113:this.memberExitGroupMsg(t.requestData);break;case 4121:this.getHostIdentity(t.requestData);break;case 4129:this.onGroupPower(t);break;case 4131:this.OnchangeUserStatus(t);break;case 4133:this.onRecPowerApplyMsg(t.requestData),this.confirmService(4134);break;case 4201:this.onReceiveGroupMsg(t.requestData),this.confirmService(4102);break;case 4117:this.onGroupAdminer(t.requestData);break;case 9004:this.close(),this.exitCurLoign(t);break;default:if(1100==t.cmd&&200==t.requestData.status||9002==t.cmd)return;r=t.cmd-1;const n=this.promisePool[r];if(!n)return;n.resolve(t),delete this.promisePool[r];}}close(){this.lockReconnect=!0,this._reconnectTimes=25,null!=this.socket&&null!=this.socket&&(this.socket.close(),this.socket=null),this.clearIntelval();}setInterval(e,t){this.timer=setInterval(()=>{this.send(e);},t);}clearIntelval(){null!=this.timer&&(clearInterval(this.timer),this.timer=null);}uuid(e,t){var i,r,n="0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz".split(""),s=[];if(t=t||n.length,e)for(i=0;i<e;i++)s[i]=n[0|Math.random()*t];else for(s[8]=s[13]=s[18]=s[23]="-",s[14]="4",i=0;i<36;i++)s[i]||(r=0|16*Math.random(),s[i]=n[19==i?3&r|8:r]);return s.join("")}}return new e}const CcHttpClient=ccHttpClient,CcWebSocket=websocket;class RTMSession{constructor(e){this.CcHttpClient=new CcHttpClient,this.CcWebSocket=new CcWebSocket,this.serverUrl=e,this.ccServerUrl=null,this.sid=null,this.userInfo=null;}async _login(n,s){return new Promise(async(e,t)=>{let i=await this.CcHttpClient.ulogin(n,this.serverUrl);var r;console.log(i),this.ccServerUrl=i.serverUrlList,!i.data&&200!=i.data.status||(this.userInfo={uid:i.data.data.uid,cid:i.data.data.cid,name:s},this.sid=i.data.data.sid,r=this.ccServerUrl.find(e=>2==e.type),console.log(r),this.CcWebSocket.close(),this.CcWebSocket.connect("wss://"+r.addr),this.CcWebSocket.onopen=async()=>{await this.CcWebSocket.login(this.sid),e(i);});})}async _regCc(e,t,i){var r=await this.CcHttpClient.registerCC({name:e,passwd:"111111",user:i},this.serverUrl);console.log(r);t=t||"cv_conf";if(200==r.status||200==r.status.status||401==r.status||401==r.status.status)return this._login({name:i||md5(e),passwd:"111111",app_id:t},e)}Linker(){}}const authToken=Symbol("authToken"),leadInSocketIo=Symbol("leadInSocketIo");class rtcClient{constructor(){console.log("云视sdk"),this.RTMSession=null,this.rtServerUrl=null,this.RTCRoom=null,this[leadInSocketIo]();}[leadInSocketIo](){const e=document.getElementsByTagName("html");var t="app_socketio-js";let i=document.getElementById(t);i||(i=document.createElement("script"),i.type="text/javascript",i.id=t,i.src="https://cv.263.net/static/js/socket.io.js",e[0].appendChild(i));}SetPath(e){}SetServer(e){this.rtServerUrl=e,console.log("设置服务器地址");}SetDevInfo(e){}async Login(e,t,i){return this.RTMSession=new RTMSession(this.rtServerUrl.ccUrl),await this.RTMSession._login({name:e,passwd:t},e)}Logout(){}async JoinRoom(e,t,i,r,n,s,o,a){let c;return o=0!=o,t&&(this.RTMSession=null,this.RTMSession=new RTMSession(this.rtServerUrl.ccUrl),c=await this.RTMSession._regCc(t,n,s),console.log(c,"222222222")),o?(await this[authToken](),this.RTCRoom=null,this.RTCRoom=new RTCRoom(this.RTMSession),this.RTCRoom._JoinConference(e,i,r,a)):c}async connectMic(e){return this.RTCRoom=null,this.RTCRoom=new RTCRoom(this.RTMSession),this.RTCRoom._connectMic(e,"Web_lianmai")}LeaveRoom(){}async CreateRoom(e){console.log(this.RTMSession.userInfo);var t=await this[authToken]();if(200==t.status)return {roomId:(await createRoom({name:e,compere:this.RTMSession.userInfo.uid})).data.roomid}}DestroyRoom(){}RTCRoom(){}RTMSession(){return this.RTMSession||(this.RTMSession=new RTMSession),this.RTMSession}async[authToken](){return {status:(await getAccessToken(Object.assign(this.RTMSession.userInfo,{sid:this.RTMSession.sid}),this.rtServerUrl.meetUrl)).status}}}window.rt=new rtcClient;

	return rtcClient;

})();
